package ecp.vcs.com.ecpsyncplugin.re_sync.utils;

import android.content.Context;
import android.util.Log;

import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintWriter;

import ecp.vcs.com.ecpsyncplugin.re_sync.networking.AppUtil;
import ecp.vcs.com.ecpsyncplugin.re_sync.storage.ScopedStorage;

public class ErrorLogHelper {

    public static String EXTERNAL_STORAGE_CPM_ROOT = "";

    public static void writeToFileMain(String fileContent, String version, Context context) {
        EXTERNAL_STORAGE_CPM_ROOT= ScopedStorage.getInstance(context).getPath(ScopedStorage.EXTERNAL_STORAGE_SYNC_LOG);
        fileContent= AppUtil.getCurrentDate(AppUtil.DATE_FORMAT)+"\n"+fileContent;
        String directoryName = "" + EXTERNAL_STORAGE_CPM_ROOT + "/" + version + "/ERRORLOG/";
        directoryName += getCurrentDateTime();
        writeToFile("syncLogs.txt", fileContent, directoryName);
    }

    /**
     * Writing content on Text File
     * @param fileName
     * @param fileContent
     * @param directoryName
     */
    public static void writeToFile(final String fileName, final String fileContent, final String directoryName) {
        File dir = new File(directoryName);
        dir.mkdirs();
        File file = new File(dir, fileName);
        try {
            if (!file.exists()) {
                file.createNewFile();
            }
            FileOutputStream f = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(f);
            pw.append("\n").append(fileContent);
            //pw.append("\n---------------------\n");
            pw.flush();
            pw.close();
            f.close();
        } catch (Exception e) {
            e.printStackTrace();
            Log.e("RECPM", "******* File not found. Did you" + " add a WRITE_EXTERNAL_STORAGE permission to the   manifest?");
        }
    }

    /**
     * Get Current Date and Time
     * @return
     */
    private static String getCurrentDateTime() {
        return AppUtil.getCurrentDate(AppUtil.DATE_FORMAT6);
    }
}
