import Flutter
import UIKit
import SSZipArchive
import Alamofire
import SwiftyJSON
import Foundation
import SystemConfiguration
import Foundation
import CryptoSwift
import FMDB
import CommonCrypto // FOR RE ENCRYPT
//import re_sync_insert_code

public class SwiftEcpSyncPlugin: NSObject, FlutterPlugin, FlutterStreamHandler, BarcodeScannerViewControllerDelegate {

    var database: FMDatabase

    let documentsPath = NSURL(fileURLWithPath: NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true)[0])

    func barcodeScannerViewController(_ controller: UIViewController?, didScanBarcodeWithResult result: String?) {
        //print("didScanBarcodeWithResult")
        //resultResend(result)

        //let items:String = result!

        returnItems = ["type": "11","Details": result,"progress": "0"] as! [String : String]
        NotificationCenter.default.post(name: notificationName, object: nil)
    }

    func barcodeScannerViewController(_ controller: UIViewController?, didFailWithErrorCode errorCode: String?) {
        //print("didFailWithErrorCode")
        //
        if(errorCode == "PERMISSION_NOT_GRANTED"){
            returnItems = ["type": "12","Details": "Permission not granted, Please try again","progress": "0"]
        }else{
            returnItems = ["type": "12","Details": errorCode,"progress": "0"] as! [String : String]
        }

        NotificationCenter.default.post(name: notificationName, object: nil)
        //resultResend(errorCode)
    }


    private var eventSink: FlutterEventSink?
    let notificationName = Notification.Name("plugin_Progress")
    private var argumentsde: [AnyHashable : Any] = [:]
    var dict : Dictionary = Dictionary<String,String>()
    var alamofireManager : Alamofire.Session?
    var zipNameFinal:String = ""
    var returnItems = ["type": "dhaval","Details": "dhaval","progress": "45"]
    var hostVC:UIViewController!
    var hashMap = [String : String]()
    var resultResend:FlutterResult!
    var ZipPassword:String = ""
    var logURL:String = ""
    var logMethod:String = ""

    let syncJSON: NSMutableDictionary = NSMutableDictionary()
    let requestJSON: NSMutableDictionary = NSMutableDictionary()

    var syncType = ""
    var password_re_user = ""
    var objBody_auth:JSON!
    var objBody_data:JSON!
    
    var isTransactionSync_RE : Bool = false
    
    var isMasterSync_RE : Bool = false
    
    

    public override init() {
        let configuration = URLSessionConfiguration.default
        configuration.timeoutIntervalForRequest = 1800000
        configuration.timeoutIntervalForResource = 1800000 // seconds
        alamofireManager = Alamofire.Session(configuration: configuration)
        print(documentsPath)
//        database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-HK-Database.db")?.path)
        database = FMDatabase(path: documentsPath.appendingPathComponent("F_Re_CPM")?.path)
    }

    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "ecp_sync_plugin", binaryMessenger: registrar.messenger())
        let instance = SwiftEcpSyncPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)

        let chargingChannel = FlutterEventChannel(name: "ecp_sync_plugin_Progress", binaryMessenger: registrar.messenger())
        //chargingChannel.streamHandler = instance
        chargingChannel.setStreamHandler(instance)

        instance.hostVC = UIApplication.shared.delegate?.window??.rootViewController
    }


    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {

        if let arguments = call.arguments {
            // argumentsde = arguments as! [AnyHashable : Any]
            dict = arguments as! Dictionary<String,String>
        }

        /*'UserName': UserName,
         'fk_EmpGlCode': fk_EmpGlCode,
         'ClientName': ClientName,
         'imei': imei,
         'version': appVersion,
         'uploadMethod': uploadMethod,
         'urlUpload': urlUpload,
         'databaseName': databaseName,
         'packageName': packageName*/

        //result("iOS \(String(describing: args))" + UIDevice.current.systemVersion)
        if(call.method == "syncronizeData"){
            syncJSON.removeAllObjects()
            requestJSON.removeAllObjects()

            self.syncType = "D"
            let UserName : String = dict["UserName"] ?? ""
            let fk_EmpGlCode : String = dict["fk_EmpGlCode"] ?? ""
            let ClientName : String = dict["ClientName"] ?? ""
            let imei : String = dict["imei"] ?? ""
            let version : String = dict["version"] ?? ""
            let uploadMethod : String = dict["uploadMethod"] ?? ""
            logUploadMethod = dict["urlUpload"] ?? ""
            let databaseName : String = dict["databaseName"] ?? ""
            let packageName : String = dict["packageName"] ?? ""
            let dbPassword : String = dict["dbPassword"] ?? ""
            let isDbEncripted : String = dict["isDbEncripted"] ?? ""
            let methodSyncID : String = dict["methodSyncID"] ?? ""
            
            let CustomerId : String = dict["fkCustomerGlCode"] ?? ""
            let DeviceSyncStatus : String = dict["DeviceSyncStatus"] ?? ""
            let CustomerCode : String = dict["CustomerCode"] ?? ""
            let SystemName : String = dict["SystemName"] ?? ""
            let LastSyncDate : String = dict["LastSyncDate"] ?? ""
            let ServerSyncId : String = dict["ServerSyncId"] ?? ""
            
            ZipPassword = dbPassword;
            //databaseName = "BASF-HK-Database"
            logURL = logUploadMethod
            logMethod = methodSyncID
            print("uploadMethod:\(uploadMethod)")
            print("logUploadMethod:\(methodSyncID)")

            //print("UserName:\(String(describing: UserName))")
            //print("fk_EmpGlCode:\(String(describing: fk_EmpGlCode))")
            //print("ClientName:\(String(describing: ClientName))")
            //print("imei:\(String(describing: imei))")
            //print("version:\(String(describing: version))")
            //print("uploadMethod:\(String(describing: uploadMethod))")
            //print("urlUpload:\(String(describing: urlUpload))")
            //print("databaseName:\(String(describing: databaseName))")
            //print("packageName:\(String(describing: packageName))")
            //print("dbPassword:\(String(describing: dbPassword))")
            //print("isDbEncripted:\(String(describing: isDbEncripted))")
            //print("\(String(describing:UserName))")
            returnItems = ["type": "dhaval","Details": "dhaval","progress": "45"]
            NotificationCenter.default.post(name: notificationName, object: nil)

//            if(packageName == "com.ecubix.basflab"){
//                database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-LAB-Database.db")?.path)
//
//                let retval = SyncDataForLAB(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei,uploadMethod:uploadMethod,urlUpload:logUploadMethod,databaseName:databaseName, dbPassword: dbPassword, isDbEncripted: isDbEncripted)
//
//                result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)
//
//            } else {

            if(packageName == "com.ecubix.basflab"){
                database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-LAB-Database.db")?.path)
 //           } else if(packageName == "com.ecubix.iffcocpm"){
            } else if(packageName == "com.vcs.iffcocpm"){
                database = FMDatabase(path: documentsPath.appendingPathComponent("IFFCO_CPM_Database.db")?.path)
            } else if(packageName == "com.ecubix.basfhkre-ret"){
                database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-Retailer-Database.db")?.path)
            } else {
               database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-HK-Database.db")?.path)
              //  database = FMDatabase(path: documentsPath.appendingPathComponent("F_Re_CPM")?.path)
            }
                let retval = SyncData(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei,uploadMethod:uploadMethod,urlUpload:logUploadMethod,databaseName:databaseName, dbPassword: dbPassword, isDbEncripted: isDbEncripted,CustomerId: CustomerId,
                                      DeviceSyncStatus: DeviceSyncStatus,CustomerCode: CustomerCode,SystemName: SystemName,LastSyncDate: LastSyncDate,ServerSyncId: ServerSyncId,packageName: packageName)

                result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)
//            }

        }else if(call.method == "encodeData"){
            let details : String = dict["details"] ?? ""
            let key : String = dict["key"] ?? ""
            let iv : String = dict["iv"] ?? ""

            //let key = "B4V2A1C@S#S$F"
            //let iv = "0000000000000000"
            //let s = "Vcs@1234"
            let enc = try! details.aesEncrypt1(key: key, iv: iv)
            //print(enc)
            result(enc)


        }else if(call.method == "decodeData"){
            let details : String = dict["details"] ?? ""
            let key : String = dict["key"] ?? ""
            let iv : String = dict["iv"] ?? ""

            do{
                let dec = try details.aesDecrypt1(key: key, iv: iv)
                //print("dec:\(dec)")
                //print("\(details == dec)")
                result(dec)
            }catch let error {
                //print("error:\(error)")
                result("error:\(error)")
            }

        }else if(call.method == "scanBarCodes"){


            let isSingleScan : String = dict["isSingleScan"] ?? ""
            let isPlaySound : String = dict["isPlaySound"] ?? ""
            let isOnFlase : String = dict["isOnFlase"] ?? ""
            let themeColor : String = dict["themeColor"] ?? ""
            let isGoogleVision : String = dict["isGoogleVision"] ?? ""
            let nextBtn : String = dict["nextBtn"] ?? ""
            let scanText : String = dict["scanText"] ?? ""


            if(isGoogleVision == "true"){
                let storyBoard = UIStoryboard(name: "Main", bundle: nil)
                //OneDQrCodeControllerViewController
                let mainViewController = storyBoard.instantiateViewController(withIdentifier: "OneDQrCodeViewController") as! OneDQrCodeViewController
                //NaviViewController

                // mainViewController.navigationBarHidden

                mainViewController.delegate = self
                mainViewController.isSingleScan = isSingleScan == "true"
                mainViewController.isPlaySound = isPlaySound == "true"
                mainViewController.isOnFlase = isOnFlase == "true"
                mainViewController.nextBtn = nextBtn
                mainViewController.scanText = scanText
                if(themeColor != ""){
                    mainViewController.themeColor = themeColor
                }
                let navigationController = UINavigationController(rootViewController: mainViewController)

                hostVC.present(navigationController, animated: true, completion: nil)
            }else{
                let storyBoard = UIStoryboard(name: "Main", bundle: nil)

                let mainViewController = storyBoard.instantiateViewController(withIdentifier: "ViewController") as! ViewController
                //NaviViewController

                // mainViewController.navigationBarHidden

                mainViewController.delegate = self
                mainViewController.isSingleScan = isSingleScan == "true"
                mainViewController.isPlaySound = isPlaySound == "true"
                mainViewController.isOnFlase = isOnFlase == "true"
                mainViewController.nextBtn = nextBtn
                mainViewController.scanText = scanText
                if(themeColor != ""){
                    mainViewController.themeColor = themeColor
                }
                let navigationController = UINavigationController(rootViewController: mainViewController)

                hostVC.present(navigationController, animated: true, completion: nil)
            }


        }else if(call.method == "UniqueNumber"){
            let retValue = getDeviceUniqueNo()
            result(retValue)
        }else if(call.method == "syncronizeDataFile"){
            syncJSON.removeAllObjects()
            requestJSON.removeAllObjects()

            self.syncType = "F"
            // Sagar File Sync ################################################

            let UserName : String = dict["UserName"] ?? ""
            let fk_EmpGlCode : String = dict["fk_EmpGlCode"] ?? ""
            let ClientName : String = dict["ClientName"] ?? ""
            let imei : String = dict["imei"] ?? ""
            let version : String = dict["version"] ?? ""
            let uploadMethod : String = dict["uploadMethod"] ?? ""
            logUploadMethod = dict["logUploadMethod"] ?? ""
            let urlUpload : String = dict["urlUpload"] ?? ""
            let databaseName : String = dict["databaseName"] ?? ""
            let packageName : String = dict["packageName"] ?? ""
            let dbPassword : String = dict["dbPassword"] ?? ""
            let isDbEncripted : String = dict["isDbEncripted"] ?? ""
            let methodSyncID : String = dict["methodSyncID"] ?? ""
            
            let CustomerId : String = dict["fkCustomerGlCode"] ?? ""
            let DeviceSyncStatus : String = dict["DeviceSyncStatus"] ?? ""
            let CustomerCode : String = dict["CustomerCode"] ?? ""
            let SystemName : String = dict["SystemName"] ?? ""
            let LastSyncDate : String = dict["LastSyncDate"] ?? ""
            let ServerSyncId : String = dict["ServerSyncId"] ?? ""
            
            //let LastSyncDate : String = dict["LastSyncDate"] ?? ""
            
            /*var objBody = JSON();
            objBody["user_id"] = userID
            objBody["password"] = appVersionCode
            objBody["version"] = version
            objBody["version_code"] = appVersionCode
            objBody["imei"] = imei
            objBody["country_id"] = countryID*/
            
            

            
            
           
            ZipPassword = dbPassword;
            //print("UserName:\(String(describing: UserName))")
            //print("fk_EmpGlCode:\(String(describing: fk_EmpGlCode))")
            //print("ClientName:\(String(describing: ClientName))")
            //print("imei:\(String(describing: imei))")
            //print("version:\(String(describing: version))")
            //print("uploadMethod:\(String(describing: uploadMethod))")
            //print("logUploadMethod:\(String(describing: logUploadMethod))")
            //print("urlUpload:\(String(describing: urlUpload))")
            //print("databaseName:\(String(describing: databaseName))")
            //print("packageName:\(String(describing: packageName))")

            logURL = urlUpload
            logMethod = methodSyncID

            returnItems = ["type": "dhaval","Details": "dhaval","progress": "45"]
            NotificationCenter.default.post(name: notificationName, object: nil)

//            if(packageName == "com.ecubix.basflab"){
//                database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-LAB-Database.db")?.path)
//
//                let retval = FileSyncDataForLAB(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei, uploadMethod:uploadMethod, logUploadMethod:logUploadMethod, urlUpload:urlUpload, databaseName:databaseName,isDbEncripted:isDbEncripted)
//
//                result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)
//
//            } else {
            if(packageName == "com.ecubix.basflab"){
                database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-LAB-Database.db")?.path)
//             } else if(packageName == "com.ecubix.iffcocpm"){
            } else if(packageName == "com.vcs.iffcocpm"){
                database = FMDatabase(path: documentsPath.appendingPathComponent("IFFCO_CPM_Database.db")?.path)
            } else if(packageName == "com.ecubix.basfhkre-ret"){
                database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-Retailer-Database.db")?.path)
            } else if(packageName == "com.ecubix.recpm" || packageName == "com.vcs.recpm"){
                database = FMDatabase(path: documentsPath.appendingPathComponent("F_Re_CPM")?.path)
            } else {
               database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-HK-Database.db")?.path)
//                database = FMDatabase(path: documentsPath.appendingPathComponent("F_Re_CPM")?.path)
            }
            /*if(packageName == "com.ecubix.recpm"){
                let retval = FileSyncDataRe(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei, uploadMethod:uploadMethod, logUploadMethod:logUploadMethod, urlUpload:urlUpload, databaseName:databaseName,isDbEncripted:isDbEncripted,CustomerId: CustomerId,
                                            DeviceSyncStatus: DeviceSyncStatus,CustomerCode: CustomerCode,SystemName: SystemName,LastSyncDate: LastSyncDate,ServerSyncId: ServerSyncId,user_id: "", country_id: "", version_code: appVersionCode, sync_date: LastSyncDate,sync_type:"G")
                
                result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)
            } else {*/
                let retval = FileSyncData(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei, uploadMethod:uploadMethod, logUploadMethod:logUploadMethod, urlUpload:urlUpload, databaseName:databaseName,isDbEncripted:isDbEncripted,CustomerId: CustomerId,
                                          DeviceSyncStatus: DeviceSyncStatus,CustomerCode: CustomerCode,SystemName: SystemName,LastSyncDate: LastSyncDate,ServerSyncId: ServerSyncId)
                
                result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)
            //}
//            }
        }else if(call.method == "RE_CPM_Sync_Start"){
            syncJSON.removeAllObjects()
            requestJSON.removeAllObjects()

            self.syncType = "F"
            // Sagar File Sync ################################################

            let UserName : String = dict["UserName"] ?? ""
            let fk_EmpGlCode : String = dict["userID"] ?? ""
            let ClientName : String = dict["ClientName"] ?? ""
            let imei : String = dict["imei"] ?? ""
            let version : String = dict["appVersion"] ?? ""
            let uploadMethod : String = dict["uploadMethod"] ?? ""
            logUploadMethod = dict["logUploadMethod"] ?? ""
            let urlUpload : String = dict["urlUpload"] ?? ""
            let databaseName : String = dict["databaseName"] ?? ""
            let packageName : String = dict["packageName"] ?? ""
            let dbPassword : String = dict["dbPassword"] ?? ""
            let isDbEncripted : String = dict["isDbEncripted"] ?? ""
            let methodSyncID : String = dict["methodSyncID"] ?? ""
            
            let CustomerId : String = dict["fkCustomerGlCode"] ?? ""
            let DeviceSyncStatus : String = dict["DeviceSyncStatus"] ?? ""
            let CustomerCode : String = dict["CustomerCode"] ?? ""
            let SystemName : String = dict["SystemName"] ?? ""
            let LastSyncDate : String = dict["LastSyncDate"] ?? ""
            let ServerSyncId : String = dict["ServerSyncId"] ?? ""
            let userID : String = dict["userID"] ?? ""
            let countryID : String = dict["countryID"] ?? ""
            let appVersionCode : String = dict["appVersionCode"] ?? ""
            let customer_level : String = dict["customer_level"] ?? ""
            let role_code : String = dict["role_code"] ?? ""
            let isTransactionSync : String = dict["isTransactionSync"] ?? ""
            let isPointCalculationSync : String = dict["isPointCalculationSync"] ?? ""
            let isMasterSync : String = dict["isMasterSync"] ?? ""
            isMasterSync_RE = isMasterSync == "true" ? true : false
            isTransactionSync_RE = isTransactionSync == "true" ? true : false
            let byPassSSL : String = dict["byPassSSL"] ?? ""
            let byPassSSL_bool = byPassSSL == "true" ? true : false
            
            password_re_user = dict["password"] ?? ""
           
            ZipPassword = dbPassword;
            print("UserName:\(String(describing: UserName))")
            print("userID:\(String(describing: userID))")
            print("fk_EmpGlCode:\(String(describing: fk_EmpGlCode))")
            print("ClientName:\(String(describing: ClientName))")
            print("imei:\(String(describing: imei))")
            print("version:\(String(describing: version))")
            print("uploadMethod:\(String(describing: uploadMethod))")
            print("logUploadMethod:\(String(describing: logUploadMethod))")
            print("urlUpload:\(String(describing: urlUpload))")
            print("databaseName:\(String(describing: databaseName))")
            print("packageName:\(String(describing: packageName))")
            print("password_re_user======:\(String(describing: password_re_user))")
            print("password_re_user=====:\(password_re_user)")
            
            print("********************************")
            print("********************************")
            print("RE_CPM_Sync_Start")
            print("********************************")
            print("********************************")
            
            
            objBody_auth = JSON(["user_id": userID,
                                "password": password_re_user,
                                "version": version,
                                "version_code": appVersionCode,
                                "imei": imei,
                                "country_id": countryID])

            logURL = urlUpload
            logMethod = methodSyncID

            returnItems = ["type": "dhaval","Details": "dhaval","progress": "45"]
            NotificationCenter.default.post(name: notificationName, object: nil)

            //if(!database.open()){
            database = FMDatabase(path: documentsPath.appendingPathComponent("F_Re_CPM")?.path)
            //}
            
            
            if(isTransactionSync == "true"){
                self.syncType = "T"
            }else{
                if(isMasterSync == "true"){
                    self.syncType = "G"
                }else if (isPointCalculationSync == "true"){
                    self.syncType = "P"
                }
            }
            
            
            
            let retval = FileSyncDataRe(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei, uploadMethod:uploadMethod, logUploadMethod:logUploadMethod, urlUpload:urlUpload, databaseName:databaseName,isDbEncripted:isDbEncripted,CustomerId: CustomerId,
                                        DeviceSyncStatus: DeviceSyncStatus,CustomerCode: CustomerCode,SystemName: SystemName,LastSyncDate: LastSyncDate,ServerSyncId: ServerSyncId, user_id: userID, country_id:countryID, version_code:appVersionCode,sync_date:LastSyncDate,sync_type:syncType,customer_level:customer_level,role_code:role_code, byPassSSL: byPassSSL_bool)
            
            result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)

        }else if(call.method == "getTimeFromUTC"){
            let date : String = dict["date"] ?? ""
            let formatType : String = dict["format"] ?? ""

            let result1 = date.toServerDateUTC().toMyFormatDate(format: formatType)
            result(result1)
        }else if(call.method == "checkInternet"){
            let result1 = Reachability.isConnectedToNetwork()
            if(result1){
                //print("true")
                result("true")
            }else{
                //print("false")
                result("false")
            }
            //result(result1)
        }else if(call.method == "openDateSettings"){
            /*if #available(iOS 10.0, *) {
                UIApplication.shared.open(URL(string: UIApplication.UIApplicationOpenSettingsURLString)!, options: [:], completionHandler: nil)
                result("true")
            } else {
                // Fallback on earlier versions
                result("false")
            }*/

        }else if(call.method == "checkBarCode"){
            let code : String = dict["code"] ?? ""
            var stringValue : String = code
            //codeScanned = stringValue



            //print("stringValue code: \(stringValue)")
            var isGoing = false

            if(stringValue.count <= 14){
                isGoing = true
            }

            if(isGoing == false){
                let swiftyString = stringValue.replacingOccurrences(of: "\"", with: "")
                //print("swiftyString:\(swiftyString)")
                let trimmedString = swiftyString.trimmingCharacters(in: .whitespaces)
                //print("trimmedString:\(trimmedString)")

                //let group = trimmedString.components(separatedBy: "29")
                //print(group)

                var ites:Int = 0
                var finalStr:String = ""
                var groupSaprator:String = ""
                while(ites < trimmedString.count){
                    let firstChar = Array(trimmedString)[ites]
                    //print("char:\(firstChar)")
                    //let asc = trimmedString.index(trimmedString.startIndex, offsetBy: ites)
                    //print(asc)
                    let charAscii = firstChar.ascii
                    if(charAscii != 29){
                        finalStr = finalStr + "\(firstChar)"
                    }else{
                        finalStr = finalStr + "\(firstChar)"
                        groupSaprator = "\(firstChar)"
                    }

                    ites = ites + 1
                }

                if(!finalStr.isEmpty){
                    if(!groupSaprator.isEmpty){
                        let group = finalStr.components(separatedBy: groupSaprator)
                        //print(group)
                        //print(group[0])
                        //print(group[1])

                        var str1:String = group[group.count - 1]
                        //print(str1)
                        if(!str1.isEmpty){
                            //let str2 = str1.removeAtIndex(enhance(str1.startIndex, 1))
                            //let ffStr = str2.removeAtIndex(enhance(str2.startIndex, 1))

                            if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                                str1.remove(at: index)
                                //print(str1) // prints "Hello I must be going"
                            }

                            if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                                str1.remove(at: index)
                                //print(str1) // prints "Hello I must be going"
                            }

                            stringValue = str1
                            //print("stringValue : \(stringValue)")
                        }
                    }
                }
            }

            result(stringValue)
        }else if(call.method == "checkBarCode16"){
          let code : String = dict["code"] ?? ""
          var stringValue : String = code
          //codeScanned = stringValue



          //print("stringValue code: \(stringValue)")
          var isGoing = false

          if(stringValue.count <= 16){
              isGoing = true
          }

          if(isGoing == false){
              let swiftyString = stringValue.replacingOccurrences(of: "\"", with: "")
              //print("swiftyString:\(swiftyString)")
              let trimmedString = swiftyString.trimmingCharacters(in: .whitespaces)
              //print("trimmedString:\(trimmedString)")

              //let group = trimmedString.components(separatedBy: "29")
              //print(group)

              var ites:Int = 0
              var finalStr:String = ""
              var groupSaprator:String = ""
              while(ites < trimmedString.count){
                  let firstChar = Array(trimmedString)[ites]
                  //print("char:\(firstChar)")
                  //let asc = trimmedString.index(trimmedString.startIndex, offsetBy: ites)
                  //print(asc)
                  let charAscii = firstChar.ascii
                  if(charAscii != 29){
                      finalStr = finalStr + "\(firstChar)"
                  }else{
                      finalStr = finalStr + "\(firstChar)"
                      groupSaprator = "\(firstChar)"
                  }

                  ites = ites + 1
              }

              if(!finalStr.isEmpty){
                  if(!groupSaprator.isEmpty){
                      let group = finalStr.components(separatedBy: groupSaprator)
                      //print(group)
                      //print(group[0])
                      //print(group[1])

                      var str1:String = group[group.count - 1]
                      //print(str1)
                      if(!str1.isEmpty){
                          //let str2 = str1.removeAtIndex(enhance(str1.startIndex, 1))
                          //let ffStr = str2.removeAtIndex(enhance(str2.startIndex, 1))

                          if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                              str1.remove(at: index)
                              //print(str1) // prints "Hello I must be going"
                          }

                          if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                              str1.remove(at: index)
                              //print(str1) // prints "Hello I must be going"
                          }

                          stringValue = str1
                          //print("stringValue : \(stringValue)")
                      }
                  }
              }
          }

          result(stringValue)
      } else if(call.method == "RE_Encryption"){
            let details : String = dict["details"] ?? ""
            let key : String = dict["key"] ?? ""
            let iv : String = dict["iv"] ?? ""

            do {
                let aes = try AES2(keyString: key)
                let encryptedData: Data = try aes.encrypt(iv)
                let encryptedMsgStr : String = encryptedData.base64EncodedString()
                result(encryptedMsgStr)
            } catch {
                print("Something went wrong: \(error)")
            }
        } else if(call.method == "RE_Description"){
            let details : String = dict["details"] ?? ""
            let key : String = dict["key"] ?? ""
            let iv : String = dict["iv"] ?? ""

            do{
                let dec = try details.aesDecrypt2(key: key, iv: iv)
                result(dec)
            }catch let error {

                result("error:\(error)")
            }

        } else{
            result("iOS syncronizeData not found" + UIDevice.current.systemVersion)
        }
    }


    
    
    //DHAVALP

    //File Sync Start
    var SyncId: Int = 0
    var userName: String = "", fk_EmpGlCode: String = "", ClientName: String = "", version: String = "", imei: String = "", uploadMethod: String = "", logUploadMethod: String = "", urlUpload: String = "",CustomerId: String = "",
    DeviceSyncStatus: String = "",CustomerCode:String = "",SystemName:String = "",LastSyncDate:String = "",ServerSyncId:String = "",packageName:String = ""

    func FileSyncData(userName:String, fk_EmpGlCode:String, ClientName:String, version:String, imei:String, uploadMethod:String, logUploadMethod:String, urlUpload:String, databaseName:String,isDbEncripted:String
                      ,CustomerId:String,DeviceSyncStatus:String,CustomerCode:String,SystemName:String,LastSyncDate:String,ServerSyncId:String)->String{

        //xxx
        requestJSON.setValue(Date().getJsonLogTime(), forKey: "SYNC_START")

        self.userName=userName;
        self.fk_EmpGlCode=fk_EmpGlCode;
        self.ClientName=ClientName;
        self.version=version;
        self.imei=imei;
        self.uploadMethod=uploadMethod;
        self.logUploadMethod=logUploadMethod;
        self.urlUpload=urlUpload;
    
        
        self.CustomerId=CustomerId;
        self.DeviceSyncStatus=DeviceSyncStatus
        self.CustomerCode=CustomerCode;
        self.SystemName=SystemName;
        self.LastSyncDate=LastSyncDate;
        self.ServerSyncId=ServerSyncId;

        writeLog(key: "FB_SYNC_START", value: "")
        updateProgress(type: 1, message: "progress", min: 1, max: 7)

        var isGoahead:Bool = true
        var isGoaheadMessage:String = ""

        let date = Date()
        let calendar = Calendar.current

        let year = calendar.component(.year, from: date)
        let month = calendar.component(.month, from: date)
        let day = calendar.component(.day, from: date)

        let hour = calendar.component(.hour, from: date)
        let minute = calendar.component(.minute, from: date)
        let second = calendar.component(.second, from: date)

        let fileManager = FileManager.default

        let filePathSyncBackUp = documentsPath.appendingPathComponent("SyncBackup")
        let filePathSyncDownload = documentsPath.appendingPathComponent("SyncDownload")

        let dateString = String(format: "%02ld%02ld%ld_%02ld%02ld%02ld", day, month, year, hour, minute, second)

        //let fName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(version)"
        let fName = "\(dateString)_\(version)"
        let fileMainDir = filePathSyncBackUp?.appendingPathComponent("\(day)/\(fName)")
        let zipName = "\(fName).zip"
        let filePathSyncDownloadZip = filePathSyncDownload!.appendingPathComponent(fName)
        let fileMainDirZip = filePathSyncBackUp?.appendingPathComponent("\(day)/\(zipName)")

        let packageName : String = dict["packageName"] ?? ""
        self.packageName = packageName

        //var dirLS, dirLMA, dirLMR, dirLD, dirLSD, dirLCD, dirLCDPD : NSURL
        //let dirCDPD, dirCRPD, dirCCSD, dirCCSDR, dirCSD, dirCPM : URL

        /*if(packageName == "com.ecubix.basflab"){
            dirLS = (fileMainDir?.appendingPathComponent("LS"))! as NSURL
            dirLMA = (fileMainDir?.appendingPathComponent("LMA"))! as NSURL
            dirLMR = (fileMainDir?.appendingPathComponent("LMR"))! as NSURL
            dirLD = (fileMainDir?.appendingPathComponent("LD"))! as NSURL
            dirLSD = (fileMainDir?.appendingPathComponent("LSD"))! as NSURL
            dirLCD = (fileMainDir?.appendingPathComponent("LCD"))! as NSURL
            dirLCDPD = (fileMainDir?.appendingPathComponent("LCDPD"))! as NSURL
        } else {
            dirCDPD = (fileMainDir?.appendingPathComponent("CCDPD"))!
            dirCRPD = (fileMainDir?.appendingPathComponent("CCRPD"))!
            dirCCSD = (fileMainDir?.appendingPathComponent("CCSD"))!
            dirCCSDR = (fileMainDir?.appendingPathComponent("CCSDR"))!
            dirCSD = (fileMainDir?.appendingPathComponent("CPM_Sticker_Details"))!
            dirCPM = (fileMainDir?.appendingPathComponent("CPM"))!
        }*/

        // HK
        let dirCDPD = fileMainDir?.appendingPathComponent("CCDPD")
        let dirCRPD = fileMainDir?.appendingPathComponent("CCRPD")
        let dirCCSD = fileMainDir?.appendingPathComponent("CCSD")
        let dirCCSDR = fileMainDir?.appendingPathComponent("CCSDR")
        let dirCSD = fileMainDir?.appendingPathComponent("CPM_Sticker_Details")
        let dirCPM = fileMainDir?.appendingPathComponent("CPM")
        let dirCGR = fileMainDir?.appendingPathComponent("CGR")

        // LAB

        let dirLS = fileMainDir?.appendingPathComponent("LS")
        let dirLMA = fileMainDir?.appendingPathComponent("LMA")
        let dirLMR = fileMainDir?.appendingPathComponent("LMR")
        let dirLD = fileMainDir?.appendingPathComponent("LD")
        let dirLSD = fileMainDir?.appendingPathComponent("LSD")
        let dirLCD = fileMainDir?.appendingPathComponent("LCD")
        let dirLCDPD = fileMainDir?.appendingPathComponent("LCDPD")
        
        // IFFCO CPM
        let dir_CDPD = fileMainDir?.appendingPathComponent("CCDPD")
        let dir_CRPD = fileMainDir?.appendingPathComponent("CCRPD")

        let dir_CSSD = fileMainDir?.appendingPathComponent("CPM_SKU_STICKER_DETAILS")
        let dir_CPM = fileMainDir?.appendingPathComponent("CPM")
        let dir_CSD = fileMainDir?.appendingPathComponent("CPM_STICKER_DETAILS")

        if(!deleteDir(path: filePathSyncBackUp! as NSURL)){
            isGoahead = false;
            isGoaheadMessage = "error:101";
        }

        DispatchQueue.global(qos: .background).async {

            self.deleteDirNew(path: filePathSyncDownload! as NSURL)
            self.createDir(path: filePathSyncBackUp! as NSURL)
            self.createDir(path: filePathSyncDownload! as NSURL)
            self.createDir(path: fileMainDir! as NSURL)

            if(packageName == "com.ecubix.basflab"){
                self.createDir(path: dirLS! as NSURL)
                self.createDir(path: dirLMA! as NSURL)
                self.createDir(path: dirLMR! as NSURL)
                self.createDir(path: dirLD! as NSURL)
                self.createDir(path: dirLSD! as NSURL)
                self.createDir(path: dirLCD! as NSURL)
                self.createDir(path: dirLCDPD! as NSURL)

                let fileLoginDetails$_1 = "LoginDetails$_1.txt";
                //let fileCPM_Customer_Dispatch$_1 = "CPM_Customer_Dispatch$_1.txt";
                //let fileCPM_Customer_Dispatch_Product_Details$_1 = "CPM_Customer_Dispatch_Product_Details$_1.txt";
                //let fileCPM_Customer_Receive$_1 = "CPM_Customer_Receive$_1.txt";
                //let fileCPM_Customer_Receive_Product_Details$_1 = "CPM_Customer_Receive_Product_Details$_1.txt";

                /*DispatchQueue.main.async  {

                 }*/

                let jsonLoginDetails = self.getJsonFromTable(database: self.database, tableName: "LoginDetails")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginDetails$_1, sBody: "\(jsonLoginDetails)")

                sleep(2)
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 7, max: 14)
                }
                //let jsonCPM_Customer_Dispatch = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Dispatch")
                //self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Dispatch$_1, sBody: "\(jsonCPM_Customer_Dispatch)")


                //DispatchQueue.main.async  {
                //    self.updateProgress(type: 1, message: "progress", min: 10, max: 12)
                //}
                //sleep(2)
                //let jsonCPM_Customer_Receive = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Receive")
                //self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Receive$_1, sBody: "\(jsonCPM_Customer_Receive)")


                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 12, max: 15)
                }
                sleep(2)
                self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_STORE, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLS?.path)!)


                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 14, max: 16)
                }
                sleep(2)
                self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_MATERIAL_ALLOCATION, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLMA?.path)!)


                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 16, max: 17)
                }
                sleep(2)
                self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_MATERIAL_RETURN, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLMR?.path)!)

                sleep(2)

                self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_DISPOSAL, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLD?.path)!)

                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 17, max: 19)
                }
                sleep(2)
                self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_CUSTOMER_DISPATCH, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLCD?.path)!)

                sleep(2)
                self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_CUSTOMER_DISPATCH_PRODUCT_DETAILS, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLCDPD?.path)!)

                sleep(2)
                self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_STICKER_DETAILS, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLSD?.path)!)

                sleep(2)
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 19, max: 20)
                }
//             } else if(packageName == "com.ecubix.iffcocpm"){
            } else if(packageName == "com.vcs.iffcocpm"){
                self.createDir(path: dir_CDPD! as NSURL)
                self.createDir(path: dir_CRPD! as NSURL)
                //self.createDir(path: dirCCSD as! NSURL)
                //self.createDir(path: dirCCSDR as! NSURL)
                self.createDir(path: dir_CSSD! as NSURL)
                self.createDir(path: dir_CPM! as NSURL)
                self.createDir(path: dir_CSD! as NSURL)
                
                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "EXPORT_FILE_START")
                self.syncJSON.setValue("---Export Database Start---", forKey: "1")
                
                let fileLoginDetails$_1 = "LOGIN_DETAILS$_1.txt";
                let fileCPM_Customer_Dispatch$_1 = "CPM_CUSTOMER_DISPATCH$_1.txt";
                //let fileCPM_Customer_Dispatch_Product_Details$_1 = "CPM_Customer_Dispatch_Product_Details$_1.txt";
                let fileCPM_Customer_Receive$_1 = "CPM_CUSTOMER_STICKER_BLOCK$_1.txt";
                let fileCPM_Customer_Sticker_Scrap$_1 = "CPM_CUSTOMER_STICKER_BLOCK_REMOVE$_1.txt";
                //let fileCPM_Customer_Sticker_Consume$_1 = "CPM_Customer_Sticker_Consume$_1.txt";
                let fileLoginFailAttempt_Details$_1 = "LOGIN_FAIL_ATTEMPT_DETAILS$_1.txt";
                let fileLoginFormDetails$_1 = "LOGIN_FORM_DETAILS$_1.txt";
                //let fileCPM_Customer_Receive_Product_Details$_1 = "CPM_Customer_Receive_Product_Details$_1.txt";
                
                /*DispatchQueue.main.async  {
                 
                 }*/
                
                let jsonLoginDetails = self.getJsonFromTableIFFCO(database: self.database, tableName: "LOGIN_DETAILS")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginDetails$_1, sBody: "\(jsonLoginDetails)")
                
                sleep(2)
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 7, max: 10)
                }
                let jsonCPM_Customer_Dispatch = self.getJsonFromTableIFFCO(database: self.database, tableName: "CPM_CUSTOMER_DISPATCH")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Dispatch$_1, sBody: "\(jsonCPM_Customer_Dispatch)")
                
                
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 10, max: 12)
                }
                sleep(2)
                let jsonCPM_Customer_Receive = self.getJsonFromTableIFFCO(database: self.database, tableName: "CPM_CUSTOMER_STICKER_BLOCK")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Receive$_1, sBody: "\(jsonCPM_Customer_Receive)")
                
                sleep(2)
                let jsonCPM_Customer_Sticker_Scrap = self.getJsonFromTableIFFCO(database: self.database, tableName: "CPM_CUSTOMER_STICKER_BLOCK_REMOVE")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Sticker_Scrap$_1, sBody: "\(jsonCPM_Customer_Sticker_Scrap)")
                
                //                           sleep(2)
                //                           let jsonCPM_Customer_Sticker_Consume = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Sticker_Consume")
                //                           self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Sticker_Consume$_1, sBody: "\(jsonCPM_Customer_Sticker_Consume)")
                
                sleep(2)
                let jsonLoginFailAttempt_Details = self.getJsonFromTableIFFCO(database: self.database, tableName: "LOGIN_FAIL_ATTEMPT_DETAILS")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginFailAttempt_Details$_1, sBody: "\(jsonLoginFailAttempt_Details)")
                
                sleep(2)
                let jsonLoginFormDetails = self.getJsonFromTableIFFCO(database: self.database, tableName: "LOGIN_FORM_DETAILS")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginFormDetails$_1, sBody: "\(jsonLoginFormDetails)")
                
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 12, max: 14)
                }
                sleep(2)
                self.writeTransactionTablesToFileIFFCO(tableName: "CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dir_CDPD!.path))
                
                
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 15, max: 17)
                }
                sleep(2)
                self.writeTransactionTablesToFileIFFCO(tableName: "CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dir_CRPD!.path))
                
                //                           sleep(2)
                //                           self.writeTransactionTablesToFile(tableName: "CPM_Customer_Sticker_Damage", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCCSD!.path))
                //
                //                           sleep(2)
                //
                //                           self.writeTransactionTablesToFile(tableName: "CPM_Customer_Sticker_Damage_Remove", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCCSDR!.path))
                
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 17, max: 19)
                }
                sleep(2)
                self.writeTransactionTablesToFileIFFCO(tableName: "CPM_SKU_STICKER_DETAILS", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dir_CSSD!.path))
                
                sleep(2)
                self.writeTransactionTablesToFileIFFCO(tableName: "CPM_PALLET_MST", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dir_CPM!.path))
                
                sleep(2)
                self.writeTransactionTablesToFileIFFCO(tableName: "CPM_STICKER_DETAILS", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dir_CSD!.path))
                
                sleep(2)
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 19, max: 20)
                }
            } else if(packageName == "com.ecubix.basfhkre-ret"){
                self.createDir(path: dirCDPD! as NSURL)
                self.createDir(path: dirCRPD! as NSURL)
                self.createDir(path: dirCCSD! as NSURL)
                self.createDir(path: dirCCSDR! as NSURL)
                self.createDir(path: dirCSD! as NSURL)
                self.createDir(path: dirCPM! as NSURL)
                self.createDir(path: dirCGR! as NSURL)

                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "EXPORT_FILE_START")
                self.syncJSON.setValue("---Export Database Start---", forKey: "1")

                let fileLoginDetails$_1 = "LoginDetails$_1.txt";
                let fileCPM_Customer_Dispatch$_1 = "CPM_Customer_Dispatch$_1.txt";
                //let fileCPM_Customer_Dispatch_Product_Details$_1 = "CPM_Customer_Dispatch_Product_Details$_1.txt";
                let fileCPM_Customer_Receive$_1 = "CPM_Customer_Receive$_1.txt";
                let fileCPM_Customer_Sticker_Scrap$_1 = "CPM_Customer_Sticker_Scrap$_1.txt";
                let fileCPM_Customer_Sticker_Consume$_1 = "CPM_Customer_Sticker_Consume$_1.txt";
                let fileLoginFailAttempt_Details$_1 = "LoginFailAttempt_Details$_1.txt";
                let fileLoginFormDetails$_1 = "LoginFormDetails$_1.txt";
                //let fileCPM_Customer_Receive_Product_Details$_1 = "CPM_Customer_Receive_Product_Details$_1.txt";

                /*DispatchQueue.main.async  {

                 }*/

                let jsonLoginDetails = self.getJsonFromTable(database: self.database, tableName: "LoginDetails")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginDetails$_1, sBody: "\(jsonLoginDetails)")

                sleep(2)
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 7, max: 10)
                }
                let jsonCPM_Customer_Dispatch = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Dispatch")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Dispatch$_1, sBody: "\(jsonCPM_Customer_Dispatch)")


                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 10, max: 12)
                }
                sleep(2)
                let jsonCPM_Customer_Receive = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Receive")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Receive$_1, sBody: "\(jsonCPM_Customer_Receive)")

                sleep(2)
                let jsonCPM_Customer_Sticker_Scrap = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Sticker_Scrap")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Sticker_Scrap$_1, sBody: "\(jsonCPM_Customer_Sticker_Scrap)")

                sleep(2)
                let jsonCPM_Customer_Sticker_Consume = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Sticker_Consume")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Sticker_Consume$_1, sBody: "\(jsonCPM_Customer_Sticker_Consume)")

                sleep(2)
                let jsonLoginFailAttempt_Details = self.getJsonFromTable(database: self.database, tableName: "LoginFailAttempt_Details")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginFailAttempt_Details$_1, sBody: "\(jsonLoginFailAttempt_Details)")

                sleep(2)
                let jsonLoginFormDetails = self.getJsonFromTable(database: self.database, tableName: "LoginFormDetails")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginFormDetails$_1, sBody: "\(jsonLoginFormDetails)")

                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 12, max: 14)
                }
                sleep(2)
                self.writeTransactionTablesToFile(tableName: "CPM_Customer_Dispatch_Product_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCDPD!.path))


                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 15, max: 17)
                }
                sleep(2)
                self.writeTransactionTablesToFile(tableName: "CPM_Customer_Receive_Product_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCRPD!.path))

                sleep(2)
                self.writeTransactionTablesToFile(tableName: "CPM_Customer_Sticker_Damage", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCCSD!.path))

                sleep(2)

                self.writeTransactionTablesToFile(tableName: "CPM_Customer_Sticker_Damage_Remove", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCCSDR!.path))

                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 17, max: 19)
                }
                sleep(2)
                self.writeTransactionTablesToFile(tableName: "CPM_Sticker_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCSD!.path))

                sleep(2)
                self.writeTransactionTablesToFile(tableName: "CPM_Pallet_Mst", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCPM!.path))
                
                sleep(2)
                self.writeTransactionTablesToFile(tableName: "CPM_General_Receive", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCGR!.path))

                sleep(2)
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 19, max: 20)
                }
            }  else {
                self.createDir(path: dirCDPD! as NSURL)
                self.createDir(path: dirCRPD! as NSURL)
                self.createDir(path: dirCCSD! as NSURL)
                self.createDir(path: dirCCSDR! as NSURL)
                self.createDir(path: dirCSD! as NSURL)
                self.createDir(path: dirCPM! as NSURL)

                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "EXPORT_FILE_START")
                self.syncJSON.setValue("---Export Database Start---", forKey: "1")

                let fileLoginDetails$_1 = "LoginDetails$_1.txt";
                let fileCPM_Customer_Dispatch$_1 = "CPM_Customer_Dispatch$_1.txt";
                //let fileCPM_Customer_Dispatch_Product_Details$_1 = "CPM_Customer_Dispatch_Product_Details$_1.txt";
                let fileCPM_Customer_Receive$_1 = "CPM_Customer_Receive$_1.txt";
                let fileCPM_Customer_Sticker_Scrap$_1 = "CPM_Customer_Sticker_Scrap$_1.txt";
                let fileCPM_Customer_Sticker_Consume$_1 = "CPM_Customer_Sticker_Consume$_1.txt";
                let fileLoginFailAttempt_Details$_1 = "LoginFailAttempt_Details$_1.txt";
                let fileLoginFormDetails$_1 = "LoginFormDetails$_1.txt";
                //let fileCPM_Customer_Receive_Product_Details$_1 = "CPM_Customer_Receive_Product_Details$_1.txt";

                /*DispatchQueue.main.async  {

                 }*/

                let jsonLoginDetails = self.getJsonFromTable(database: self.database, tableName: "LoginDetails")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginDetails$_1, sBody: "\(jsonLoginDetails)")

                sleep(2)
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 7, max: 10)
                }
                let jsonCPM_Customer_Dispatch = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Dispatch")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Dispatch$_1, sBody: "\(jsonCPM_Customer_Dispatch)")


                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 10, max: 12)
                }
                sleep(2)
                let jsonCPM_Customer_Receive = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Receive")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Receive$_1, sBody: "\(jsonCPM_Customer_Receive)")

                sleep(2)
                let jsonCPM_Customer_Sticker_Scrap = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Sticker_Scrap")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Sticker_Scrap$_1, sBody: "\(jsonCPM_Customer_Sticker_Scrap)")

                sleep(2)
                let jsonCPM_Customer_Sticker_Consume = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Sticker_Consume")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Sticker_Consume$_1, sBody: "\(jsonCPM_Customer_Sticker_Consume)")

                sleep(2)
                let jsonLoginFailAttempt_Details = self.getJsonFromTable(database: self.database, tableName: "LoginFailAttempt_Details")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginFailAttempt_Details$_1, sBody: "\(jsonLoginFailAttempt_Details)")

                sleep(2)
                let jsonLoginFormDetails = self.getJsonFromTable(database: self.database, tableName: "LoginFormDetails")
                self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginFormDetails$_1, sBody: "\(jsonLoginFormDetails)")

                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 12, max: 14)
                }
                sleep(2)
                self.writeTransactionTablesToFile(tableName: "CPM_Customer_Dispatch_Product_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCDPD!.path))


                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 15, max: 17)
                }
                sleep(2)
                self.writeTransactionTablesToFile(tableName: "CPM_Customer_Receive_Product_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCRPD!.path))

                sleep(2)
                self.writeTransactionTablesToFile(tableName: "CPM_Customer_Sticker_Damage", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCCSD!.path))

                sleep(2)

                self.writeTransactionTablesToFile(tableName: "CPM_Customer_Sticker_Damage_Remove", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCCSDR!.path))

                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 17, max: 19)
                }
                sleep(2)
                self.writeTransactionTablesToFile(tableName: "CPM_Sticker_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCSD!.path))

                sleep(2)
                self.writeTransactionTablesToFile(tableName: "CPM_Pallet_Mst", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCPM!.path))

                sleep(2)
                DispatchQueue.main.async  {
                    self.updateProgress(type: 1, message: "progress", min: 19, max: 20)
                }
            }
            self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "EXPORT_FILE_END")
            self.self.syncJSON.setValue("---Export Database End---", forKey: "2")

            self.writeLog(key: "CREATE_ZIP_START", value: "")

            self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_START")
            self.self.syncJSON.setValue("---Create Zip File Start---", forKey: "3")

            var success = false

            if(isDbEncripted == "true"){
                // Create ZIP FIle
                success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path,
                                                     withContentsOfDirectory: fileMainDir!.path,
                                                     keepParentDirectory: false,
                                                     compressionLevel: 5,
                                                     password: self.ZipPassword,
                                                     aes: true,
                                                     progressHandler: nil)
                //var success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path, withContentsOfDirectory: fileMainDir!.path)
                if(success){
                    self.writeLog(key: "CREATE_ZIP_END", value: "Success")
                    isGoahead = true

                    self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_END")
                    self.self.syncJSON.setValue("---Create Zip File End---", forKey: "4")

                }else{
                    self.writeLog(key: "CREATE_ZIP_END", value: "Error creating zip")
                    isGoahead = false
                    isGoaheadMessage = "Error creating zip"
                    self.self.syncJSON.setValue("---Create Zip File Failed---", forKey: "5")
                }
            }else{
                success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path, withContentsOfDirectory: fileMainDir!.path)
                if(success){
                    self.writeLog(key: "CREATE_ZIP_END", value: "Success")
                    isGoahead = true
                    self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_END")
                    self.self.syncJSON.setValue("---Create Zip File End---", forKey: "6")
                }else{
                    self.writeLog(key: "CREATE_ZIP_END", value: "Error creating zip")
                    isGoahead = false
                    isGoaheadMessage = "Error creating zip"
                    self.self.syncJSON.setValue("---Create Zip File Failed---", forKey: "7")
                }
            }

            //success = false
            //isGoahead = false

            self.self.requestJSON.setValue(zipName, forKey: "CREATE_ZIP_FILE_NAME")
            self.self.syncJSON.setValue("---Crate ZIP File Name---\(zipName)", forKey: "8")

            var fileData: NSData? = nil
            var fileData1:String  = ""
            if(success){
                do {
                    self.writeLog(key: "ENCODE_ZIP_START", value: "")
                    var fileSizeValue: UInt64 = 0
                    do {
                        let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: fileMainDirZip!.path)

                        if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                            fileSizeValue = UInt64(fileNumberSize)
                            self.writeLog(key: "UPLOAD_ZIP_SIZE", value: "\(fileSizeValue)")
                            let byteCountFormatter = ByteCountFormatter()
                            byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB

                            self.self.requestJSON.setValue(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)), forKey: "CREATE_ZIP_SIZE")
                            self.self.syncJSON.setValue("---ZIP Size---\(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))", forKey: "9")
                        }
                    } catch {
                        //print(error.localizedDescription)
                        self.self.syncJSON.setValue("---Encode Zip Failed---", forKey: "10")
                    }

                    try fileData = NSData(contentsOfFile: fileMainDirZip!.path, options: NSData.ReadingOptions.mappedIfSafe)

                    fileData1 = fileData!.base64EncodedString(options: NSData.Base64EncodingOptions([]))
                    self.writeLog(key: "ENCODE_ZIP_END", value: "")
                }
                catch let error as NSError {
                    self.writeLog(key: "ENCODE_ZIP_ERROR", value: "\(error)")
                    //print("Ooops! Something went wrong : \(error)")
                    isGoahead = false;
                    isGoaheadMessage = "error:104"
                    self.syncJSON.setValue("---Encode Zip Failed---", forKey: "11")
                }
            }

            self.updateProgress(type: 1, message: "progress", min: 21, max: 34)
            self.startTimmerDetails(min: 21, max: 34)
            // Call API
            if(isGoahead){
                self.writeLog(key: "UPLOAD_ZIP_START", value: "")
                let web = urlUpload+uploadMethod
                print(web)
                print("FileName \(zipName)")
                print("DeviceId \(imei)")
                print("PersonId \(fk_EmpGlCode)")
                print("Version \(version)")
                print("APIToken \(userName)")

                self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "UPLOAD_API_CALL_START")
                self.self.syncJSON.setValue("---Upload API call start---", forKey: "12")

                self.UploadDatabaseFileZipOld(web:web, fileData1:fileData1, zipName:zipName, action: "FileUpload", fileMainDir: fileMainDir!, fileManager:fileManager, filePathSyncDownload:filePathSyncDownload!, filePathSyncDownloadZip:filePathSyncDownloadZip,packageName: packageName)

                /*let parameters = [
                    "FileArray": "\(fileData1)",
                    "FileName": zipName,
                    "DeviceId": "\(imei)",
                    "PersonId": "\(fk_EmpGlCode)",
                    "Version": "\(version)",
                    "SubModuleName": ClientName,
                    "APIToken": "\(userName)",
                ]

                self.writeLog(key: "UPLOAD_ZIP_API_START", value: "")
                self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)

                    .responseString { response in
                        print("Success: \(response.result)")
                        print(response)

                        switch response.result {
                        case .success(let jsonData):
                            self.writeLog(key: "UPLOAD_ZIP_END", value: "SUCCESS")
                            self.updateProgress(type: 1, message: "progress", min: 61, max: 65)
                            print("Success with JSON: \(jsonData)")

                            // delete directory
                            self.deleteDirNew(path: fileMainDir! as NSURL)

                            //print(jsonData)

                            do{
                                let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData

                                let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]

                                let anyObj = JSON(json)

                                var isValid:String = ""
                                var Message:String = ""
                                var Response:String = ""

                                if anyObj["Status"].exists(){
                                    //print("inside Status")
                                    //let list: Array<JSON> = anyObj["Status"].arrayValue

                                    isValid =  anyObj["Status"].stringValue
                                    Message =  anyObj["Message"].stringValue
                                    Response =  anyObj["Response"].stringValue
                                }else{
                                    isValid =  anyObj["Status"].stringValue
                                    Message =  anyObj["Message"].stringValue
                                    self.writeLog(key: "SYNC_ERROR", value: Message)
                                }

                                if anyObj["SyncId"].exists(){
                                    self.SyncId = anyObj["SyncId"].intValue
                                }

                                if(isValid == "1"){
                                    self.writeLog(key: "UPLOAD_ZIP_API_SUCCESS", value: "")
                                    if (self.isConnectedToNetwork() == true ){
                                        let destination: DownloadRequest.DownloadFileDestination = { _, _ in
                                            let fileURL = filePathSyncDownload!.appendingPathComponent("\(zipName)")
                                            return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
                                        }

                                        Alamofire.download(Response, to: destination).response { response in
                                            //print(response)

                                            if response.error == nil, let zipPath = response.destinationURL?.path {
                                                //print(zipPath)

                                                //var fileSizeValue: UInt64 = 0

                                                /*do {
                                                 let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: zipPath)

                                                 if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                                                 let fileSizeValue = UInt64(fileNumberSize)
                                                 }
                                                 } catch {
                                                 //print(error.localizedDescription)
                                                 }*/
                                                self.stopTimer()
                                                self.updateProgress(type: 1, message: "progress", min: 66, max: 98)

                                                self.createDir(path: filePathSyncDownloadZip as NSURL)
                                                if(self.unzipFile(zipPath: (filePathSyncDownload?.appendingPathComponent("\(zipName)").path)!, destinationPath: filePathSyncDownloadZip.path)){
                                                    //print("Unzipped")
                                                    //CPM_Sticker_Details/CPM_Sticker_Details$_1.txt

                                                    let enumerator = fileManager.enumerator(atPath: filePathSyncDownloadZip.path)
                                                    let filePaths = enumerator?.allObjects as! [String]
                                                    let txtFilePaths = filePaths.filter{$0.contains(".txt")}

                                                    self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("BASF-HK-Database.db")?.path)

                                                    if self.database.open()
                                                    {
                                                        let deleteQuery = "DELETE FROM CPM_Customer_Dispatch_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])

                                                        let deleteQuery2 = "DELETE FROM CPM_Customer_Receive_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery2, withArgumentsIn: [])

                                                        let deleteQuery3 = "DELETE FROM CPM_Customer_Sticker_Damage WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery3, withArgumentsIn: [])

                                                        let deleteQuery4 = "DELETE FROM CPM_Customer_Sticker_Damage_Remove WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery4, withArgumentsIn: [])
                                                    }

                                                    for txtFilePath in txtFilePaths{
                                                        //print("FilePath \(txtFilePath)")
                                                        let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                        let tableName = fileURL.path.fileName().split(separator: "$")
                                                        //print("tableName \(tableName)")

                                                        do {

                                                            //DispatchQueue.global(qos: .background).async {
                                                            let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)

                                                            let json = JSON.init(parseJSON:stringJSON)
                                                            self.deleteRecordForViolation(tableName: String(tableName[0]), jsonArray: json)
                                                            isGoahead = self.insertRecordDynamic(tableName: String(tableName[0]), jsonArray: json)
                                                            if(!isGoahead){
                                                                //DispatchQueue.main.async {
                                                                isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                break;
                                                                //}
                                                            }
                                                            //}
                                                        }
                                                        catch {
                                                            //print("Error Reading \(txtFilePath)")
                                                            isGoahead = false
                                                            isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                        }
                                                    }

                                                    if(isGoahead){
                                                        self.writeLog(key: "SYNC_DONE", value: "")
                                                        self.updateProgress(type: 3, message: Message, min: 100, max: 100)
                                                    }else{
                                                        self.writeLog(key: "SYNC_FAIL", value: isGoaheadMessage)
                                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 100, max: 100)
                                                    }
                                                }else{
                                                    isGoahead = false
                                                    isGoaheadMessage = "Error in extract zip file"
                                                    self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                }
                                            }else{
                                                isGoahead = false
                                                isGoaheadMessage = "Error in download zip file"
                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                self.updateProgress(type: 2, message: Message, min: 0, max: 0)
                                            }
                                        }
                                    }else{
                                        isGoaheadMessage = "NO_INTERNET"
                                        self.writeLog(key: "UPLOAD_ZIP_END", value: isGoaheadMessage)
                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                    }
                                }else if(isValid == "2"){
                                    isGoaheadMessage = "Session expired. Please try again";
                                    self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }else{
                                    isGoaheadMessage = Message;
                                    self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }
                            }catch{
                                isGoaheadMessage = "server error:@, please try again \(jsonData)";
                                self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                            }
                        case .failure(let error):
                            //print("Request failed with error: \(error)")
                            let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
                            self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        }
                }*/
            }else{
                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
            }

        }

        return isGoaheadMessage
    }
    
    
    var zipName_final_re = ""
    var toLocation_zip_file_path = ""
    
    func FileSyncDataRe(userName:String, fk_EmpGlCode:String, ClientName:String, version:String, imei:String, uploadMethod:String, logUploadMethod:String, urlUpload:String, databaseName:String,isDbEncripted:String
                        ,CustomerId:String,DeviceSyncStatus:String,CustomerCode:String,SystemName:String,LastSyncDate:String,ServerSyncId:String,user_id: String, country_id: String, version_code: String, sync_date: String, sync_type: String,customer_level:String,role_code:String,byPassSSL:Bool)->String{
        
        print("********************************")
        print("********************************")
        print("FileSyncDataRe")
        print("********************************")
        print("********************************")
        
        //xxx
        requestJSON.setValue(Date().getJsonLogTime(), forKey: "SYNC_START")
        
        self.userName=userName;
        self.fk_EmpGlCode=fk_EmpGlCode;
        self.ClientName=ClientName;
        self.version=version;
        self.imei=imei;
        self.uploadMethod=uploadMethod;
        self.logUploadMethod=logUploadMethod;
        self.urlUpload=urlUpload;
        
        
        self.CustomerId=CustomerId;
        self.DeviceSyncStatus=DeviceSyncStatus
        self.CustomerCode=CustomerCode;
        self.SystemName=SystemName;
        self.LastSyncDate=LastSyncDate;
        self.ServerSyncId=ServerSyncId;
        
        writeLog(key: "FB_SYNC_START", value: "")
        updateProgress(type: 444, message: "progress", min: 1, max: 7)
        
       // var isGoahead:Bool = true
        //var isGoaheadMessage:String = ""
        
        let date = Date()
        let calendar = Calendar.current
        
        let year = calendar.component(.year, from: date)
        let month = calendar.component(.month, from: date)
        let day = calendar.component(.day, from: date)
        
        let hour = calendar.component(.hour, from: date)
        let minute = calendar.component(.minute, from: date)
        let second = calendar.component(.second, from: date)
        
        let fileManager = FileManager.default
        
        let filePathSyncBackUp = documentsPath.appendingPathComponent("SyncBackup")
        let filePathSyncDownload = documentsPath.appendingPathComponent("SyncDownload")
        
        let dateString = String(format: "%02ld%02ld%ld_%02ld%02ld%02ld", day, month, year, hour, minute, second)
        
        //let fName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(version)"
        let fName = "\(dateString)_\(version)"
        let fileMainDir = filePathSyncBackUp?.appendingPathComponent("\(day)/\(fName)")
        let zipName = "\(fName).zip"
        let ZipFileName = "\(fName)"
        
        let filePathSyncDownloadZip = filePathSyncDownload!.appendingPathComponent(fName)
        let fileMainDirZip = filePathSyncBackUp?.appendingPathComponent("\(day)/\(zipName)")
        
        let packageName : String = dict["packageName"] ?? ""
        self.packageName = packageName
        
        if(!deleteDir(path: filePathSyncBackUp! as NSURL)){
            //isGoahead = false;
           // isGoaheadMessage = "error:101";
            //            DispatchQueue.main.async  {
            let errorMssg = "Getting Error in deleteDir : 8"
            let response = "FLAG!!1" +
                           "||" +
                           "errorCode!!101" +
                           "||" +
                           "errorMsg!!\(errorMssg)" +
                           "||" +
                           "objProcess!!ERROR" +
                           "||" +
                           "syncLogID!!0"
            
            self.updateProgress(type: 555, message: "Fail@@\(response)", min: 8, max: 8)
            //            }
        }
        updateProgress(type: 444, message: "progress", min: 8, max: 8)
        // DispatchQueue.global(qos: .background).async { [self] in
        
        self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "EXPORT_FILE_END")
        self.self.syncJSON.setValue("---Export Database End---", forKey: "2")
        
        self.writeLog(key: "CREATE_ZIP_START", value: "")
        
        self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_START")
        self.self.syncJSON.setValue("---Create Zip File Start---", forKey: "3")
        
       // var success = false
       // var fileMainDir:String = ""
        
        //CHECK_FILE_CREATE
        let fileMainDir_dev = getLocalTransactionFile(syncType: sync_type, userid: user_id)
        
        print(fileMainDir_dev)
        
        //sleep(5)
        
        //success = true
        //isGoahead = true
        let web = urlUpload+uploadMethod
        print("web:\(web)")
       // let path_URL = URL(string: fileMainDir_dev)
        let path_URL = URL(fileURLWithPath: fileMainDir_dev)
        uploadZipFile(url: web, zipFileName: zipName_final_re, zipFilePath: path_URL, token: "", user_id: user_id, upload_type: sync_type, first_sync: LastSyncDate != "" ? "N" : "Y", zPath: fileMainDir_dev,web_url_old:web, fileData1:"", zipName:zipName, action:"", fileMainDir:fileMainDir!, fileManager:fileManager, filePathSyncDownload:filePathSyncDownloadZip, filePathSyncDownloadZip:filePathSyncDownloadZip,packageName:packageName,country_id:country_id,date_folder:"",version_code:version_code,sync_log_id:"",sync_date:sync_date,sync_type:sync_type,flag_code:sync_type,request_param:"",ZipFileName:zipName_final_re,customer_level:customer_level,role_code:role_code,imei:imei, byPassSSL: byPassSSL)
        
        /*self.self.requestJSON.setValue(zipName, forKey: "CREATE_ZIP_FILE_NAME")
         self.self.syncJSON.setValue("---Crate ZIP File Name---\(zipName)", forKey: "8")
         
         var fileData: NSData? = nil
         var fileData1:String  = ""
         if(success){
         do {
         self.writeLog(key: "ENCODE_ZIP_START", value: "")
         var fileSizeValue: UInt64 = 0
         //ZIP SIZE CODE
         /*do {
          let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: fileMainDirZip!.path)
          
          if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
          fileSizeValue = UInt64(fileNumberSize)
          self.writeLog(key: "UPLOAD_ZIP_SIZE", value: "\(fileSizeValue)")
          let byteCountFormatter = ByteCountFormatter()
          byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
          
          self.self.requestJSON.setValue(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)), forKey: "CREATE_ZIP_SIZE")
          self.self.syncJSON.setValue("---ZIP Size---\(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))", forKey: "9")
          }
          } catch {
          //print(error.localizedDescription)
          self.self.syncJSON.setValue("---Encode Zip Failed---", forKey: "10")
          }*/
         
         try fileData = NSData(contentsOfFile: fileMainDir, options: NSData.ReadingOptions.mappedIfSafe)
         
         fileData1 = fileData!.base64EncodedString(options: NSData.Base64EncodingOptions([]))
         self.writeLog(key: "ENCODE_ZIP_END", value: "")
         }
         catch let error as NSError {
         self.writeLog(key: "ENCODE_ZIP_ERROR", value: "\(error)")
         //print("Ooops! Something went wrong : \(error)")
         isGoahead = false;
         isGoaheadMessage = "error:104"
         self.syncJSON.setValue("---Encode Zip Failed---", forKey: "11")
         DispatchQueue.main.async  {
         self.updateProgress(type: 555, message: "error:104", min: 9, max: 15)
         }
         }
         }
         
         self.updateProgress(type: 444, message: "progress", min: 26, max: 34)
         //self.startTimmerDetails(min: 25, max: 34)
         // Call API
         if(isGoahead){
         self.writeLog(key: "UPLOAD_ZIP_START", value: "")
         let web = urlUpload+uploadMethod
         print(web)
         print("FileName \(zipName)")
         print("DeviceId \(imei)")
         print("PersonId \(fk_EmpGlCode)")
         print("Version \(version)")
         print("APIToken \(userName)")
         
         self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "UPLOAD_API_CALL_START")
         self.self.syncJSON.setValue("---Upload API call start---", forKey: "12")
         
         //self.UploadDatabaseFileZipOld_Re(web:web, fileData1:fileData1, zipName:zipName_final_re, action: "FileUpload", fileMainDir: filePathSyncDownload!, fileManager:fileManager, filePathSyncDownload:filePathSyncDownload!, filePathSyncDownloadZip:filePathSyncDownloadZip,packageName: packageName,user_id: user_id, country_id: country_id, version_code: version_code, sync_date: sync_date, sync_type: sync_type)
         
         let action = "FileUpload"
         var parameters = [String: String]()
         var headers = HTTPHeaders()
         //let headers = []
         //var parameters: NSMutableArray = []
         //var headers: NSArray = []
         
         //         if(packageName == "com.ecubix.iffcocpm"){
         print("web url:\(web)")
         
         parameters = [
         "FileArray": "\(action == "Process" || action == "CHECK_DOWNLOAD" ? "" : "\(fileData1)")",
         "FileName": zipName,
         "DeviceId": "\(imei)",
         "PersonId": "\(fk_EmpGlCode)",
         "Version": "\(version)",
         "SubModuleName": ClientName,
         "APIToken": "\(userName)",
         "Action": "\(action)",
         "JsonData": "{\"Sync_Log\":[\"\(requestJSONInString())\"]}",
         "SyncId": "\(self.SyncId)",
         ]
         
         //print("{\"Sync_Log\":[\"\(requestJSONInString())\"]}")
         
         //if action == "Process" {
         print("\(parameters)")
         //}
         
         let configuration = URLSessionConfiguration.default
         var timeout: Double = 2700
         
         if action == "Process" || action == "CHECK_DOWNLOAD" {
         if action == "Process" {
         if !isProgressFirstTime {
         isProgressFirstTime = true
         self.startTimmerDetails(min: 35, max: 45)
         }
         } else if action == "CHECK_DOWNLOAD" {
         if !isCheckDownloadFirstTime {
         isCheckDownloadFirstTime = true
         self.startTimmerDetails(min: 45, max: 60)
         }
         }
         timeout = 120
         }
         
         configuration.timeoutIntervalForRequest = timeout
         configuration.timeoutIntervalForResource = timeout  // seconds
         alamofireManager = Alamofire.Session(configuration: configuration)*/
        
        
        
        /*self.writeLog(key: "UPLOAD_ZIP_API_START", value: "")
         self.alamofireManager!.request(web, method: .post, parameters: parameters, headers: headers)
         .validate(statusCode: 200..<300)
         
         .responseString { response in
         print("Success: \(response.result)")
         print(response)
         
         switch response.result {
         case .success(let jsonData):
         self.writeLog(key: "UPLOAD_ZIP_END", value: "SUCCESS")
         print("Success with JSON: \(jsonData)")
         
         // delete directory
         //self.deleteDirNew(path: fileMainDir as NSURL)
         
         //print(jsonData)
         self.updateProgress(type: 444, message: "progress", min: 36, max: 37)
         do {
         let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData
         
         let json =
         try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String: Any]
         
         let anyObj = JSON(json)
         
         var isValid: Bool = false
         var Message: String = ""
         var msg_code: String = ""
         var date_folder: String = ""
         var sync_done: String = ""
         
         if anyObj["status"].exists() {
         isValid = anyObj["status"].boolValue
         Message = anyObj["message"].stringValue
         msg_code = anyObj["msg_code"].stringValue
         date_folder = anyObj["date_folder"].stringValue
         sync_done = anyObj["sync_done"].stringValue
         self.SyncId = anyObj["sync_log_id"].intValue
         } else {
         isValid = anyObj["status"].boolValue
         Message = anyObj["message"].stringValue
         self.writeLog(key: "SYNC_ERROR", value: Message)
         }
         
         if anyObj["sync_log_id"].exists() {
         self.SyncId = anyObj["sync_log_id"].intValue
         }
         
         if isValid == true {
         
         self.UploadDatabaseFileZipOld_Re_sync_porocess(
         web_url_old: web, fileData1: fileData1, zipName: zipName, action: "Process",
         fileMainDir: filePathSyncDownload!, fileManager: fileManager,
         filePathSyncDownload: filePathSyncDownload!,
         filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName,
         user_id: user_id, country_id: country_id, date_folder: date_folder,
         version_code: version_code, sync_log_id: "\(self.SyncId)", sync_date: sync_date,
         sync_type: sync_type, flag_code: sync_type, request_param: "", ZipFileName:ZipFileName,customer_level:customer_level,role_code:role_code)
         
         } else if isValid == false {
         isGoaheadMessage = "Session expired. Please try again"
         self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
         self.updateProgress(type: 555, message: isGoaheadMessage, min: 36, max: 37)
         
         if action == "Process" {
         self.self.syncJSON.setValue(
         "---Upload API Call Failed---\(isGoaheadMessage)", forKey: "26")
         } else {
         self.self.syncJSON.setValue(
         "---Process API Call Failed---\(isGoaheadMessage)", forKey: "27")
         }
         
         } else {
         isGoaheadMessage = Message
         self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
         self.updateProgress(type: 555, message: isGoaheadMessage, min: 36, max: 37)
         }
         } catch {
         isGoaheadMessage = "server error:@, please try again \(jsonData)"
         self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
         self.updateProgress(type: 555, message: isGoaheadMessage, min: 36, max: 37)
         
         if action == "Process" {
         self.self.syncJSON.setValue(
         "---Upload API Call Failed---\(isGoaheadMessage)", forKey: "28")
         } else {
         self.self.syncJSON.setValue(
         "---Process API Call Failed---\(isGoaheadMessage)", forKey: "29")
         }
         }
         case .failure(let error):
         switch error {
         case .sessionTaskFailed(URLError.timedOut):
         print("Request timeout!")
         if action == "Process" || action == "CHECK_DOWNLOAD" {
         /*self.UploadDatabaseFileZipOld(
          web: web, fileData1: fileData1, zipName: zipName, action: "CHECK_DOWNLOAD",
          fileMainDir: fileMainDir, fileManager: fileManager,
          filePathSyncDownload: filePathSyncDownload,
          filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName)*/
         let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
         self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
         self.updateProgress(type: 555, message: isGoaheadMessage, min: 36, max: 37)
         }
         default:
         let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
         self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
         self.updateProgress(type: 555, message: isGoaheadMessage, min: 36, max: 37)
         
         let httpStatusCode = response.response?.statusCode
         
         if action == "Process" {
         self.self.syncJSON.setValue(
         "---Response Status Not Getting 200---\(String(describing: httpStatusCode))",
         forKey: "30")
         self.self.syncJSON.setValue(
         "---Upload API Call Failed---\(isGoaheadMessage)", forKey: "31")
         } else {
         self.self.syncJSON.setValue(
         "---Response Status Not Getting 200---\(String(describing: httpStatusCode))",
         forKey: "32")
         self.self.syncJSON.setValue(
         "---Process API Call Failed---\(isGoaheadMessage)", forKey: "33")
         }
         }
         
         }
         }*/
        
        /*}else{
         self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
         self.updateProgress(type: 555, message: isGoaheadMessage, min: 8, max: 8)
         }*/
        
        // }
        
        return "isGoaheadMessage"
    }
    
    class CustomURLSessionDelegate: NSObject, URLSessionDelegate {
        func urlSession(_ session: URLSession, didReceive challenge: URLAuthenticationChallenge, completionHandler: @escaping (URLSession.AuthChallengeDisposition, URLCredential?) -> Void) {
            guard let serverTrust = challenge.protectionSpace.serverTrust else {
                completionHandler(.performDefaultHandling, nil)
                return
            }

            // Disable SSL/TLS validation
            let credential = URLCredential(trust: serverTrust)
            completionHandler(.useCredential, credential)
        }
    }

    func uploadZipFile(url:String, zipFileName: String, zipFilePath: URL, token: String, user_id: String, upload_type: String, first_sync: String, zPath:String,web_url_old:String, fileData1:String, zipName:String, action:String, fileMainDir:URL, fileManager:FileManager, filePathSyncDownload:URL, filePathSyncDownloadZip:URL,packageName:String,country_id:String,date_folder:String,version_code:String,sync_log_id:String,sync_date:String,sync_type:String,flag_code:String,request_param:String,ZipFileName:String,customer_level:String,role_code:String,imei:String, byPassSSL:Bool) {
        
        var isGoaheadMessage = ""
        let url = URL(string: url)
        
        // generate boundary string using a unique per-app string
        //let boundary = UUID().uuidString
        let boundary = "------fileUpload"
        
        
        var session: URLSession
        
        if(!byPassSSL){
            session = URLSession.shared
        }else{
            session = URLSession(configuration: .ephemeral, delegate: CustomURLSessionDelegate(), delegateQueue: nil)
        }
        // Set the URLRequest to POST and to the specified URL
        var urlRequest = URLRequest(url: url!)
        urlRequest.httpMethod = "POST"
        
        // Set Content-Type Header to multipart/form-data, this is equivalent to submitting form data with file upload in a web browser
        // And the boundary is also set here
        urlRequest.setValue("multipart/form-data; boundary=\(boundary)", forHTTPHeaderField: "Content-Type")
        
        // Add "Keep-Alive" header
        urlRequest.setValue("Keep-Alive", forHTTPHeaderField: "Connection")
        // urlRequest.setValue("filename", forHTTPHeaderField: zPath)
        // urlRequest.setValue("token", forHTTPHeaderField: token)
        // urlRequest.setValue("user_id", forHTTPHeaderField: user_id)
        // urlRequest.setValue("upload_type", forHTTPHeaderField: upload_type)
        // urlRequest.setValue("first_sync", forHTTPHeaderField: first_sync)
        // urlRequest.setValue("imei_no", forHTTPHeaderField: imei)
        
        urlRequest.setValue(zPath, forHTTPHeaderField: "filename")
        urlRequest.setValue(token, forHTTPHeaderField: "token")
        urlRequest.setValue(user_id, forHTTPHeaderField: "user_id")
        urlRequest.setValue(upload_type, forHTTPHeaderField: "upload_type")
        urlRequest.setValue(first_sync, forHTTPHeaderField: "first_sync")
        urlRequest.setValue(imei, forHTTPHeaderField: "imei_no")
        
        var data = Data()
        
        //let zipFileName_1 = zipFileName + ".zip"
        
        // Add the zip file data to the raw HTTP request data
        data.append("\r\n--\(boundary)\r\n".data(using: .utf8)!)
        data.append("Content-Disposition: form-data; name=\"file\";filename=\"\(zPath)\"; token=\"\(token)\"; user_id=\"\(user_id)\"; upload_type=\"\(upload_type)\"; first_sync=\"\(first_sync)\"; imei_no=\"\(imei)\"; \r\n".data(using: .utf8)!)
        data.append("Content-Type: application/form-data\r\n\r\n".data(using: .utf8)!)
        
        do {
            let zipFileData = try Data(contentsOf: zipFilePath)
            data.append(zipFileData)
        } catch {
            print("Error reading zip file data: \(error.localizedDescription)")
            return
        }
        
        data.append("\r\n--\(boundary)--\r\n".data(using: .utf8)!)
        
        // Send a POST request to the URL, with the data we created earlier
        session.uploadTask(with: urlRequest, from: data) { responseData, response, error in
            if let error = error {
                // Handle the error
                print("Error during upload: \(error.localizedDescription)")
                let errorMssg = "Getting Error in uploadTask : \(error.localizedDescription)"
                let response = "FLAG!!1" +
                "||" +
                "errorCode!!102" +
                "||" +
                "errorMsg!!\(errorMssg)" +
                "||" +
                "objProcess!!ERROR" +
                "||" +
                "syncLogID!!0"
                
                self.updateProgress(type: 555, message: "Fail@@\(response)", min: 36, max: 36)
                //                self.updateProgress(type: 555, message: isGoaheadMessage, min: 36, max: 37)
            } else {
                if let responseData = responseData {
                    print(responseData)
                    // Convert responseData to a UTF-8 string and print
                    if let jsonString = String(data: responseData, encoding: .utf8) {
                        print("Response Data: \(jsonString)")
                        
                        do {
                            // Try to parse JSON from the responseData
                            let jsonData = try JSONSerialization.jsonObject(with: responseData, options: .allowFragments)
                            if let json = jsonData as? [String: Any] {
                                // Handle the JSON response
                                var isValid: Bool = false
                                var Message: String = ""
                                var msg_code: String = ""
                                var date_folder: String = ""
                                var sync_done: String = ""
                                
                                let anyObj = JSON(json)
                                
                                if anyObj["status"].exists() {
                                    isValid = anyObj["status"].boolValue
                                    Message = anyObj["message"].stringValue
                                    msg_code = anyObj["msg_code"].stringValue
                                    date_folder = anyObj["date_folder"].stringValue
                                    sync_done = anyObj["sync_done"].stringValue
                                    self.SyncId = anyObj["sync_log_id"].intValue

                                } else {
                                    isValid = anyObj["status"].boolValue
                                    Message = anyObj["message"].stringValue
                                    self.writeLog(key: "SYNC_ERROR", value: Message)
                                }
                                
                                if anyObj["sync_log_id"].exists() {
                                    self.SyncId = anyObj["sync_log_id"].intValue
                                }
                                
                                if isValid == true {
                                    
                                    self.UploadDatabaseFileZipOld_Re_sync_porocess(
                                        web_url_old: web_url_old, fileData1: fileData1, zipName: zipName, action: "Process",
                                        fileMainDir: filePathSyncDownload, fileManager: fileManager,
                                        filePathSyncDownload: filePathSyncDownload,
                                        filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName,
                                        user_id: user_id, country_id: country_id, date_folder: date_folder,
                                        version_code: version_code, sync_log_id: "\(self.SyncId)", sync_date: sync_date,
                                        sync_type: sync_type, flag_code: sync_type, request_param: "", ZipFileName:ZipFileName,customer_level:customer_level,role_code:role_code)
                                    
                                } else if isValid == false {
                                    
                                    isGoaheadMessage = "Getting Error in uploadTask : \(Message)"
                                    self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                    
                                    print("========BBBBBBBBBBBBBB=========")
                                    
                                    let errorMssg = "Getting Error in uploadTask : \(Message)"
                                    let response = "FLAG!!2" +
                                    "||" +
                                    "errorCode!!\(msg_code)" +
                                    "||" +
                                    "errorMsg!!\(Message)" +
                                    "||" +
                                    "objProcess!!ERROR" +
                                    "||" +
                                    "syncLogID!!\(self.SyncId)"
                                    
                                    OperationQueue.main.addOperation {
                                        print("========BBBBBBBBBBBBBB=========")
                                        self.updateProgress(type: 555, message: "Fail@@\(response)", min: 36, max: 37)
                                    }
                                    
                                } else {
                                    isGoaheadMessage = "Getting Error in uploadTask : \(Message)"
                                    self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                    
                                    
                                    print("========AAAAAAAAAAAAAAAAA=========")
                                    
                                    let errorMssg = "Getting Error in uploadTask : \(Message)"
                                    let response = "FLAG!!2" +
                                    "||" +
                                    "errorCode!!\(msg_code)" +
                                    "||" +
                                    "errorMsg!!\(Message)" +
                                    "||" +
                                    "objProcess!!ERROR" +
                                    "||" +
                                    "syncLogID!!\(self.SyncId)"
                                    
                                    OperationQueue.main.addOperation {
                                        self.updateProgress(type: 555, message: "Fail@@\(response)", min: 36, max: 37)
                                    }
                                    
                                }
                            }
                        } catch {
                            // Handle JSON parsing error
                            print("Error parsing JSON: \(error.localizedDescription)")
                            
                            let errorMssg = "In uploadTask Error parsing JSON: \(error.localizedDescription)"
                            let response = "FLAG!!2" +
                            "||" +
                            "errorCode!!103" +
                            "||" +
                            "errorMsg!!\(errorMssg)" +
                            "||" +
                            "objProcess!!ERROR" +
                            "||" +
                            "syncLogID!!0"
                            
                            OperationQueue.main.addOperation {
                                self.updateProgress(type: 555, message: "Fail@@\(response)", min: 36, max: 37)
                            }
                            
                        }
                    } else {
                        // Handle the case where responseData is not a valid UTF-8 string
                        print("Response Data is not a valid UTF-8 string.")
                        
                        
                        let errorMssg = "In uploadTask Response Data is not a valid UTF-8 string."
                        let response = "FLAG!!2" +
                        "||" +
                        "errorCode!!104" +
                        "||" +
                        "errorMsg!!\(errorMssg)" +
                        "||" +
                        "objProcess!!ERROR" +
                        "||" +
                        "syncLogID!!0"
                        
                        OperationQueue.main.addOperation {
                            self.updateProgress(type: 555, message: "Fail@@\(response)", min: 36, max: 37)
                        }
                        
                        //                        OperationQueue.main.addOperation {
                        //                            self.updateProgress(type: 555, message: isGoaheadMessage, min: 36, max: 37)
                        //                        }
                    }
                } else {
                    // Handle the case where responseData is nil
                    print("Response Data is nil.")
                    
                    let errorMssg = "In uploadTask Response Data is nil."
                    let response = "FLAG!!2" +
                    "||" +
                    "errorCode!!105" +
                    "||" +
                    "errorMsg!!\(errorMssg)" +
                    "||" +
                    "objProcess!!ERROR" +
                    "||" +
                    "syncLogID!!0"
                    
                    OperationQueue.main.addOperation {
                        self.updateProgress(type: 555, message: "Fail@@\(response)", min: 36, max: 37)
                    }
                    
                    //                    OperationQueue.main.addOperation {
                    //                        self.updateProgress(type: 555, message: isGoaheadMessage, min: 36, max: 37)
                    //                    }
                }
            }
        }.resume()
        
    }
    
    func UploadDatabaseFileZipOld(web:String, fileData1:String, zipName:String, action:String, fileMainDir:URL, fileManager:FileManager, filePathSyncDownload:URL, filePathSyncDownloadZip:URL,packageName:String) {

        var isGoahead = true
        var isGoaheadMessage = ""
       
        var parameters = [String: String]()
        var headers = HTTPHeaders()
        //let headers = []
        //var parameters: NSMutableArray = []
        //var headers: NSArray = []
        
        
//         if(packageName == "com.ecubix.iffcocpm"){
        print("web url:\(web)")
        if(packageName == "com.vcs.iffcocpm"){
            parameters = [
                "FileArray": "\(action == "Process" || action == "CHECK_DOWNLOAD" ? "" : "\(fileData1)")",
                "FileName": zipName,
                "DeviceId": "\(imei)",
                "PersonId": "\(fk_EmpGlCode)",
                "Version": "\(version)",
                "SubModuleName": ClientName,
                "APIToken": "\(userName)",
                "Action": "\(action)",
                "ZipPassword": "",
                "CustomerId": "\(CustomerId)",
                "DeviceSyncStatus": "\(DeviceSyncStatus)",
                "CustomerCode": "\(CustomerCode)",
                "SystemName": "\(SystemName)",
                "LastSyncDate": "\(LastSyncDate)",
                "ServerSyncId": "\(ServerSyncId)",
                
                "JsonData": "{\"Sync_Log\":[\"\(requestJSONInString())\"]}",
                "ExtraFields": "",
                "SyncId": "\(action == "Process" || action == "CHECK_DOWNLOAD" ? "\(self.SyncId)" : "")",
            ]
            
            headers = [
                  "X-ApiKey": "i3BalYxQL",
                  "Content-Type": "application/x-www-form-urlencoded"
              ]
        } else {
            parameters = [
                "FileArray": "\(action == "Process" || action == "CHECK_DOWNLOAD" ? "" : "\(fileData1)")",
                "FileName": zipName,
                "DeviceId": "\(imei)",
                "PersonId": "\(fk_EmpGlCode)",
                "Version": "\(version)",
                "SubModuleName": ClientName,
                "APIToken": "\(userName)",
                "Action": "\(action)",
                "JsonData": "{\"Sync_Log\":[\"\(requestJSONInString())\"]}",
                "ExtraFields": "",
                "SyncId": "\(action == "Process" || action == "CHECK_DOWNLOAD" ? "\(self.SyncId)" : "")",
            ]
        
        }

        print("{\"Sync_Log\":[\"\(requestJSONInString())\"]}")

        if(action == "Process"){
            print("\(parameters)")
        }
        
        let configuration = URLSessionConfiguration.default
        var timeout: Double = 1800000
        
        if(action == "Process" || action == "CHECK_DOWNLOAD"){
            if(action == "Process"){
                if(!isProgressFirstTime){
                    isProgressFirstTime=true;
                self.startTimmerDetails(min: 35, max: 45)
                }
            } else if(action == "CHECK_DOWNLOAD"){
                if(!isCheckDownloadFirstTime){
                    isCheckDownloadFirstTime=true;
                self.startTimmerDetails(min: 45, max: 60)
                }
            }
//            timeout = 120
        }
        
        configuration.timeoutIntervalForRequest = timeout
        configuration.timeoutIntervalForResource = timeout // seconds
        alamofireManager = Alamofire.Session(configuration: configuration)

        self.writeLog(key: "UPLOAD_ZIP_API_START", value: "")
        self.alamofireManager!.request(web, method: .post, parameters: parameters,headers:headers).validate(statusCode: 200..<300)

            .responseString { response in
                print("Success: \(response.result)")
                print(response)

                switch response.result {
                case .success(let jsonData):
                    self.writeLog(key: "UPLOAD_ZIP_END", value: "SUCCESS")
                    print("Success with JSON: \(jsonData)")

                    // delete directory
                    self.deleteDirNew(path: fileMainDir as NSURL)

                    //print(jsonData)

                    do{
                        let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData

                        let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]

                        let anyObj = JSON(json)

                        var isValid:String = ""
                        var Message:String = ""
                        var Response:String = ""

                        if anyObj["Status"].exists(){
                            isValid =  anyObj["Status"].stringValue
                            Message =  anyObj["Message"].stringValue
                            Response =  anyObj["Response"].stringValue
                        }else{
                            isValid =  anyObj["Status"].stringValue
                            Message =  anyObj["Message"].stringValue
                            self.writeLog(key: "SYNC_ERROR", value: Message)
                        }

                        if anyObj["SyncId"].exists(){
                            self.SyncId = anyObj["SyncId"].intValue
                        }

                        if(isValid == "1") {
                            if(action != "Process" && action != "CHECK_DOWNLOAD") {
                                self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "UPLOAD_API_CALL_END")
                                self.self.syncJSON.setValue("---Upload API Call End---", forKey: "14")

                                self.stopTimer()
                                self.updateProgress(type: 1, message: "progress", min: 35, max: 60)
                                self.startTimmerDetails(min: 35, max: 60)

                                self.UploadDatabaseFileZipOld(web:web, fileData1:fileData1, zipName:zipName, action:"Process", fileMainDir:fileMainDir, fileManager:fileManager, filePathSyncDownload:filePathSyncDownload, filePathSyncDownloadZip:filePathSyncDownloadZip,packageName: packageName)

                                self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "PROCESS_API_CALL_START")
                                self.self.syncJSON.setValue("---Process API Call Start---", forKey: "15")
                            } else {
                                self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "PROCESS_API_CALL_END")
                                self.self.syncJSON.setValue("---Process API Call End---", forKey: "16")

                                self.writeLog(key: "UPLOAD_ZIP_API_SUCCESS", value: "")
                                if (self.isConnectedToNetwork() == true ){
                                    /*let destination: DownloadRequest.DownloadFileDestination = { _, _ in
                                        let fileURL = filePathSyncDownload.appendingPathComponent("\(zipName)")
                                        return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
                                    }*/

                                   let destination: DownloadRequest.Destination = { _, _ in
                                       //let documentsURL = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask)[0]
                                       let fileURL = filePathSyncDownload.appendingPathComponent("\(zipName)")
                                       return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
                                   }

                                    self.stopTimer()
                                    self.updateProgress(type: 1, message: "progress", min: 61, max: 75)
                                    //self.startTimmerDetails(min: 61, max: 75)

                                    self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "DOWNLOAD_START")
                                    self.self.syncJSON.setValue("---Download DB Start---", forKey: "17")

                                    //AF.download(Response, to: destination).response { response in
                                    AF.download(Response, to: destination).response { response in
                                        //if response.error == nil, let zipPath = response.destinationURL?.path {
                                        if response.error == nil, let zipPath = response.fileURL?.path {
                                            self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "DOWNLOAD_END")
                                            self.self.syncJSON.setValue("---Download DB End---", forKey: "18")

                                            self.stopTimer()
                                            self.updateProgress(type: 1, message: "progress", min: 75, max: 98)
                                            self.startTimmerDetails(min: 75, max: 98)

                                            self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "IMPORT_FILE_START")
                                            self.self.syncJSON.setValue("---Import File Start---", forKey: "19")

                                            self.createDir(path: filePathSyncDownloadZip as NSURL)
                                            if(self.unzipFile(zipPath: (filePathSyncDownload.appendingPathComponent("\(zipName)").path), destinationPath: filePathSyncDownloadZip.path)){

                                                let enumerator = fileManager.enumerator(atPath: filePathSyncDownloadZip.path)
                                                let filePaths = enumerator?.allObjects as! [String]
                                                let txtFilePaths = filePaths.filter{$0.contains(".txt")}
                                                let packageName : String = self.dict["packageName"] ?? ""

                                               /* if(packageName == "com.ecubix.basflab"){
                                                     self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("BASF-LAB-Database.db")?.path)

                                                     if self.database.open()
                                                     {
                                                         let deleteQuery = "DELETE FROM LAB_Customer_Dispatch_Product_Details WHERE chrSync = 'N'"
                                                         self.database.executeUpdate(deleteQuery, withArgumentsIn: [])


                                                     }

                                                     for txtFilePath in txtFilePaths{
                                                         //print("FilePath \(txtFilePath)")
                                                         let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                         let tableName = fileURL.path.fileName().split(separator: "$")
                                                         //print("tableName \(tableName)")

                                                         do {

                                                             //DispatchQueue.global(qos: .background).async {
                                                             let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)

                                                             let json = JSON.init(parseJSON:stringJSON)
                                                             self.deleteRecordForViolation(tableName: String(tableName[0]), jsonArray: json)
                                                             isGoahead = self.insertRecordDynamicForLAB(tableName: String(tableName[0]), jsonArray: json)
                                                             if(!isGoahead){
                                                                 //DispatchQueue.main.async {
                                                                 isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                 self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                 self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                 break;
                                                                 //}
                                                             }
                                                             //}
                                                         }
                                                         catch {
                                                             //print("Error Reading \(txtFilePath)")
                                                             isGoahead = false
                                                             isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                             self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                             self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                         }
                                                     }
//                                                 } else if(packageName == "com.ecubix.iffcocpm"){
                                                } else if(packageName == "com.vcs.iffcocpm"){
                                                    //database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-Retailer-Database.db")?.path)
                                                    
                                                    self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("IFFCO_CPM_Database.db")?.path)

                                                    if self.database.open()
                                                    {
                                                        let deleteQuery = "DELETE FROM CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS WHERE CHR_SYNC = 'N'"
                                                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])

                                                        let deleteQuery2 = "DELETE FROM CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS WHERE CHR_SYNC = 'N'"
                                                        self.database.executeUpdate(deleteQuery2, withArgumentsIn: [])

                                                        let deleteQuery3 = "DELETE FROM CPM_CUSTOMER_STICKER_BLOCK WHERE CHR_SYNC = 'N'"
                                                        self.database.executeUpdate(deleteQuery3, withArgumentsIn: [])

                                                        let deleteQuery4 = "DELETE FROM CPM_CUSTOMER_STICKER_BLOCK_REMOVE WHERE CHR_SYNC = 'N'"
                                                        self.database.executeUpdate(deleteQuery4, withArgumentsIn: [])
                                                        
//                                                        let deleteQuery5 = "DELETE FROM CPM_General_Receive WHERE chrSync = 'N'"
//                                                        self.database.executeUpdate(deleteQuery5, withArgumentsIn: [])
                                                    }

                                                    for txtFilePath in txtFilePaths{
                                                        let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                        let tableName = fileURL.path.fileName().split(separator: "$")

                                                        do {
                                                            let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)

                                                            let json = JSON.init(parseJSON:stringJSON)
                                                            self.deleteRecordForViolationIFFCO(tableName: String(tableName[0]), jsonArray: json)
                                                            isGoahead = self.insertRecordDynamicIFFCO(tableName: String(tableName[0]), jsonArray: json)
                                                            if(!isGoahead){
                                                                isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                break;
                                                            }
                                                        }
                                                        catch {
                                                            isGoahead = false
                                                            isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                            self.self.syncJSON.setValue("---Import File Failed---\(isGoaheadMessage)", forKey: "20")
                                                        }
                                                    }

                                                } else if(packageName == "com.ecubix.basfhkre-ret"){
                                                    //database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-Retailer-Database.db")?.path)
                                                    
                                                    self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("BASF-Retailer-Database.db")?.path)

                                                    if self.database.open()
                                                    {
                                                        let deleteQuery = "DELETE FROM CPM_Customer_Dispatch_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])

                                                        let deleteQuery2 = "DELETE FROM CPM_Customer_Receive_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery2, withArgumentsIn: [])

                                                        let deleteQuery3 = "DELETE FROM CPM_Customer_Sticker_Damage WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery3, withArgumentsIn: [])

                                                        let deleteQuery4 = "DELETE FROM CPM_Customer_Sticker_Damage_Remove WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery4, withArgumentsIn: [])
                                                        
                                                        let deleteQuery5 = "DELETE FROM CPM_General_Receive WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery5, withArgumentsIn: [])
                                                    }

                                                    for txtFilePath in txtFilePaths{
                                                        let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                        let tableName = fileURL.path.fileName().split(separator: "$")

                                                        do {
                                                            let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)

                                                            let json = JSON.init(parseJSON:stringJSON)
                                                            self.deleteRecordForViolation(tableName: String(tableName[0]), jsonArray: json)
                                                            isGoahead = self.insertRecordDynamic(tableName: String(tableName[0]), jsonArray: json)
                                                            if(!isGoahead){
                                                                isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                break;
                                                            }
                                                        }
                                                        catch {
                                                            isGoahead = false
                                                            isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                            self.self.syncJSON.setValue("---Import File Failed---\(isGoaheadMessage)", forKey: "20")
                                                        }
                                                    }

                                                } else {*/
//                                                    self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("BASF-HK-Database.db")?.path)
                                                    //self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("F_Re_CPM")?.path)

                                                    if self.database.open()
                                                    {
                                                        let deleteQuery = "DELETE FROM CPM_Customer_Dispatch_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])

                                                        let deleteQuery2 = "DELETE FROM CPM_Customer_Receive_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery2, withArgumentsIn: [])

                                                        let deleteQuery3 = "DELETE FROM CPM_Customer_Sticker_Damage WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery3, withArgumentsIn: [])

                                                        let deleteQuery4 = "DELETE FROM CPM_Customer_Sticker_Damage_Remove WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery4, withArgumentsIn: [])
                                                    }

                                                    for txtFilePath in txtFilePaths{
                                                        let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                        let tableName = fileURL.path.fileName().split(separator: "$")

                                                        do {
                                                            let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)

                                                            let json = JSON.init(parseJSON:stringJSON)
                                                            self.deleteRecordForViolation(tableName: String(tableName[0]), jsonArray: json)
                                                            isGoahead = self.insertRecordDynamic(tableName: String(tableName[0]), jsonArray: json)
                                                            if(!isGoahead){
                                                                isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                break;
                                                            }
                                                        }
                                                        catch {
                                                            isGoahead = false
                                                            isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                            self.self.syncJSON.setValue("---Import File Failed---\(isGoaheadMessage)", forKey: "20")
                                                        }
                                                    }
                                                //}

                                                self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "IMPORT_FILE_END")
                                                self.self.syncJSON.setValue("---Import File End---", forKey: "21")

                                                self.stopTimer()
                                                if(isGoahead){
                                                    self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "SYNC_END")
                                                    self.self.syncJSON.setValue("---Sync End---", forKey: "22")

                                                    self.writeLog(key: "SYNC_DONE", value: "")
                                                    self.updateProgress(type: 3, message: Message, min: 100, max: 100)
                                                }else{
                                                    self.writeLog(key: "SYNC_FAIL", value: isGoaheadMessage)
                                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 100, max: 100)
                                                    self.self.syncJSON.setValue("---Sync Failed---", forKey: "23")
                                                }
                                            }else{
                                                isGoahead = false
                                                isGoaheadMessage = "Error in extract zip file"
                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                self.self.syncJSON.setValue("---Sync Error---\(isGoaheadMessage)", forKey: "23")
                                            }
                                        }else{
                                            isGoahead = false
                                            isGoaheadMessage = "Error in download zip file"
                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                            self.updateProgress(type: 2, message: Message, min: 0, max: 0)
                                            self.self.syncJSON.setValue("---Sync Error---\(isGoaheadMessage)", forKey: "24")
                                        }
                                    }
                                }else{
                                    isGoaheadMessage = "NO_INTERNET"
                                    self.writeLog(key: "UPLOAD_ZIP_END", value: isGoaheadMessage)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                    self.self.syncJSON.setValue("---Sync Error---\(isGoaheadMessage)", forKey: "25")
                                }
                            }
                        } else if(isValid == "2"){
                            isGoaheadMessage = "Session expired. Please try again";
                            self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)

                            if(action == "Process") {
                                self.self.syncJSON.setValue("---Upload API Call Failed---\(isGoaheadMessage)", forKey: "26")
                            }else{
                                self.self.syncJSON.setValue("---Process API Call Failed---\(isGoaheadMessage)", forKey: "27")
                            }

                        } else if(isValid.lowercased() == "3" && action == "CHECK_DOWNLOAD") {
                            do {
                                sleep(120)
                                self.UploadDatabaseFileZipOld(web:web, fileData1:fileData1, zipName:zipName, action:"CHECK_DOWNLOAD", fileMainDir:fileMainDir, fileManager:fileManager, filePathSyncDownload:filePathSyncDownload, filePathSyncDownloadZip:filePathSyncDownloadZip,packageName: packageName)
                            }
                        } else{
                            isGoaheadMessage = Message;
                            self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        }
                    }catch{
                        isGoaheadMessage = "server error:@, please try again \(jsonData)";
                        self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)

                        if(action == "Process") {
                            self.self.syncJSON.setValue("---Upload API Call Failed---\(isGoaheadMessage)", forKey: "28")
                        }else{
                            self.self.syncJSON.setValue("---Process API Call Failed---\(isGoaheadMessage)", forKey: "29")
                        }
                    }
                case .failure(let error):
                    switch error {
                            case .sessionTaskFailed(URLError.timedOut):
                                print("Request timeout!")
                                if(action == "Process" || action == "CHECK_DOWNLOAD") {
                                    self.UploadDatabaseFileZipOld(web:web, fileData1:fileData1, zipName:zipName, action:"CHECK_DOWNLOAD", fileMainDir:fileMainDir, fileManager:fileManager, filePathSyncDownload:filePathSyncDownload, filePathSyncDownloadZip:filePathSyncDownloadZip,packageName: packageName)
                                }
                            default:
                                let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
                                self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                
                                let httpStatusCode = response.response?.statusCode
                                
                                if(action == "Process") {
                                    self.self.syncJSON.setValue("---Response Status Not Getting 200---\(httpStatusCode)", forKey: "30")
                                    self.self.syncJSON.setValue("---Upload API Call Failed---\(isGoaheadMessage)", forKey: "31")
                                }else{
                                    self.self.syncJSON.setValue("---Response Status Not Getting 200---\(httpStatusCode)", forKey: "32")
                                    self.self.syncJSON.setValue("---Process API Call Failed---\(isGoaheadMessage)", forKey: "33")
                                }
                            }

//                    if error._code == NSURLErrorTimedOut {
//                        print("Request timeout!")
//                        if(action == "Process" || action == "CHECK_DOWNLOAD") {
//                            self.UploadDatabaseFileZipOld(web:web, fileData1:fileData1, zipName:zipName, action:"CHECK_DOWNLOAD", fileMainDir:fileMainDir, fileManager:fileManager, filePathSyncDownload:filePathSyncDownload, filePathSyncDownloadZip:filePathSyncDownloadZip,packageName: packageName)
//                        }
//                    } else {
//
//                    }
                }
        }
    }

    
   /* func UploadDatabaseFileZipOld_Re(
      web: String, fileData1: String, zipName: String, action: String, fileMainDir: URL,
      fileManager: FileManager, filePathSyncDownload: URL, filePathSyncDownloadZip: URL,
      packageName: String, user_id: String, country_id: String, version_code: String, sync_date: String,
      sync_type: String
    ) {

      print("********************************")
      print("********************************")
      print("UploadDatabaseFileZipOld_Re")
      print("********************************")
      print("********************************")

      var isGoahead = true
      var isGoaheadMessage = ""

      var parameters = [String: String]()
      var headers = HTTPHeaders()
      //let headers = []
      //var parameters: NSMutableArray = []
      //var headers: NSArray = []

      //         if(packageName == "com.ecubix.iffcocpm"){
      print("web url:\(web)")

      parameters = [
        "FileArray": "\(action == "Process" || action == "CHECK_DOWNLOAD" ? "" : "\(fileData1)")",
        "FileName": zipName,
        "DeviceId": "\(imei)",
        "PersonId": "\(fk_EmpGlCode)",
        "Version": "\(version)",
        "SubModuleName": ClientName,
        "APIToken": "\(userName)",
        "Action": "\(action)",
        "JsonData": "{\"Sync_Log\":[\"\(requestJSONInString())\"]}",
        "ExtraFields": "",
        "SyncId": "\(action == "Process" || action == "CHECK_DOWNLOAD" ? "\(self.SyncId)" : "")",
      ]

      print("{\"Sync_Log\":[\"\(requestJSONInString())\"]}")

      if action == "Process" {
        print("\(parameters)")
      }

      let configuration = URLSessionConfiguration.default
      var timeout: Double = 2700

      if action == "Process" || action == "CHECK_DOWNLOAD" {
        if action == "Process" {
          if !isProgressFirstTime {
            isProgressFirstTime = true
            self.startTimmerDetails(min: 35, max: 45)
          }
        } else if action == "CHECK_DOWNLOAD" {
          if !isCheckDownloadFirstTime {
            isCheckDownloadFirstTime = true
            self.startTimmerDetails(min: 45, max: 60)
          }
        }
        timeout = 120
      }

      configuration.timeoutIntervalForRequest = timeout
      configuration.timeoutIntervalForResource = timeout  // seconds
      alamofireManager = Alamofire.Session(configuration: configuration)

      print("web:\(web)")

      self.writeLog(key: "UPLOAD_ZIP_API_START", value: "")
      self.alamofireManager!.request(web, method: .post, parameters: parameters, headers: headers)
        .validate(statusCode: 200..<300)

        .responseString { response in
          print("Success: \(response.result)")
          print(response)

          switch response.result {
          case .success(let jsonData):
            self.writeLog(key: "UPLOAD_ZIP_END", value: "SUCCESS")
            print("Success with JSON: \(jsonData)")

            // delete directory
            self.deleteDirNew(path: fileMainDir as NSURL)

            //print(jsonData)

            do {
              let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData

              let json =
                try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String: Any]

              let anyObj = JSON(json)

              var isValid: Bool = false
              var Message: String = ""
              var msg_code: String = ""
              var date_folder: String = ""
              var sync_done: String = ""

              if anyObj["status"].exists() {
                isValid = anyObj["status"].boolValue
                Message = anyObj["message"].stringValue
                msg_code = anyObj["msg_code"].stringValue
                date_folder = anyObj["date_folder"].stringValue
                sync_done = anyObj["sync_done"].stringValue
                self.SyncId = anyObj["sync_log_id"].intValue
              } else {
                isValid = anyObj["status"].boolValue
                Message = anyObj["message"].stringValue
                self.writeLog(key: "SYNC_ERROR", value: Message)
              }

              if anyObj["sync_log_id"].exists() {
                self.SyncId = anyObj["sync_log_id"].intValue
              }

              if isValid == true {

                self.UploadDatabaseFileZipOld_Re_Sync(
                  web_url_old: web, fileData1: fileData1, zipName: zipName, action: "Process",
                  fileMainDir: fileMainDir, fileManager: fileManager,
                  filePathSyncDownload: filePathSyncDownload,
                  filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName,
                  user_id: user_id, country_id: country_id, date_folder: date_folder,
                  version_code: version_code, sync_log_id: "\(self.SyncId)", sync_date: sync_date,
                  sync_type: sync_type, flag_code: "G", request_param: "")

              } else if isValid == false {
                isGoaheadMessage = "Session expired. Please try again"
                self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)

                if action == "Process" {
                  self.self.syncJSON.setValue(
                    "---Upload API Call Failed---\(isGoaheadMessage)", forKey: "26")
                } else {
                  self.self.syncJSON.setValue(
                    "---Process API Call Failed---\(isGoaheadMessage)", forKey: "27")
                }

              } else {
                isGoaheadMessage = Message
                self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
              }
            } catch {
              isGoaheadMessage = "server error:@, please try again \(jsonData)"
              self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
              self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)

              if action == "Process" {
                self.self.syncJSON.setValue(
                  "---Upload API Call Failed---\(isGoaheadMessage)", forKey: "28")
              } else {
                self.self.syncJSON.setValue(
                  "---Process API Call Failed---\(isGoaheadMessage)", forKey: "29")
              }
            }
          case .failure(let error):
            switch error {
            case .sessionTaskFailed(URLError.timedOut):
              print("Request timeout!")
              if action == "Process" || action == "CHECK_DOWNLOAD" {
                self.UploadDatabaseFileZipOld(
                  web: web, fileData1: fileData1, zipName: zipName, action: "CHECK_DOWNLOAD",
                  fileMainDir: fileMainDir, fileManager: fileManager,
                  filePathSyncDownload: filePathSyncDownload,
                  filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName)
              }
            default:
              let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
              self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
              self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)

              let httpStatusCode = response.response?.statusCode

              if action == "Process" {
                self.self.syncJSON.setValue(
                  "---Response Status Not Getting 200---\(String(describing: httpStatusCode))",
                  forKey: "30")
                self.self.syncJSON.setValue(
                  "---Upload API Call Failed---\(isGoaheadMessage)", forKey: "31")
              } else {
                self.self.syncJSON.setValue(
                  "---Response Status Not Getting 200---\(String(describing: httpStatusCode))",
                  forKey: "32")
                self.self.syncJSON.setValue(
                  "---Process API Call Failed---\(isGoaheadMessage)", forKey: "33")
              }
            }

          }
        }
    }*/
    
    
    func UploadDatabaseFileZipOld_Re_sync_porocess(web_url_old:String, fileData1:String, zipName:String, action:String, fileMainDir:URL, fileManager:FileManager, filePathSyncDownload:URL, filePathSyncDownloadZip:URL,packageName:String,user_id:String,country_id:String,date_folder:String,version_code:String,sync_log_id:String,sync_date:String,sync_type:String,flag_code:String,request_param:String,ZipFileName:String,customer_level:String,role_code:String) {
        
        print("********************************")
        print("********************************")
        print("UploadDatabaseFileZipOld_Re_sync_porocess")
        print("********************************")
        print("********************************")
        
        sleep(10)
        
        var isGoahead = true
        var isGoaheadMessage = ""
        
        var parameters_1 = [String: String]()
        let headers = HTTPHeaders()
        
        let web = self.urlUpload + "web_service/web_service_cpm/synchronization_android_cpm"
        print("web url:\(web)")
        /*var modifiedString_zipName = zipName
         //let gile_tempname = "\(zipName).zip"
         if !zipName.contains(".zip") {
         let modifiedString_zipName = zipName.replacingOccurrences(of: ".zip", with: "")
         }*/
        self.updateProgress(type: 444, message: "progress", min: 40, max: 41)
        objBody_data = JSON(["filename": ZipFileName,
                             "sync_log_id": sync_log_id,
                             "sync_date": sync_date,
                             "date_folder": date_folder,
                             "sync_type": sync_type,
                             "flag": sync_type])
        
        var request_param = JSON()
        request_param["auth"] = objBody_auth
        request_param["data"] = objBody_data
        
        print(request_param)
        
        let request_param_string = request_param.description
        
        print(request_param_string)
        
        parameters_1 = [
            //"FileArray": "\(fileData1)",
            "filename": ZipFileName,
            "imei_no": "\(imei)",
            //"PersonId": "\(fk_EmpGlCode)",
            "Version": "\(version)",
            //"SyncId": "\(self.SyncId)",
            "user_id": user_id,
            "country_id":country_id,
            "sync_date":sync_date,
            "date_folder":date_folder,
            "version_code":version_code,
            "sync_log_id":sync_log_id,
            "sync_type":sync_type,
            "flag":flag_code,
            "request_param": request_param_string
        ]
        
        print(parameters_1)
        
        print("{\"Sync_Log\":[\"\(requestJSONInString())\"]}")
        let configuration = URLSessionConfiguration.default
        var timeout: Double = 1800000
        
        if(action == "Process" || action == "CHECK_DOWNLOAD"){
            if(action == "Process"){
                if(!isProgressFirstTime){
                    isProgressFirstTime=true;
                    //                self.startTimmerDetails(min: 35, max: 45)
                }
            } else if(action == "CHECK_DOWNLOAD"){
                if(!isCheckDownloadFirstTime){
                    isCheckDownloadFirstTime=true;
                    //                self.startTimmerDetails(min: 45, max: 60)
                }
            }
            //timeout = 120
        }
        
        configuration.timeoutIntervalForRequest = timeout
        configuration.timeoutIntervalForResource = timeout // seconds
        alamofireManager = Alamofire.Session(configuration: configuration)
        
        self.writeLog(key: "UPLOAD_ZIP_API_START", value: "")
        self.alamofireManager!.request(web, method: .post, parameters: parameters_1,headers:headers).validate(statusCode: 200..<300)
        
            .responseString { response in
                print("Success: \(response.result)")
                print(response)
                
                switch response.result {
                case .success(let jsonData):
                    self.writeLog(key: "UPLOAD_ZIP_END", value: "SUCCESS")
                    print("Success with JSON: \(jsonData)")
                    self.updateProgress(type: 444, message: "progress", min: 50, max: 51)
                    // delete directory
                    self.deleteDirNew(path: fileMainDir as NSURL)
                    
                    //print(jsonData)
                    
                    do{
                        let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData
                        
                        let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]
                        
                        let anyObj = JSON(json)
                        
                        var isValid:Bool = false
                        var Message:String = ""
                        var msg_code:String = ""
                        var announcement_count:String = ""
                        var lang_code:String = ""
                        var download_url:String = ""
                        var user_manual_url:String = ""
                        var is_manual_updated:String = ""
                        var user_faq_url:String = ""
                        var is_faq_updated:String = ""
                        var sync_log_id:String = ""
                        var kyc_url:String = ""
                        
                        if anyObj["status"].exists(){
                            isValid =  anyObj["status"].boolValue
                            Message =  anyObj["message"].stringValue
                            msg_code =  anyObj["msg_code"].stringValue
                            announcement_count =  anyObj["announcement_count"].stringValue
                            lang_code =  anyObj["lang_code"].stringValue
                            download_url =  anyObj["download_url"].stringValue
                            user_manual_url =  anyObj["user_manual_url"].stringValue
                            is_manual_updated =  anyObj["is_manual_updated"].stringValue
                            user_faq_url =  anyObj["user_faq_url"].stringValue
                            is_faq_updated =  anyObj["is_faq_updated"].stringValue
                            sync_log_id = "\(self.SyncId)" // anyObj["sync_log_id"].stringValue // SAGARZALA CHANGE 12/1/24
                            kyc_url =  anyObj["kyc_url"].stringValue
                            /*self.SyncId = anyObj["sync_log_id"].intValue*/ // SAGAR ZALA CHANGE
                        }else{
                            isValid =  anyObj["status"].boolValue
                            Message =  anyObj["message"].stringValue
                            self.writeLog(key: "SYNC_ERROR", value: Message)
                        }
                        
                        print("isTransactionSync_RE:\(self.isTransactionSync_RE)")
                        print("isMasterSync_RE:\(self.isMasterSync_RE)")
                        
                        if(isValid == true) {
                            
                            if(sync_type == "T"){
                                if(customer_level == "L4" && role_code != "FO"){
                                    
                                    self.handleResponseForTransaction(download_url: download_url, web_url_old: web, fileData1: fileData1, zipName: zipName, action: action, fileMainDir: fileMainDir, fileManager: fileManager, filePathSyncDownload: filePathSyncDownload, filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName, user_id: user_id, country_id: country_id, date_folder: date_folder, version_code: version_code, sync_log_id: sync_log_id, sync_date: sync_date, sync_type: "T", flag_code: "T", request_param: "", ZipFileName: ZipFileName, customer_level: customer_level, role_code: role_code)
                                }else{
                                    self.UploadDatabaseFileZipOld_Re_sync_porocess(
                                        web_url_old: web, fileData1: fileData1, zipName: zipName, action: "Process",
                                        fileMainDir: filePathSyncDownload, fileManager: fileManager,
                                        filePathSyncDownload: filePathSyncDownload,
                                        filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName,
                                        user_id: user_id, country_id: country_id, date_folder: date_folder,
                                        version_code: version_code, sync_log_id: "\(self.SyncId)", sync_date: sync_date,
                                        sync_type: "I", flag_code: "I", request_param: "", ZipFileName:ZipFileName,customer_level:customer_level,role_code:role_code)
                                }
                            }else if(sync_type == "G"){
                                self.handleResponseForTransaction(download_url: download_url, web_url_old: web, fileData1: fileData1, zipName: zipName, action: action, fileMainDir: fileMainDir, fileManager: fileManager, filePathSyncDownload: filePathSyncDownload, filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName, user_id: user_id, country_id: country_id, date_folder: date_folder, version_code: version_code, sync_log_id: sync_log_id, sync_date: sync_date, sync_type: "G", flag_code: "G", request_param: "", ZipFileName: ZipFileName, customer_level: customer_level, role_code: role_code)
                            }else if(sync_type == "P"){
                                self.handleResponseForTransaction(download_url: download_url, web_url_old: web, fileData1: fileData1, zipName: zipName, action: action, fileMainDir: fileMainDir, fileManager: fileManager, filePathSyncDownload: filePathSyncDownload, filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName, user_id: user_id, country_id: country_id, date_folder: date_folder, version_code: version_code, sync_log_id: sync_log_id, sync_date: sync_date, sync_type: "P", flag_code: "P", request_param: "", ZipFileName: ZipFileName, customer_level: customer_level, role_code: role_code)
                            }else if(sync_type == "I"){
                                self.handleResponseForTransaction(download_url: download_url, web_url_old: web, fileData1: fileData1, zipName: zipName, action: action, fileMainDir: fileMainDir, fileManager: fileManager, filePathSyncDownload: filePathSyncDownload, filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName, user_id: user_id, country_id: country_id, date_folder: date_folder, version_code: version_code, sync_log_id: sync_log_id, sync_date: sync_date, sync_type: "I", flag_code: "I", request_param: "", ZipFileName: ZipFileName, customer_level: customer_level, role_code: role_code)
                            }
                            
                            
                        } else if(isValid == false){
                            isGoaheadMessage = "Session expired. Please try again";
                            self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                            //self.updateProgress(type: 555, message: isGoaheadMessage, min: 0, max: 0)
                            
                            if(action == "Process") {
                                self.self.syncJSON.setValue("---Upload API Call Failed---\(isGoaheadMessage)", forKey: "26")
                            }else{
                                self.self.syncJSON.setValue("---Process API Call Failed---\(isGoaheadMessage)", forKey: "27")
                            }
                            
                            let errorMssg = "Getting Error in Process API : \(Message)"
                            let response = "FLAG!!3" +
                                           "||" +
                                           "errorCode!!\(msg_code)" +
                                           "||" +
                                           "errorMsg!!\(Message)" +
                                           "||" +
                                           "objProcess!! ERROR" +
                                           "||" +
                                           "syncLogID!!\(self.SyncId)"
                            
                            OperationQueue.main.addOperation {
                                self.updateProgress(type: 555, message: "Fail@@\(response)", min: 52, max: 53)
                            }
                            
                        } /*else if(isValid.lowercased() == "3" && action == "CHECK_DOWNLOAD") {
                           do {
                           sleep(120)
                           self.UploadDatabaseFileZipOld(web:web, fileData1:fileData1, zipName:zipName, action:"CHECK_DOWNLOAD", fileMainDir:fileMainDir, fileManager:fileManager, filePathSyncDownload:filePathSyncDownload, filePathSyncDownloadZip:filePathSyncDownloadZip,packageName: packageName)
                           }
                           }*/ else{
                               isGoaheadMessage = Message;
                               self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                               //self.updateProgress(type: 555, message: isGoaheadMessage, min: 0, max: 0)
                               
                               let errorMssg = "Getting Error in Process API : \(Message)"
                               let response = "FLAG!!3" +
                                              "||" +
                                              "errorCode!!\(msg_code)" +
                                              "||" +
                                              "errorMsg!!\(Message)" +
                                              "||" +
                                              "objProcess!!ERROR" +
                                              "||" +
                                              "syncLogID!!\(self.SyncId)"
                               
                               OperationQueue.main.addOperation {
                                   self.updateProgress(type: 555, message: "Fail@@\(response)", min: 52, max: 53)
                               }
                           }
                        
                        
                        
                        
                    }catch{
                        isGoaheadMessage = "server error:@, please try again \(jsonData)";
                        self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                        //self.updateProgress(type: 555, message: isGoaheadMessage, min: 0, max: 0)
                        
                        if(action == "Process") {
                            self.self.syncJSON.setValue("---Upload API Call Failed---\(isGoaheadMessage)", forKey: "28")
                        }else{
                            self.self.syncJSON.setValue("---Process API Call Failed---\(isGoaheadMessage)", forKey: "29")
                        }
                        
                        let errorMssg = "Getting Error in Process API : \(jsonData)"
                        let response = "FLAG!!3" +
                                       "||" +
                                       "errorCode!!105" +
                                       "||" +
                                       "errorMsg!!\(errorMssg)" +
                                       "||" +
                                       "objProcess!!ERROR" +
                                       "||" +
                                       "syncLogID!!\(self.SyncId)"
                        
                        OperationQueue.main.addOperation {
                            self.updateProgress(type: 555, message: "Fail@@\(response)", min: 52, max: 53)
                        }
                    }
                case .failure(let error):
                    switch error {
                    case .sessionTaskFailed(URLError.timedOut):
                        print("Request timeout!")
                        let errorMssg = "Getting Error in Process API : \(error)"
                        let response = "FLAG!!3" +
                                       "||" +
                                       "errorCode!!105" +
                                       "||" +
                                       "errorMsg!!\(errorMssg)" +
                                       "||" +
                                       "objProcess!!ERROR" +
                                       "||" +
                                       "syncLogID!!\(self.SyncId)"
                        
                        OperationQueue.main.addOperation {
                            self.updateProgress(type: 555, message: "Fail@@\(response)", min: 52, max: 53)
                        }
                    default:
                        let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
                        self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                        //self.updateProgress(type: 555, message: isGoaheadMessage, min: 0, max: 0)
                        
                        let httpStatusCode = response.response?.statusCode
                        
                        
                        let errorMssg = "Getting Error in Process API : \(error)"
                        let response = "FLAG!!3" +
                                       "||" +
                                       "errorCode!!106" +
                                       "||" +
                                       "errorMsg!!\(errorMssg)" +
                                       "||" +
                                       "objProcess!!ERROR" +
                                       "||" +
                                       "syncLogID!!\(self.SyncId)"
                        
                        OperationQueue.main.addOperation {
                            self.updateProgress(type: 555, message: "Fail@@\(response)", min: 52, max: 53)
                        }
                        
                        
                    }
                }
            }
    }
    
    func handleResponseForTransaction(download_url:String,web_url_old:String, fileData1:String, zipName:String, action:String, fileMainDir:URL, fileManager:FileManager, filePathSyncDownload:URL, filePathSyncDownloadZip:URL,packageName:String,user_id:String,country_id:String,date_folder:String,version_code:String,sync_log_id:String,sync_date:String,sync_type:String,flag_code:String,request_param:String,ZipFileName:String,customer_level:String,role_code:String){
        
        if(isMasterSync_RE && isTransactionSync_RE) && sync_type == "T"{
            self.UploadDatabaseFileZipOld_Re_sync_porocess(
              web_url_old: web_url_old, fileData1: fileData1, zipName: zipName, action: "Process",
              fileMainDir: filePathSyncDownload, fileManager: fileManager,
              filePathSyncDownload: filePathSyncDownload,
              filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName,
              user_id: user_id, country_id: country_id, date_folder: date_folder,
              version_code: version_code, sync_log_id: "\(self.SyncId)", sync_date: sync_date,
              sync_type: "G", flag_code: "G", request_param: "", ZipFileName:ZipFileName,customer_level:customer_level,role_code:role_code)
        }else{
            var isGoahead = false
            var isGoaheadMessage = "Error in extract zip file"
            //FILE_DOWNLOAD_DEV
            
            print(download_url)
            
            let modifiedString = download_url.replacingOccurrences(of: "\\", with: "/")
            
            print(modifiedString)
            
            
            
            self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "PROCESS_API_CALL_END")
            self.self.syncJSON.setValue("---Process API Call End---", forKey: "16")
            
            self.writeLog(key: "UPLOAD_ZIP_API_SUCCESS", value: "")
            if (self.isConnectedToNetwork() == true ){
                
                let destination: DownloadRequest.Destination = { _, _ in
                    //let documentsURL = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask)[0]
                    let fileURL = filePathSyncDownload.appendingPathComponent("\(zipName)")
                    return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
                }
                
                self.stopTimer()
                self.updateProgress(type: 444, message: "progress", min: 61, max: 75)
                self.startTimmerDetails(min: 61, max: 75)
                
                self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "DOWNLOAD_START")
                self.self.syncJSON.setValue("---Download DB Start---", forKey: "17")
                
                print(download_url)
                print(destination)
                
                //AF.download(Response, to: destination).response { response in
                AF.download(modifiedString, to: destination).response { response in
                    //if response.error == nil, let zipPath = response.destinationURL?.path {
                    if response.error == nil, let zipPath = response.fileURL?.path {
                        self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "DOWNLOAD_END")
                        self.self.syncJSON.setValue("---Download DB End---", forKey: "18")
                        
                        self.stopTimer()
                        self.updateProgress(type: 444, message: "progress", min: 75, max: 98)
                        self.startTimmerDetails(min: 75, max: 98)
                        
                        self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "IMPORT_FILE_START")
                        self.self.syncJSON.setValue("---Import File Start---", forKey: "19")
                        
                        self.createDir(path: filePathSyncDownloadZip as NSURL)
                        
                        sleep(5)
                        
                        let fileManager = FileManager.default
                        if fileManager.fileExists(atPath: zipPath) {
                            print("file found")
                        }else{
                            print("file nit found")
                        }
                        
                        
                        
                        if(self.unzipFile(zipPath: (filePathSyncDownload.appendingPathComponent("\(zipName)").path), destinationPath: filePathSyncDownloadZip.path)){
                            
                            let enumerator = fileManager.enumerator(atPath: filePathSyncDownloadZip.path)
                            let filePaths = enumerator?.allObjects as! [String]
                            // let txtFilePaths = filePaths.filter{$0.contains(".txt")}
                            
                            
                            //DATA_INSERT_RE
                            // TODO: impliment data insert over here
                            //insert_re_methods()
                            if(sync_type == "G"){
                                
                                saveMasterData(downloadFileName: filePathSyncDownloadZip.path,database: self.database, zipFolderName: ZipFileName,user_id:user_id,country_id:country_id,customer_level:customer_level,role_code:role_code)
                                
                            }else if(sync_type == "T" || sync_type == "I"){
                                
                                if(customer_level == "L4"){
                                    saveWHMasterData(downloadFileName: filePathSyncDownloadZip.path,database: self.database, zipFolderName: ZipFileName,user_id:user_id,country_id:country_id,customer_level:customer_level,role_code:role_code)
                                }else if(customer_level == "L3"){
                                    saveDistMasterData(downloadFileName: filePathSyncDownloadZip.path,database: self.database, zipFolderName: ZipFileName,user_id:user_id,country_id:country_id,customer_level:customer_level,role_code:role_code)
                                }else if(customer_level == "L2" || role_code == "FO"){
                                    saveRetailerTransactionData(downloadFileName: filePathSyncDownloadZip.path,database: self.database, zipFolderName: ZipFileName,user_id:user_id,country_id:country_id,customer_level:customer_level,role_code:role_code)
                                }
                                
                            }
                            
                            
                            self.stopTimer()
                            self.callGetUserCurrentPointsAPI(web_url_old: web_url_old, fileData1: fileData1, zipName: zipName, action: "Process",
                                                             fileMainDir: filePathSyncDownload, fileManager: fileManager,
                                                             filePathSyncDownload: filePathSyncDownload,
                                                             filePathSyncDownloadZip: filePathSyncDownloadZip, packageName: packageName,
                                                             user_id: user_id, country_id: country_id, date_folder: date_folder,
                                                             version_code: version_code, sync_log_id: "\(self.SyncId)", sync_date: sync_date,
                                                             sync_type: sync_type, flag_code: sync_date, request_param: "", ZipFileName:ZipFileName,customer_level:customer_level,role_code:role_code)
                        }else{
                            isGoahead = false
                            isGoaheadMessage = "Error in extract zip file"
                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                            
                            let errorMssg = "Getting Error in extract zip file"
                            let response = "FLAG!!4" +
                                           "||" +
                                           "errorCode!!107" +
                                           "||" +
                                           "errorMsg!!\(errorMssg)" +
                                           "||" +
                                           "objProcess!!ERROR" +
                                           "||" +
                                           "syncLogID!!\(self.SyncId)"
                            

                            self.updateProgress(type: 555, message: "Fail@@\(response)", min: 75, max: 90)

                            
//                            self.updateProgress(type: 555, message: isGoaheadMessage, min: 0, max: 0)
                            self.self.syncJSON.setValue("---Sync Error---\(isGoaheadMessage)", forKey: "23")
                        }
                    }else{
                        isGoahead = false
                        isGoaheadMessage = "Error in download zip file"
                        self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
//                        self.updateProgress(type: 555, message: "Error in download zip file", min: 0, max: 0)
                        let errorMssg = "Getting Error in download zip file"
                        let response = "FLAG!!4" +
                                       "||" +
                                       "errorCode!!108" +
                                       "||" +
                                       "errorMsg!!\(errorMssg)" +
                                       "||" +
                                       "objProcess!!ERROR" +
                                       "||" +
                                       "syncLogID!!\(self.SyncId)"
                        

                        self.updateProgress(type: 555, message: "Fail@@\(response)", min: 75, max: 90)
                        
                        
                        self.self.syncJSON.setValue("---Sync Error---\(isGoaheadMessage)", forKey: "24")
                    }
                }
            }else{
                isGoaheadMessage = "NO_INTERNET"
                self.writeLog(key: "UPLOAD_ZIP_END", value: isGoaheadMessage)
//                self.updateProgress(type: 555, message: isGoaheadMessage, min: 0, max: 0)
                let errorMssg = "NO INTERNET CONNECTION"
                let response = "FLAG!!4" +
                               "||" +
                               "errorCode!!109" +
                               "||" +
                               "errorMsg!!\(errorMssg)" +
                               "||" +
                               "objProcess!!ERROR" +
                               "||" +
                               "syncLogID!!\(self.SyncId)"
                

                self.updateProgress(type: 555, message: "Fail@@\(response)", min: 75, max: 90)
                
                
                self.self.syncJSON.setValue("---Sync Error---\(isGoaheadMessage)", forKey: "25")
            }
        }
    }
    
    func callGetUserCurrentPointsAPI(web_url_old:String, fileData1:String, zipName:String, action:String, fileMainDir:URL, fileManager:FileManager, filePathSyncDownload:URL, filePathSyncDownloadZip:URL,packageName:String,user_id:String,country_id:String,date_folder:String,version_code:String,sync_log_id:String,sync_date:String,sync_type:String,flag_code:String,request_param:String,ZipFileName:String,customer_level:String,role_code:String){
        
        var isGoahead = true
        var isGoaheadMessage = ""
        
        var parameters = [String: String]()
        let headers = HTTPHeaders()
        
        //updateTollerTotalSyncLogData
        let web = self.urlUpload + "web_service/web_service_cpm/getCurrentSchemePoints"
        //let web = self.urlUpload + "web_service/web_service_cpm/updateTollerTotalSyncLogData"
        print("web url:\(web)")
        
        objBody_data = JSON(["country_id": country_id,
                             "user_id": user_id,
                             "date_folder": date_folder,
                            ])
        
        var request_param = JSON()
        request_param["auth"] = objBody_auth
        request_param["data"] = objBody_data
        
        print(request_param)
        
        let request_param_string = request_param.description
        
        print(request_param_string)
        
        parameters = [
            "date_folder":date_folder,
            "user_id":user_id,
            "country_id":country_id,
            "request_param": request_param_string
        ]
        
        print(parameters)
        
        //print("{\"Sync_Log\":[\"\(requestJSONInString())\"]}")
        let configuration = URLSessionConfiguration.default
        var timeout: Double = 1800000
        
        configuration.timeoutIntervalForRequest = timeout
        configuration.timeoutIntervalForResource = timeout // seconds
        alamofireManager = Alamofire.Session(configuration: configuration)
        
        self.alamofireManager!.request(web, method: .post, parameters: parameters, headers: headers)
            .validate(statusCode: 200..<300)
        
            .responseString { response in
                print("Success: \(response.result)")
                print(response)
                
                switch response.result {
                case .success(let jsonData):
                    self.writeLog(key: "UPLOAD_ZIP_END", value: "SUCCESS")
                    print("Success with JSON: \(jsonData)")
                    
                    // delete directory
                    //self.deleteDirNew(path: fileMainDir as NSURL)
                    
                    //print(jsonData)
                    
                    
                    do {
                        let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData
                        
                        let json =
                        try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String: Any]
                        
                        let anyObj = JSON(json)
                        
                        var isValid: Bool = true
                        
                        if isValid == true {
                            
                            self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "SYNC_END")
                            self.self.syncJSON.setValue("---Sync End---", forKey: "22")
                            
                            self.writeLog(key: "SYNC_DONE", value: "")
//                            self.updateProgress(type: 666, message: "Sync Done", min: 100, max: 100)
//                            self.updateProgress(type: 444, message: "progress", min: 100, max: 100)
                            
                            
                        }
                        
                        let errorMssg = "Sync Success Done"
                        let response = "FLAG!!7" +
                        "||" +
                        "errorCode!!666" +
                        "||" +
                        "errorMsg!!\(errorMssg)" +
                        "||" +
                        "objProcess!!Success" +
                        "||" +
                        "syncLogID!!\(self.SyncId)"
                        
                        self.updateProgress(type: 666, message: "Fail@@\(response)", min: 100, max: 100)
//                        self.updateProgress(type: 666, message: "Sync Done", min: 100, max: 100)
                        self.updateProgress(type: 444, message: "progress", min: 100, max: 100)
                        
                    } catch {
                        isGoaheadMessage = "server error:@, please try again \(jsonData)"
                        self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                        //self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        let errorMssg = "Sync Success Done"
                        let response = "FLAG!!7" +
                        "||" +
                        "errorCode!!666" +
                        "||" +
                        "errorMsg!!\(errorMssg)" +
                        "||" +
                        "objProcess!!Success" +
                        "||" +
                        "syncLogID!!\(self.SyncId)"
                        
                        self.updateProgress(type: 666, message: "Fail@@\(response)", min: 100, max: 100)
                        
//                        self.updateProgress(type: 666, message: "Sync Done", min: 100, max: 100)
                        self.updateProgress(type: 444, message: "progress", min: 100, max: 100)
                        if action == "Process" {
                            self.self.syncJSON.setValue(
                                "---Upload API Call Failed---\(isGoaheadMessage)", forKey: "28")
                        } else {
                            self.self.syncJSON.setValue(
                                "---Process API Call Failed---\(isGoaheadMessage)", forKey: "29")
                        }
                    }
                case .failure(let error):
                    switch error {
                        
//                        self.updateProgress(type: 666, message: "Sync Done", min: 100, max: 100)
//                        self.updateProgress(type: 444, message: "progress", min: 100, max: 100)
                        
                    case .sessionTaskFailed(URLError.timedOut):
                        print("Request timeout!")
                        if action == "Process" || action == "CHECK_DOWNLOAD" {
                            
                            let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
                            self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        }
                        let errorMssg = "Sync Success Done"
                        let response = "FLAG!!7" +
                        "||" +
                        "errorCode!!666" +
                        "||" +
                        "errorMsg!!\(errorMssg)" +
                        "||" +
                        "objProcess!!Success" +
                        "||" +
                        "syncLogID!!\(self.SyncId)"
                        
                        self.updateProgress(type: 666, message: "Fail@@\(response)", min: 100, max: 100)
                        
//                        ÷self.updateProgress(type: 666, message: "Sync Done", min: 100, max: 100)
                        self.updateProgress(type: 444, message: "progress", min: 100, max: 100)
                    default:
                        let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
                        self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        
                        let httpStatusCode = response.response?.statusCode
                        
                        if action == "Process" {
                            self.self.syncJSON.setValue(
                                "---Response Status Not Getting 200---\(String(describing: httpStatusCode))",
                                forKey: "30")
                            self.self.syncJSON.setValue(
                                "---Upload API Call Failed---\(isGoaheadMessage)", forKey: "31")
                        } else {
                            self.self.syncJSON.setValue(
                                "---Response Status Not Getting 200---\(String(describing: httpStatusCode))",
                                forKey: "32")
                            self.self.syncJSON.setValue(
                                "---Process API Call Failed---\(isGoaheadMessage)", forKey: "33")
                        }
                        
                        let errorMssg = "Sync Success Done"
                        let response = "FLAG!!7" +
                        "||" +
                        "errorCode!!666" +
                        "||" +
                        "errorMsg!!\(errorMssg)" +
                        "||" +
                        "objProcess!!Success" +
                        "||" +
                        "syncLogID!!\(self.SyncId)"
                        
                        self.updateProgress(type: 666, message: "Fail@@\(response)", min: 100, max: 100)
                        
//                        self.updateProgress(type: 666, message: "Sync Done", min: 100, max: 100)
                        self.updateProgress(type: 444, message: "progress", min: 100, max: 100)
                    }
                    
                }
            }
    }
    
    
    func downloadFile(fromURL url: URL, completion: @escaping (URL?, Error?) -> Void) {
        let downloadTask = URLSession.shared.downloadTask(with: url) { (tempURL, response, error) in
            if let error = error {
                completion(nil, error)
                return
            }

            guard let httpResponse = response as? HTTPURLResponse, (200...299).contains(httpResponse.statusCode) else {
                let statusCode = (response as? HTTPURLResponse)?.statusCode ?? 0
                let error = NSError(domain: "HTTP", code: statusCode, userInfo: nil)
                completion(nil, error)
                return
            }

            guard let tempURL = tempURL else {
                let error = NSError(domain: "Download", code: 0, userInfo: [NSLocalizedDescriptionKey: "No temporary file URL"])
                completion(nil, error)
                return
            }

            let documentsDirectory = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask)[0]
            let destinationURL = documentsDirectory.appendingPathComponent(url.lastPathComponent)

            do {
                try FileManager.default.moveItem(at: tempURL, to: destinationURL)
                completion(destinationURL, nil)
            } catch {
                completion(nil, error)
            }
        }

        downloadTask.resume()
    }

    
    
    func FileSyncDataForLAB(userName:String, fk_EmpGlCode:String, ClientName:String, version:String, imei:String, uploadMethod:String, logUploadMethod:String, urlUpload:String, databaseName:String,isDbEncripted:String)->String{

        self.userName=userName;
        self.fk_EmpGlCode=fk_EmpGlCode;
        self.ClientName=ClientName;
        self.version=version;
        self.imei=imei;
        self.uploadMethod=uploadMethod;
        self.logUploadMethod=logUploadMethod;
        self.urlUpload=urlUpload;

        writeLog(key: "FB_SYNC_START", value: "")
        updateProgress(type: 1, message: "progress", min: 1, max: 7)

        var isGoahead:Bool = true
        var isGoaheadMessage:String = ""

        let date = Date()
        let calendar = Calendar.current

        let year = calendar.component(.year, from: date)
        let month = calendar.component(.month, from: date)
        let day = calendar.component(.day, from: date)

        let hour = calendar.component(.hour, from: date)
        let minute = calendar.component(.minute, from: date)
        let second = calendar.component(.second, from: date)

        let fileManager = FileManager.default

        let filePathSyncBackUp = documentsPath.appendingPathComponent("SyncBackup")
        let filePathSyncDownload = documentsPath.appendingPathComponent("SyncDownload")

        let dateString = String(format: "%02ld%02ld%ld_%02ld%02ld%02ld", day, month, year, hour, minute, second)

        //let fName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(version)"
        let fName = "\(dateString)_\(version)"
        let fileMainDir = filePathSyncBackUp?.appendingPathComponent("\(day)/\(fName)")
        let zipName = "\(fName).zip"
        let filePathSyncDownloadZip = filePathSyncDownload!.appendingPathComponent(fName)
        let fileMainDirZip = filePathSyncBackUp?.appendingPathComponent("\(day)/\(zipName)")

        let dirLS = fileMainDir?.appendingPathComponent("LS")
        let dirLMA = fileMainDir?.appendingPathComponent("LMA")
        let dirLMR = fileMainDir?.appendingPathComponent("LMR")
        let dirLD = fileMainDir?.appendingPathComponent("LD")
        let dirLSD = fileMainDir?.appendingPathComponent("LSD")
        let dirLCD = fileMainDir?.appendingPathComponent("LCD")
        let dirLCDPD = fileMainDir?.appendingPathComponent("LCDPD")

        if(!deleteDir(path: filePathSyncBackUp! as NSURL)){
            isGoahead = false;
            isGoaheadMessage = "error:101";
        }

        DispatchQueue.global(qos: .background).async {

            self.deleteDirNew(path: filePathSyncDownload! as NSURL)
            self.createDir(path: filePathSyncBackUp! as NSURL)
            self.createDir(path: filePathSyncDownload! as NSURL)
            self.createDir(path: fileMainDir! as NSURL)

            self.createDir(path: dirLS! as NSURL)
            self.createDir(path: dirLMA! as NSURL)
            self.createDir(path: dirLMR! as NSURL)
            self.createDir(path: dirLD! as NSURL)
            self.createDir(path: dirLSD! as NSURL)
            self.createDir(path: dirLCD! as NSURL)
            self.createDir(path: dirLCDPD! as NSURL)

            let fileLoginDetails$_1 = "LoginDetails$_1.txt";
            //let fileCPM_Customer_Dispatch$_1 = "CPM_Customer_Dispatch$_1.txt";
            //let fileCPM_Customer_Dispatch_Product_Details$_1 = "CPM_Customer_Dispatch_Product_Details$_1.txt";
            //let fileCPM_Customer_Receive$_1 = "CPM_Customer_Receive$_1.txt";
            //let fileCPM_Customer_Receive_Product_Details$_1 = "CPM_Customer_Receive_Product_Details$_1.txt";

            /*DispatchQueue.main.async  {

             }*/

            let jsonLoginDetails = self.getJsonFromTable(database: self.database, tableName: "LoginDetails")
            self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginDetails$_1, sBody: "\(jsonLoginDetails)")

            sleep(2)
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 7, max: 10)
            }
            //let jsonCPM_Customer_Dispatch = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Dispatch")
            //self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Dispatch$_1, sBody: "\(jsonCPM_Customer_Dispatch)")


            //DispatchQueue.main.async  {
            //    self.updateProgress(type: 1, message: "progress", min: 10, max: 12)
            //}
            //sleep(2)
            //let jsonCPM_Customer_Receive = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Receive")
            //self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Receive$_1, sBody: "\(jsonCPM_Customer_Receive)")


            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 12, max: 15)
            }
            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_STORE, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLS?.path)!)


            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 15, max: 18)
            }
            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_MATERIAL_ALLOCATION, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLMA?.path)!)


            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 18, max: 20)
            }
            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_MATERIAL_RETURN, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLMR?.path)!)

            sleep(2)

            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_DISPOSAL, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLD?.path)!)

            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 20, max: 22)
            }
            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_CUSTOMER_DISPATCH, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLCD?.path)!)

            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_CUSTOMER_DISPATCH_PRODUCT_DETAILS, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLCDPD?.path)!)

            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_STICKER_DETAILS, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLSD?.path)!)

            sleep(2)
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 22, max: 25)
            }

            self.writeLog(key: "CREATE_ZIP_START", value: "")

            var success = false

            if(isDbEncripted == "true"){
                // Create ZIP FIle
                success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path,
                                                     withContentsOfDirectory: fileMainDir!.path,
                                                     keepParentDirectory: false,
                                                     compressionLevel: 5,
                                                     password: self.ZipPassword,
                                                     aes: true,
                                                     progressHandler: nil)
                //var success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path, withContentsOfDirectory: fileMainDir!.path)
                if(success){
                    self.writeLog(key: "CREATE_ZIP_END", value: "Success")
                    isGoahead = true
                }else{
                    self.writeLog(key: "CREATE_ZIP_END", value: "Error creating zip")
                    isGoahead = false
                    isGoaheadMessage = "Error creating zip"
                }
            }else{
                success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path, withContentsOfDirectory: fileMainDir!.path)
                if(success){
                    self.writeLog(key: "CREATE_ZIP_END", value: "Success")
                    isGoahead = true
                }else{
                    self.writeLog(key: "CREATE_ZIP_END", value: "Error creating zip")
                    isGoahead = false
                    isGoaheadMessage = "Error creating zip"
                }
            }

            //success = false
            //isGoahead = false

            var fileData: NSData? = nil
            var fileData1:String  = ""
            if(success){
                do {
                    self.writeLog(key: "ENCODE_ZIP_START", value: "")
                    var fileSizeValue: UInt64 = 0
                    do {
                        let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: fileMainDirZip!.path)

                        if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                            fileSizeValue = UInt64(fileNumberSize)
                            self.writeLog(key: "UPLOAD_ZIP_SIZE", value: "\(fileSizeValue)")
                            let byteCountFormatter = ByteCountFormatter()
                            byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                        }
                    } catch {
                        //print(error.localizedDescription)
                    }

                    try fileData = NSData(contentsOfFile: fileMainDirZip!.path, options: NSData.ReadingOptions.mappedIfSafe)

                    fileData1 = fileData!.base64EncodedString(options: NSData.Base64EncodingOptions([]))
                    self.writeLog(key: "ENCODE_ZIP_END", value: "")
                }
                catch let error as NSError {
                    self.writeLog(key: "ENCODE_ZIP_ERROR", value: "\(error)")
                    //print("Ooops! Something went wrong : \(error)")
                    isGoahead = false;
                    isGoaheadMessage = "error:104"
                }
            }

            self.updateProgress(type: 1, message: "progress", min: 26, max: 30)
            self.startTimmerDetails(min: 30, max: 60)
            // Call API
            if(isGoahead){
                self.writeLog(key: "UPLOAD_ZIP_START", value: "")
                let web = urlUpload+uploadMethod
                print(web)
                print("FileName \(zipName)")
                print("DeviceId \(imei)")
                print("PersonId \(fk_EmpGlCode)")
                print("Version \(version)")
                print("APIToken \(userName)")

                let parameters = [
                    "FileArray": "\(fileData1)",
                    "FileName": zipName,
                    "DeviceId": "\(imei)",
                    "PersonId": "\(fk_EmpGlCode)",
                    "Version": "\(version)",
                    "SubModuleName": ClientName,
                    "APIToken": "\(userName)",
                ]

                /*let parameters = [
                 "FileArray": "\(fileData1)",
                 "FileName": zipName,
                 "DeviceId": "000000000000000",
                 "PersonId": "3",
                 "Version": "18.0.11",
                 "SubModuleName": "BASF_HK_Device",
                 "APIToken": "3B6D5CE1-0F9F-468E-A42F-2F4F7EFEF8A8",
                 ]*/

                self.writeLog(key: "UPLOAD_ZIP_API_START", value: "")
                self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)

                    .responseString { response in
                        print("Success: \(response.result)")
                        print(response)

                        switch response.result {
                        case .success(let jsonData):
                            self.writeLog(key: "UPLOAD_ZIP_END", value: "SUCCESS")
                            self.updateProgress(type: 1, message: "progress", min: 61, max: 65)
                            print("Success with JSON: \(jsonData)")

                            // delete directory
                            self.deleteDirNew(path: fileMainDir! as NSURL)

                            //print(jsonData)

                            do{
                                let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData

                                let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]

                                let anyObj = JSON(json)

                                var isValid:String = ""
                                var Message:String = ""
                                var Response:String = ""

                                if anyObj["Status"].exists(){
                                    //print("inside Status")
                                    //let list: Array<JSON> = anyObj["Status"].arrayValue

                                    isValid =  anyObj["Status"].stringValue
                                    Message =  anyObj["Message"].stringValue
                                    Response =  anyObj["Response"].stringValue
                                }else{
                                    isValid =  anyObj["Status"].stringValue
                                    Message =  anyObj["Message"].stringValue
                                    self.writeLog(key: "SYNC_ERROR", value: Message)
                                }

                                if anyObj["SyncId"].exists(){
                                    self.SyncId = anyObj["SyncId"].intValue
                                }

                                if(isValid == "1"){
                                    self.writeLog(key: "UPLOAD_ZIP_API_SUCCESS", value: "")
                                    if (self.isConnectedToNetwork() == true ){
                                        /*let destination: DownloadRequest.DownloadFileDestination = { _, _ in
                                            let fileURL = filePathSyncDownload!.appendingPathComponent("\(zipName)")
                                            return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
                                        }*/

                                        let destination: DownloadRequest.Destination = { _, _ in
                                            let documentsURL = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask)[0]
                                            let fileURL = filePathSyncDownload!.appendingPathComponent("\(zipName)")
                                            return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
                                        }

                                        AF.download(Response, to: destination).response { response in
                                            //print(response)

                                            //if response.error == nil, let zipPath = response.destinationURL?.path {
                                             if response.error == nil, let imagePath = response.fileURL?.path {
                                                //print(zipPath)

                                                //var fileSizeValue: UInt64 = 0

                                                /*do {
                                                 let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: zipPath)

                                                 if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                                                 let fileSizeValue = UInt64(fileNumberSize)
                                                 }
                                                 } catch {
                                                 //print(error.localizedDescription)
                                                 }*/
                                                self.stopTimer()
                                                self.updateProgress(type: 1, message: "progress", min: 66, max: 98)

                                                self.createDir(path: filePathSyncDownloadZip as NSURL)
                                                if(self.unzipFile(zipPath: (filePathSyncDownload?.appendingPathComponent("\(zipName)").path)!, destinationPath: filePathSyncDownloadZip.path)){
                                                    //print("Unzipped")
                                                    //CPM_Sticker_Details/CPM_Sticker_Details$_1.txt

                                                    let enumerator = fileManager.enumerator(atPath: filePathSyncDownloadZip.path)
                                                    let filePaths = enumerator?.allObjects as! [String]
                                                    let txtFilePaths = filePaths.filter{$0.contains(".txt")}

                                                    self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("BASF-LAB-Database.db")?.path)

                                                    if self.database.open()
                                                    {
                                                        let deleteQuery = "DELETE FROM LAB_Customer_Dispatch_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])

                                                        //let deleteQuery2 = "DELETE FROM CPM_Customer_Receive_Product_Details WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery2, withArgumentsIn: [])

                                                        //let deleteQuery3 = "DELETE FROM CPM_Customer_Sticker_Damage WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery3, withArgumentsIn: [])

                                                        //let deleteQuery4 = "DELETE FROM CPM_Customer_Sticker_Damage_Remove WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery4, withArgumentsIn: [])
                                                    }

                                                    for txtFilePath in txtFilePaths{
                                                        //print("FilePath \(txtFilePath)")
                                                        let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                        let tableName = fileURL.path.fileName().split(separator: "$")
                                                        //print("tableName \(tableName)")

                                                        do {

                                                            //DispatchQueue.global(qos: .background).async {
                                                            let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)

                                                            let json = JSON.init(parseJSON:stringJSON)
                                                            self.deleteRecordForViolation(tableName: String(tableName[0]), jsonArray: json)
                                                            isGoahead = self.insertRecordDynamic(tableName: String(tableName[0]), jsonArray: json)
                                                            if(!isGoahead){
                                                                //DispatchQueue.main.async {
                                                                isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                break;
                                                                //}
                                                            }
                                                            //}
                                                        }
                                                        catch {
                                                            //print("Error Reading \(txtFilePath)")
                                                            isGoahead = false
                                                            isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                        }
                                                    }

                                                    self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("BASF-LAB-Database.db")?.path)

                                                    if self.database.open()
                                                    {
                                                        let deleteQuery = "DELETE FROM LAB_Customer_Dispatch_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])

                                                        //let deleteQuery2 = "DELETE FROM CPM_Customer_Receive_Product_Details WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery2, withArgumentsIn: [])

                                                        //let deleteQuery3 = "DELETE FROM CPM_Customer_Sticker_Damage WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery3, withArgumentsIn: [])

                                                        //let deleteQuery4 = "DELETE FROM CPM_Customer_Sticker_Damage_Remove WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery4, withArgumentsIn: [])
                                                    }

                                                    for txtFilePath in txtFilePaths{
                                                        //print("FilePath \(txtFilePath)")
                                                        let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                        let tableName = fileURL.path.fileName().split(separator: "$")
                                                        //print("tableName \(tableName)")

                                                        do {

                                                            //DispatchQueue.global(qos: .background).async {
                                                            let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)

                                                            let json = JSON.init(parseJSON:stringJSON)
                                                            self.deleteRecordForViolation(tableName: String(tableName[0]), jsonArray: json)
                                                            isGoahead = self.insertRecordDynamic(tableName: String(tableName[0]), jsonArray: json)
                                                            if(!isGoahead){
                                                                //DispatchQueue.main.async {
                                                                isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                break;
                                                                //}
                                                            }
                                                            //}
                                                        }
                                                        catch {
                                                            //print("Error Reading \(txtFilePath)")
                                                            isGoahead = false
                                                            isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                        }
                                                    }

                                                    self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("BASF-LAB-Database.db")?.path)

                                                    if self.database.open()
                                                    {
                                                        let deleteQuery = "DELETE FROM LAB_Customer_Dispatch_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])

                                                        //let deleteQuery2 = "DELETE FROM CPM_Customer_Receive_Product_Details WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery2, withArgumentsIn: [])

                                                        //let deleteQuery3 = "DELETE FROM CPM_Customer_Sticker_Damage WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery3, withArgumentsIn: [])

                                                        //let deleteQuery4 = "DELETE FROM CPM_Customer_Sticker_Damage_Remove WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery4, withArgumentsIn: [])
                                                    }

                                                    for txtFilePath in txtFilePaths{
                                                        //print("FilePath \(txtFilePath)")
                                                        let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                        let tableName = fileURL.path.fileName().split(separator: "$")
                                                        //print("tableName \(tableName)")

                                                        do {

                                                            //DispatchQueue.global(qos: .background).async {
                                                            let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)

                                                            let json = JSON.init(parseJSON:stringJSON)
                                                            self.deleteRecordForViolation(tableName: String(tableName[0]), jsonArray: json)
                                                            isGoahead = self.insertRecordDynamic(tableName: String(tableName[0]), jsonArray: json)
                                                            if(!isGoahead){
                                                                //DispatchQueue.main.async {
                                                                isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                break;
                                                                //}
                                                            }
                                                            //}
                                                        }
                                                        catch {
                                                            //print("Error Reading \(txtFilePath)")
                                                            isGoahead = false
                                                            isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                        }
                                                    }

                                                    if(isGoahead){
                                                        self.writeLog(key: "SYNC_DONE", value: "")
                                                        self.updateProgress(type: 3, message: Message, min: 100, max: 100)
                                                    }else{
                                                        self.writeLog(key: "SYNC_FAIL", value: isGoaheadMessage)
                                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 100, max: 100)
                                                    }
                                                }else{
                                                    isGoahead = false
                                                    isGoaheadMessage = "Error in extract zip file"
                                                    self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                }
                                            }else{
                                                isGoahead = false
                                                isGoaheadMessage = "Error in download zip file"
                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                self.updateProgress(type: 2, message: Message, min: 0, max: 0)
                                            }
                                        }
                                    }else{
                                        isGoaheadMessage = "NO_INTERNET"
                                        self.writeLog(key: "UPLOAD_ZIP_END", value: isGoaheadMessage)
                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                    }
                                }else if(isValid == "2"){
                                    isGoaheadMessage = "Session expired. Please try again";
                                    self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }else{
                                    isGoaheadMessage = Message;
                                    self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }
                            }catch{
                                isGoaheadMessage = "server error:@, please try again \(jsonData)";
                                self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                            }
                        case .failure(let error):
                            //print("Request failed with error: \(error)")
                            let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
                            self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        }
                }
            }else{
                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
            }

        }

        return isGoaheadMessage
    }

    func deleteRecordForViolation(tableName:String, jsonArray:JSON){
        if(jsonArray.count>0){
            var i:Int = 0
            var initGlCodes:String = ""
            while(i < jsonArray.count){

                var intGlCode:Int = 0
                if jsonArray[i]["intGlCode"] == nil {
                    intGlCode = 0
                }else{
                    intGlCode = jsonArray[i]["intGlCode"].intValue
                }

                if(initGlCodes == ""){
                    initGlCodes = "\(intGlCode)"
                }else{
                    initGlCodes = "\(initGlCodes),\(intGlCode)"
                }
                i = i + 1
            }

            print("intGlCode:\(initGlCodes)")
            if(!initGlCodes.isEmpty){
                do{
                    var count:Int = 0
                    let selectQuery:String = "SELECT intGlCode FROM " + tableName + "  WHERE intGlCode IN (" + initGlCodes + ")";
                    if let rs = self.database.executeQuery(selectQuery, withArgumentsIn: []) {
                        while rs.next() {
                            count = Int(rs.int(forColumn: "intGlCode"))
                            print("Total Records:", count)
                        }
                    }

                    if(count > 0){
                        let deleteQuery = "DELETE FROM  " + tableName + "  WHERE intGlCode IN (" + initGlCodes + ")"
                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                    }

                }catch{
                    print("error deleteRecordForViolation")
                }
            }

        }
    }
    
    func deleteRecordForViolationIFFCO(tableName:String, jsonArray:JSON){
        if(jsonArray.count>0){
            var i:Int = 0
            var initGlCodes:String = ""
            while(i < jsonArray.count){

                var intGlCode:Int = 0
                if jsonArray[i]["INT_GLCODE"] == nil {
                    intGlCode = 0
                }else{
                    intGlCode = jsonArray[i]["INT_GLCODE"].intValue
                }

                if(initGlCodes == ""){
                    initGlCodes = "\(intGlCode)"
                }else{
                    initGlCodes = "\(initGlCodes),\(intGlCode)"
                }
                i = i + 1
            }

            print("INT_GLCODE:\(initGlCodes)")
            if(!initGlCodes.isEmpty){
                do{
                    var count:Int = 0
                    let selectQuery:String = "SELECT INT_GLCODE FROM " + tableName + "  WHERE INT_GLCODE IN (" + initGlCodes + ")";
                    if let rs = self.database.executeQuery(selectQuery, withArgumentsIn: []) {
                        while rs.next() {
                            count = Int(rs.int(forColumn: "INT_GLCODE"))
                            print("Total Records:", count)
                        }
                    }

                    if(count > 0){
                        let deleteQuery = "DELETE FROM  " + tableName + "  WHERE INT_GLCODE IN (" + initGlCodes + ")"
                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                    }

                }catch{
                    print("error deleteRecordForViolation")
                }
            }

        }
    }

    func insertRecordDynamic(tableName:String, jsonArray:JSON)->Bool{

        // DispatchQueue.global(qos: .background).async {
        var success = true

        do{
            let isTranTable = (tableName == DBHelper.TABLE_CPM_CUSTOMER_DISPATCH
                || tableName == DBHelper.TABLE_CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS
                || tableName == DBHelper.TABLE_CPM_CUSTOMER_RECEIVE
                || tableName == DBHelper.TABLE_CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS
                || tableName == DBHelper.TABLE_CPM_GENERAL_RECEIVE
                || tableName == DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE
                || tableName == DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE_REMOVE
                || tableName == DBHelper.TABLE_CPM_Customer_Sticker_Scrap
                || tableName == DBHelper.TABLE_CPM_Customer_Sticker_Consume
                || tableName == DBHelper.TABLE_PERSON_MST
                || tableName == DBHelper.TABLE_CPM_DAMAGE_TYPE
                || tableName == DBHelper.TABLE_PRODUCT_SKU_MST
                || tableName == DBHelper.TABLE_CUSTOMER_PARTNER_MST
                || tableName == DBHelper.TABLE_CUSTOMER_TYPE_COUNTRY_MST
                || tableName == DBHelper.TABLE_POLITICAL_GEOGRAPHY_LEVEL_COUNTRY_MST
                || tableName == DBHelper.TABLE_POLITICAL_GEOGRAPHY_DETAILS
                || tableName == DBHelper.TABLE_CPM_PALLET_MST
                || tableName == DBHelper.TABLE_CPM_STRICKER_Details)
            print(tableName)

            /*if(tableName == "CPM_Sticker_Details" || tableName == "Customer_Type_Country_Mst"){
             let deleteQuery = "DELETE FROM \(tableName)"
             self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
             }*/

            /*if(tableName != "CPM_Sticker_Details"){
             return true
             }*/

            if !isTranTable && self.database.open()
            {
                let deleteQuery = "DELETE FROM \(tableName)"
                self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                //// print("here one")
            }else{
                if (tableName != DBHelper.TABLE_CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS
                    && tableName != DBHelper.TABLE_CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS
                    && tableName != DBHelper.TABLE_CPM_GENERAL_RECEIVE
                    && tableName != DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE
                    && tableName != DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE_REMOVE) {

                    let deleteQuery = "DELETE FROM \(tableName) WHERE chrSync = 'N'"
                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                }
                // print("here two")
            }

            if(tableName == "CPM_Sticker_Details"){
                return parseJsonStickerDetails(Tourplan_Daily: jsonArray)
                //return true
            }else{

                if(jsonArray.count>0){

                    var sbQuery = ""

                    sbQuery = "INSERT INTO \(tableName) ("

                    let keys = jsonArray[0].dictionaryValue.keys.sorted()

                    var sbQuery2 = ""
                    for (position, name) in keys.enumerated() {
                        if(name=="chrTran"){
                            continue
                        }
                        sbQuery2.append(name)
                        sbQuery2.append(",")
                    }

                    sbQuery2 = sbQuery2.trim()
                    sbQuery2 = String(sbQuery2.dropLast())

                    sbQuery.append(sbQuery2)
                    sbQuery.append(" ) VALUES ")

                    let arraySize = jsonArray.count
                    let BATCHSIZE = 150
                    let intBatch = Int(CGFloat(ceil(Double(Double(arraySize) * 1.00 / Double(BATCHSIZE)))))-1
                    let intRemainder = Int(Double(arraySize).truncatingRemainder(dividingBy: Double(BATCHSIZE)))
                    var intMaxRecords = Int(BATCHSIZE)

                    //print("intBatch:\(intBatch)")
                    //print("intRemainder:\(intRemainder)")
                    //print("intMaxRecords:\(intMaxRecords)")

                    //print("here 1:\(sbQuery)")

                    for b in 0...intBatch {
                         try autoreleasepool {

                              var finalInsert=""
                              finalInsert.append(sbQuery)
                              if (b == intBatch) {
                                   intMaxRecords = intRemainder == 0 ? BATCHSIZE : intRemainder;
                              }

                              var valuesBuiler=""
                              var deleteValues = [String]()
                              var deleteQ=""
                              let innerLoopSize = Int((b * Int(BATCHSIZE)) + intMaxRecords)-1
                              let tmp1 = Int((b * BATCHSIZE))

                              //print("BATCHSIZE:\(BATCHSIZE)")
                              //print("innerLoopSize:\(innerLoopSize)")
                              //print("tmp1:\(tmp1)")

                              for m in tmp1...innerLoopSize {
                                   //let jsonObject = jsonArray[m]
                                   if(jsonArray[m].dictionaryValue.keys.contains("chrTran")){
                                        let chrTran = jsonArray[m].dictionaryValue["chrTran"]?.string

                                        if (jsonArray[m].dictionaryValue.keys.contains("varSync_Code")) {
                                             deleteQ.append(deleteValues.count <= 0 ? "?" : ",?")
                                             deleteValues.append((jsonArray[m].dictionaryValue["varSync_Code"]?.string)!)
                                        }
                                        if (chrTran != nil && chrTran!.caseInsensitiveCompare("d") == .orderedSame) {
                                             continue
                                        }
                                   }

                                   if (!valuesBuiler.isEmpty){
                                        valuesBuiler.append(",")
                                   }

                                   valuesBuiler.append("(")

                                   for (pos, key) in jsonArray[m].dictionaryValue.keys.sorted().enumerated() {

                                        let hasNext = (pos != jsonArray[m].dictionaryValue.keys.count-1)
                                        if (key=="chrTran") {
                                             if (!hasNext && valuesBuiler.contains(",")) {
                                                  valuesBuiler.remove(at: valuesBuiler.lastIndex(of: ",")!)
                                             }
                                             continue
                                        }

                                        let tmp = jsonArray[m].dictionaryValue[key]?.string

                                        if (tmp != nil && !(tmp?.isEmpty)! && tmp != "null") {
                                             valuesBuiler.append("'")
                                             valuesBuiler.append(tmp!.replace(target: "'", withString: "''"))
                                             valuesBuiler.append("'")
                                        }else if(tmp == "null" || tmp == "NULL"){
                                             valuesBuiler.append("NULL")
                                        }else{
                                             let ddd = nullToNil(value: jsonArray[m].dictionaryValue[key] as AnyObject)

                                             if let actualVariable = ddd {
                                                  valuesBuiler = valuesBuiler + " \(actualVariable)"
                                             }
                                        }
                                        valuesBuiler.append(hasNext ? "," : "")
                                        valuesBuiler = valuesBuiler.trim()
                                        if(valuesBuiler.contains(",,") || valuesBuiler.contains(", ,") || valuesBuiler.contains("( ,") || valuesBuiler.contains("(,")){
                                             if(valuesBuiler.contains(",,")){
                                                  let newString = valuesBuiler.replacingOccurrences(of: ",,", with: ",'',", options: .literal, range: nil)
                                                  valuesBuiler = newString
                                             }
                                             if(valuesBuiler.contains(", ,")){
                                                  let newString1 = valuesBuiler.replacingOccurrences(of: ", ,", with: ",'',", options: .literal, range: nil)
                                                  valuesBuiler = newString1
                                             }

                                             if(valuesBuiler.contains("(,")){
                                                  let newString3 = valuesBuiler.replacingOccurrences(of: "(,", with: "('',", options: .literal, range: nil)
                                                  valuesBuiler = newString3
                                             }

                                             if(valuesBuiler.contains("( ,")){
                                                  let newString3 = valuesBuiler.replacingOccurrences(of: "( ,", with: "('',", options: .literal, range: nil)
                                                  valuesBuiler = newString3
                                             }
                                        }
                                   }
                                   valuesBuiler.append(")")

                                   if(valuesBuiler.contains(", )")){
                                        let newString2 = valuesBuiler.replacingOccurrences(of: ", )", with: ",'')", options: .literal, range: nil)
                                        valuesBuiler = newString2
                                   }

                                   if(valuesBuiler.contains(",)")){
                                        let newString3 = valuesBuiler.replacingOccurrences(of: ",)", with: ",'')", options: .literal, range: nil)
                                        valuesBuiler = newString3
                                   }
                              }
                              finalInsert.append(valuesBuiler)
                              //print("##INSERTED##   \(finalInsert)")

                              if(isTranTable){
                                   let deleteQuery = "DELETE FROM \(tableName) WHERE varSync_Code IN (\(deleteQ))"
                                   self.database.executeUpdate(deleteQuery, withArgumentsIn: deleteValues)
                                   //print("##DELETED##\(deleteCount)")
                              }

                              try self.database.executeUpdate(finalInsert, withArgumentsIn: [])
                              print("##INSERTED##   \(finalInsert)")
                         }
                    }
                }
            }
        } catch let error as NSError {
            print("##insertRecordDynamic##   \(error.debugDescription)")
            NSLog("insertRecordDynamic \(error.debugDescription)")
            self.self.syncJSON.setValue("---insertRecordDynamic failed---\(error.debugDescription)", forKey: "34")
            success=false
        }
        //}

        return success
    }


    /*struct Synchronization: Encodable {
        var ishop_distributor_return: [Any] = []
        var ishop_distributor_return_product: [Any] = []
        // Add other properties here
        
        // Implementing the Encodable protocol
        enum CodingKeys: String, CodingKey {
            case ishop_distributor_return
            case ishop_distributor_return_product
            // Add other coding keys for additional properties
        }

        func encode(to encoder: Encoder) throws {
            var container = encoder.container(keyedBy: CodingKeys.self)
            try container.encode(ishop_distributor_return, forKey: .ishop_distributor_return)
            try container.encode(ishop_distributor_return_product, forKey: .ishop_distributor_return_product)
            // Encode other properties
        }
    }*/

    func getJsonFromObject<T: Encodable>(_ object: T) throws -> String {
        let encoder = JSONEncoder()
        let jsonData = try encoder.encode(object)
        if let jsonString = String(data: jsonData, encoding: .utf8) {
            return jsonString
        } else {
            throw NSError(domain: "JSON Encoding Error", code: 0, userInfo: nil)
        }
    }
    

    private func getJsonFromTableINVALIDForFOCMainTable(_ db: FMDatabase) -> [[String: Any]] {
        
        db.open()
        
        var jsonTableData = [[String: Any]]()
        var listDispatchID = [String]()
        var listIDs = ""

        let qry = """
                  SELECT biddp.distributor_dispatch_id AS distributor_dispatch_id
                    FROM bf_ishop_distributor_dispatch_product AS biddp
                         INNER JOIN
                         bf_ishop_distributor_dispatch AS bidp ON bidp.distributor_dispatch_id = biddp.distributor_dispatch_id
                   WHERE biddp.is_valid = '6' AND
                         biddp.sync_flag = 'Y' AND
                         bidp.sync_flag = 'Y' AND
                         bidp.isDispatch <> '1';
                  """

        if let cursor = db.executeQuery(qry, withArgumentsIn: []) {
            while cursor.next() {
                if let dispatchID = cursor.string(forColumn: "distributor_dispatch_id") {
                    listDispatchID.append(dispatchID)

                    if listIDs.isEmpty {
                        listIDs = "'\(dispatchID)'"
                    } else {
                        listIDs = "\(listIDs),'\(dispatchID)'"
                    }
                }
            }
        }

        if !listIDs.isEmpty {
            let sql2 = """
                       SELECT bidd.*
                         FROM bf_ishop_distributor_dispatch_product AS biddp
                              INNER JOIN
                              bf_ishop_distributor_dispatch AS bidd ON bidd.distributor_dispatch_id = biddp.distributor_dispatch_id
                        WHERE bidd.isDispatch = '0' AND
                              biddp.sync_flag = 'Y' AND
                              biddp.is_valid = '6' AND
                              biddp.distributor_dispatch_id IN (\(listIDs));
                       """

            if let c = db.executeQuery(sql2, withArgumentsIn: []) {
                while c.next() {
                    let totalColumn = c.columnCount
                    if totalColumn > 0 {
                        var rowObject = [String: Any]()
                        for i in 0..<totalColumn {
                            guard let cName = c.columnName(for: i) else { continue }

                            switch cName {
                            case "id", "_id", "intglcode":
                                continue
                            case "isDispatch":
                                continue
                            default:
                                if let value = c.object(forColumn: cName) {
                                    rowObject[cName] = value
                                } else {
                                    rowObject[cName] = NSNull()
                                }
                            }
                        }
                        jsonTableData.append(rowObject)
                    }
                }
            }
        }
        
        db.close()

        return jsonTableData
    }


    func getJsonFromTableINVALIDForFOC(db: FMDatabase) -> [[String: Any]] {
        db.open()
        var jsonTableData = [[String: Any]]()
        var listDispatchID = [String]()
        var listIDs = ""

        let qry = """
            SELECT biddp.distributor_dispatch_id AS distributor_dispatch_id
            FROM bf_ishop_distributor_dispatch_product AS biddp
            INNER JOIN bf_ishop_distributor_dispatch AS bidp ON bidp.distributor_dispatch_id = biddp.distributor_dispatch_id
            WHERE biddp.is_valid = '6' AND
                  biddp.sync_flag = 'Y' AND
                  bidp.sync_flag = 'Y' AND
                  bidp.isDispatch <> '1';
        """

        guard let cursor = db.executeQuery(qry, withArgumentsIn: []) else {
            // Handle query execution error
            return jsonTableData
        }

        defer {
            cursor.close()
        }

        do {
            while cursor.next() {
                listDispatchID.append(cursor.string(forColumn: "distributor_dispatch_id") ?? "")

                if listIDs.isEmpty {
                    listIDs = "'" + (cursor.string(forColumn: "distributor_dispatch_id") ?? "") + "'"
                } else {
                    listIDs = listIDs + "," + "'" + (cursor.string(forColumn: "distributor_dispatch_id") ?? "") + "'"
                }
            }
        } catch {
            // Handle cursor iteration error
            return jsonTableData
        }

        if !listIDs.isEmpty {
            let sql2 = """
                SELECT biddp.*
                FROM bf_ishop_distributor_dispatch_product AS biddp
                INNER JOIN bf_ishop_distributor_dispatch AS bidd ON bidd.distributor_dispatch_id = biddp.distributor_dispatch_id
                WHERE bidd.isDispatch = '0' AND
                      biddp.sync_flag = 'Y' AND
                      biddp.is_valid = '6' AND
                      biddp.distributor_dispatch_id IN (\(listIDs));
            """

            guard let c = db.executeQuery(sql2, withArgumentsIn: []) else {
                // Handle query execution error
                return jsonTableData
            }

            defer {
                c.close()
            }

            do {
                while c.next() {
                    var rowObject = [String: Any]()

                    for i in 0..<c.columnCount {
                        let columnName = c.columnName(for: i) ?? ""
                        
                        if let columnValue = c.object(forColumnIndex: i) {
                                    // Check the class of the columnValue to determine its type
                                    if columnValue is String {
                                        print("\(columnName) is a String: \(columnValue as? String ?? "")")
                                        if columnName.lowercased() != "isdispatch" {
                                            rowObject[columnName] = c.string(forColumn: columnName) ?? ""
                                        }
                                    } else if columnValue is Int {
                                        print("\(columnName) is an Int: \(columnValue as? Int ?? 0)")
                                        if columnName.lowercased() != "id" && columnName.lowercased() != "_id" && columnName.lowercased() != "intglcode" {
                                            rowObject[columnName] = Int(c.long(forColumn: columnName))
                                        }
                                    } else if columnValue is Double {
                                        print("\(columnName) is a Double: \(columnValue as? Double ?? 0.0)")
                                        rowObject[columnName] = c.double(forColumn: columnName)
                                    } else if columnValue is Bool {
                                        print("\(columnName) is a Bool: \(columnValue as? Bool ?? false)")
                                        rowObject[columnName] = c.bool(forColumn: columnName)
                                    } else {
                                        // Handle other types as needed
                                        print("\(columnName) has an unknown type")
                                        rowObject[columnName] = ""
                                    }
                                } else {
                                    print("\(columnName) has a nil value")
                                    rowObject[columnName] = ""
                                }
                        

                        /*switch c.columnType(cName) {
                        case .integer:
                            if cName.lowercased() != "id" && cName.lowercased() != "_id" && cName.lowercased() != "intglcode" {
                                rowObject[cName] = Int(c.long(forColumn: cName))
                            }
                        case .real:
                            rowObject[cName] = c.double(forColumn: cName)
                        case .text:
                            if cName.lowercased() != "isdispatch" {
                                rowObject[cName] = c.string(forColumn: cName) ?? ""
                            }
                        default:
                            rowObject[cName] = ""
                        }*/
                    }

                    jsonTableData.append(rowObject)
                }
            } catch {
                // Handle cursor iteration error
                return jsonTableData
            }
        }
        
        db.close()

        return jsonTableData
    }
    

    private func addDistributorDispatchForSampleAndFOCProduct(_ tableDistributorDispatchProduct: [[String: Any]]) -> [[String: Any]] {
        var updatedTableDistributorDispatchProduct = tableDistributorDispatchProduct

        do {
            let tableDistributorDispatchProductInvalidFOC = getJsonFromTableINVALIDForFOC(db: database)

            if tableDistributorDispatchProductInvalidFOC != nil && tableDistributorDispatchProductInvalidFOC.count > 0 {
                for i in 0..<tableDistributorDispatchProductInvalidFOC.count {
                    if let object = tableDistributorDispatchProductInvalidFOC[i] as? [String: Any] {
                        if updatedTableDistributorDispatchProduct == nil {
                            updatedTableDistributorDispatchProduct = [[String: Any]]()
                        }
                        updatedTableDistributorDispatchProduct.append(object)
                    }
                }
            }
        } catch {
            // Handle JSONException
            print(error.localizedDescription)
        }

        print("TAG_FOC", updatedTableDistributorDispatchProduct ?? "")
        return updatedTableDistributorDispatchProduct ?? [[String: Any]]()
    }


    
    private func addDistributorDispatchForSampleAndFOC(_ tableDistributorDispatch: [[String: Any]]) -> [[String: Any]] {
        var updatedTableDistributorDispatch = tableDistributorDispatch

        do {
            let tableDistributorDispatchInvalidFOC = getJsonFromTableINVALIDForFOCMainTable(database)

//            if tableDistributorDispatchInvalidFOC != nil && tableDistributorDispatchInvalidFOC.count > 0 {
//                for object in tableDistributorDispatchInvalidFOC {
//                    if updatedTableDistributorDispatch == nil {
//                        updatedTableDistributorDispatch = [[String: Any]]()
//                    }
//                    updatedTableDistributorDispatch.append(object)
//                }
//            }
            if tableDistributorDispatchInvalidFOC.count > 0 {
                        if updatedTableDistributorDispatch == nil {
                            updatedTableDistributorDispatch = [[String: Any]]()
                        }
                        updatedTableDistributorDispatch.append(contentsOf: tableDistributorDispatchInvalidFOC)
                    }

        } catch {
            // Handle JSONException
            print(error.localizedDescription)
        }

        print("TAG_FOC", updatedTableDistributorDispatch ?? "")
        return updatedTableDistributorDispatch ?? [[String: Any]]()
    }


    struct IshopDistributorReturn: Codable {
        var countryId: String
        var createdByUser: String
        var createdOn: String
        var customerFromId: String
        var customerToId: String
        var customerTypeCountryId: String
        var distributorReturnId: String
        var isNewCustomer: String
        var modifiedByUser: String
        var modifiedOn: String
        var returnDate: String
        var status: String
        var syncByUser: String
        var syncCode: String
        var syncDate: String
        var syncFlag: String
    }
    
    struct IshopDistributorReturnProduct: Codable {
        var qrCodeOut: String
        var amount: String
        var btcNoOut: String
        var distributorReturnId: String
        var distributorReturnProductId: String
        var isValid: String
        var productSkuId: String
        var qtyKgl: String
        var quantity: String
        var stickerDetailsId: String
        var syncByUser: String
        var syncCode: String
        var syncDate: String
        var syncFlag: String
        var unit: String
    }

    
    func getDistributorReturnSyncData() -> [IshopDistributorReturn] {
        var arrayList = [IshopDistributorReturn]()
        let query = "SELECT * FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN) WHERE \(DBHelper.KEY_SYNC_FLAG) = 'Y'"
        database.open()
        if let cursor = database.executeQuery(query, withParameterDictionary: nil) {
            while cursor.next() {
                var object = IshopDistributorReturn(
                                countryId: cursor.string(forColumn: DBHelper.KEY_COUNTRY_ID) ?? "",
                                createdByUser: cursor.string(forColumn: DBHelper.KEY_CREATED_BY_USER) ?? "",
                                createdOn: cursor.string(forColumn: DBHelper.KEY_CREATE_ON) ?? "",
                                customerFromId: cursor.string(forColumn: DBHelper.KEY_CUSTOMER_FROM_ID) ?? "",
                                customerToId: cursor.string(forColumn: DBHelper.KEY_CUSTOMER_TO_ID) ?? "",
                                customerTypeCountryId: cursor.string(forColumn: DBHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID) ?? "",
                                distributorReturnId: cursor.string(forColumn: DBHelper.KEY_DISTRIBUTOR_RETURN_ID) ?? "",
                                isNewCustomer: cursor.string(forColumn: DBHelper.KEY_IS_NEW_CUSTOMER) ?? "",
                                modifiedByUser: cursor.string(forColumn: DBHelper.KEY_MODIFIED_BY_USER) ?? "",
                                modifiedOn: cursor.string(forColumn: DBHelper.KEY_MODIFIED_ON) ?? "",
                                returnDate: cursor.string(forColumn: DBHelper.KEY_RETURN_DATE) ?? "",
                                status: cursor.string(forColumn: DBHelper.KEY_STATUS) ?? "",
                                syncByUser: cursor.string(forColumn: DBHelper.KEY_SYNC_USER) ?? "",
                                syncCode: cursor.string(forColumn: DBHelper.KEY_SYNC_CODE) ?? "",
                                syncDate: cursor.string(forColumn: DBHelper.KEY_SYNC_DATE) ?? "",
                                syncFlag: cursor.string(forColumn: DBHelper.KEY_SYNC_FLAG) ?? ""
                            )
                            arrayList.append(object)
            }
            
            cursor.close()
        }
        database.close()
        
        return arrayList
    }

    func getDistributorReturnProductSyncData() -> [IshopDistributorReturnProduct] {
        var arrayList = [IshopDistributorReturnProduct]()
        let query = "SELECT * FROM \(DBHelper.TABLE_DISTRIBUTOR_RETURN_PRODUCT) WHERE \(DBHelper.KEY_SYNC_FLAG) = 'Y'"
        
        database.open()
        if let cursor = database.executeQuery(query, withParameterDictionary: nil) {
            defer {
                cursor.close()
            }
            
            while cursor.next() {
                var object = IshopDistributorReturnProduct(
                    qrCodeOut: cursor.string(forColumn: DBHelper.KEY_QR_CODE_OUT) ?? "",
                    amount: cursor.string(forColumn: DBHelper.KEY_AMOUNT) ?? "",
                    btcNoOut: cursor.string(forColumn: DBHelper.KEY_BTC_NO_OUT) ?? "",
                    distributorReturnId: cursor.string(forColumn: DBHelper.KEY_DISTRIBUTOR_RETURN_ID) ?? "",
                    distributorReturnProductId: cursor.string(forColumn: DBHelper.KEY_DISTRIBUTOR_RETURN_PRODUCT_ID) ?? "",
                    isValid: cursor.string(forColumn: DBHelper.KEY_IS_VALID) ?? "",
                    productSkuId: cursor.string(forColumn: DBHelper.KEY_PRODUCT_SKU_ID) ?? "",
                    qtyKgl: cursor.string(forColumn: DBHelper.KEY_QTY_KGL) ?? "",
                    quantity: cursor.string(forColumn: DBHelper.KEY_QUANTITY) ?? "",
                    stickerDetailsId: cursor.string(forColumn: DBHelper.KEY_STICKER_DETAILS_ID) ?? "",
                    syncByUser: cursor.string(forColumn: DBHelper.KEY_SYNC_USER) ?? "",
                    syncCode: cursor.string(forColumn: DBHelper.KEY_SYNC_CODE) ?? "",
                    syncDate: cursor.string(forColumn: DBHelper.KEY_SYNC_DATE) ?? "",
                    syncFlag: cursor.string(forColumn: DBHelper.KEY_SYNC_FLAG) ?? "",
                    unit: cursor.string(forColumn: DBHelper.KEY_UNIT) ?? ""
                )
                arrayList.append(object)
            }
        }
        database.close()
        return arrayList
    }
    
    
    
    func getMillisDifference(startTime: TimeInterval, endTime: TimeInterval) -> TimeInterval {
        return endTime - startTime
    }
    
    func getFileName(_ filenameWithExtension: String) -> String {
        return filenameWithExtension.replacingOccurrences(of: ".txt", with: "")
    }
    
    func deleteContentsOfDirectory(atPath path: String) {
        let fileManager = FileManager.default
        
        print("&&&&&&&&&&&&&&&&&&&&&&&&&&&&")
        print("remove content path: \(path)")
        print("&&&&&&&&&&&&&&&&&&&&&&&&&&&&")
        
        do {
            let contents = try fileManager.contentsOfDirectory(atPath: path)
            
            for content in contents {
                let fullPath = (path as NSString).appendingPathComponent(content)
                
                do {
                    try fileManager.removeItem(atPath: fullPath)
                    print("Deleted: \(fullPath)")
                } catch {
                    print("Error deleting \(fullPath): \(error.localizedDescription)")
                }
            }
        } catch {
            print("Error accessing directory contents: \(error.localizedDescription)")
        }
    }

    func getLocalTransactionFile(syncType: String, userid:String) -> String {
        
        let file_toLocation = SwiftEcpSyncPlugin.ScopedStorage.getPath(fileName: ScopedStorage.EXTERNAL_STORAGE_RECPM_SYNC_REQUEST)
        if FileManager.default.fileExists(atPath: file_toLocation) {
           // deleteContentsOfDirectory(atPath: file_toLocation)
        }
        
        var zippedFileName = ""
        
        do {
            var requestData = ""
            if syncType.lowercased() == "g" {
                requestData = getSynchronizationMaster()
            } else {
                requestData = getSynchronization()
            }
            
            //let fgStart = Date().timeIntervalSince1970 * 1000
            let requestFileName = getRequestFileName(userId: userid)
            print("SYNC_REQUEST REQUEST::: \(requestFileName)")
            if let generatedFilePath = generateNoteOnSDForAll(sFileName: requestFileName, sBody: requestData, context: self) {
                
                //let fgEnd = Date().timeIntervalSince1970 * 1000
                //let difference = getMillisDifference(startTime: fgStart, endTime: fgEnd)
                //objSyncData["FG"] = difference
                
                let fileManager = FileManager.default
                if fileManager.fileExists(atPath: generatedFilePath) {
                    let zipStart = Date().timeIntervalSince1970 * 1000
                    zipName_final_re = getFileName(requestFileName)
                    print(zipName_final_re)
                    
                    let toLocation_folder = SwiftEcpSyncPlugin.ScopedStorage.getPath(fileName: ScopedStorage.EXTERNAL_STORAGE_RECPM_SYNC_REQUEST_ZIP_LOCATION)
                    
                    let toLocation = SwiftEcpSyncPlugin.ScopedStorage.getPath(fileName: ScopedStorage.EXTERNAL_STORAGE_RECPM_SYNC_REQUEST_ZIP_LOCATION) + "/" + zipName_final_re + ".zip"
                    
                    if !FileManager.default.fileExists(atPath: toLocation_folder) {
                        print("Zip file already exists in the destination. Removing it.")
                         try FileManager.default.createDirectory(atPath: toLocation_folder, withIntermediateDirectories: true, attributes: nil)
                    }else{
                        //deleteContentsOfDirectory(atPath: toLocation_folder)
                    }
                    
                    // let toLocation_dev_path = SwiftEcpSyncPlugin.ScopedStorage.getPath(fileName: ScopedStorage.EXTERNAL_STORAGE_RECPM_SYNC_REQUEST_ZIP_LOCATION) + "/" + zipName_final_re
                    
                    print(toLocation)
                    print("SYNC_REQUEST REQUEST:::toLocation \(toLocation)")
                    //                    zipManager.zipFileAtPath(generatedFilePath, toLocation)
                    
                    let zipEnd = Date().timeIntervalSince1970 * 1000
                    let zipDifference = getMillisDifference(startTime: zipStart, endTime: zipEnd)
                    print("SYNCTRACK ZP_ TIME:: \(zipDifference)")
                    //                    objSyncData["ZP"] = zipDifference
                    
                    zippedFileName = toLocation
                    
                    
                    let success = SSZipArchive.createZipFile(atPath: zippedFileName, withContentsOfDirectory: file_toLocation)
                    
                    if(success){
                        self.writeLog(key: "CREATE_ZIP_END", value: "Success")
                        //isGoahead = true
                        self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_END")
                        self.self.syncJSON.setValue("---Create Zip File End---", forKey: "6")
                    }else{
                        self.writeLog(key: "CREATE_ZIP_END", value: "Error creating zip")
                        //isGoahead = false
                        //isGoaheadMessage = "Error creating zip"
                        self.self.syncJSON.setValue("---Create Zip File Failed---", forKey: "7")
                    }
                    
                    /*do {
                     let url = URL(fileURLWithPath: zippedFileName)
                     let zipFileData = try Data(contentsOf: url)
                     //data.append(zipFileData)
                     } catch {
                     print("Error reading zip file data: \(error.localizedDescription)")
                     // return
                     }*/
                } else {
                    //                    error_code = String(SyncErrorCode.ERROR_103.rawValue)
                    //                    exceptionDetails = SyncErrorCode.SYNC_ERROR_MSG_103
                    //                    updateActivity()
                    
                    zippedFileName = ""
                }
            } else {
                //                error_code = String(SyncErrorCode.ERROR_102.rawValue)
                //                exceptionDetails = SyncErrorCode.SYNC_ERROR_MSG_102
                //                return String(SyncErrorCode.ERROR_102.rawValue)
                zippedFileName = ""
            }
        } catch let error as NSError {
            //            error.printStackTrace()
            //            databaseHelperExtended.insertTransactionErrorLog(synchronizationService: self, className: self.classForCoder.description(),
            //                                                             methodName: "startSync",
            //                                                             exceptionDetails: AppUtil.getStackTrace(error),
            //                                                             errorDetails: AppUtil.getStackTrace(error),
            //                                                             errorCode: SyncErrorCode.ERROR_CODE_311.rawValue,
            //                                                             syncLogID: syncLogID, userID: userID)
            //            return String(SyncErrorCode.ERROR_CODE_311.rawValue)
            
            zippedFileName = ""
        }
        
        return zippedFileName
    }
        

    func getSynchronization() -> String {
        
        let TABLE_TRANSACTION_ERROR = getJsonFromTable_Re(tableName: DBHelper.TABLE_TRANSACTION_ERROR_LOG, db: database, isDispatch: "0")
        let TABLE_ISHOP_PALLET_DETAILS = getJsonFromTable_Re(tableName: DBHelper.TABLE_ISHOP_PALLET_DETAILS, db: database, isDispatch: "0")
        let TABLE_DEVICE_TOKEN = getJsonFromTable_Re(tableName: DBHelper.TABLE_DEVICE_TOKEN, db: database, isDispatch: "0")
        let TABLE_SAVE_OFFLINE_LOG = getJsonFromTable_Re(tableName: DBHelper.TABLE_SAVE_OFFLINE_LOG, db: database, isDispatch: "0")
        let TABLE_TOLLER_DISPATCH = getJsonFromTable_Re(tableName: DBHelper.TABLE_TOLLER_DISPATCH, db: database, isDispatch: "0")
        
        let TABLE_TOLLER_DISPATCH_PRODUCT = getJsonFromTable_Re(tableName: DBHelper.TABLE_TOLLER_DISPATCH_PRODUCT, db: database, isDispatch: "0")
        let TABLE_RETAILER_DISPATCH = getJsonFromTable_Re(tableName: DBHelper.TABLE_RETAILER_DISPATCH, db: database, isDispatch: "1")
        let TABLE_RETAILER_DISPATCH_PRODUCT = getJsonFromTable_Re(tableName: DBHelper.TABLE_RETAILER_DISPATCH_PRODUCT, db: database, isDispatch: "0")
        
        let TABLE_CFA_DISPATCH = getJsonFromTable_Re(tableName: DBHelper.TABLE_CFA_DISPATCH, db: database, isDispatch: "1")
        let TABLE_CFA_DISPATCH_PRODUCT = getJsonFromTable_Re(tableName: DBHelper.TABLE_CFA_DISPATCH_PRODUCT, db: database, isDispatch: "0")
        let TABLE_SAMPLE_DISPATCH = getJsonFromTable_Re(tableName: DBHelper.TABLE_ISHOP_SAMPLE_DISPATCH, db: database, isDispatch: "1")
        let TABLE_SAMPLE_DISPATCH_PRODUCT = getJsonFromTable_Re(tableName: DBHelper.TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT, db: database, isDispatch: "0")
        let TABLE_CFA_RETURN = getJsonFromTable_Re(tableName: DBHelper.TABLE_CFA_RETURN, db: database, isDispatch: "0")
        
        var TABLE_DISTRIBUTOR_DISPATCH = getJsonFromTable_Re(tableName: DBHelper.TABLE_DISTRIBUTOR_DISPATCH, db: database, isDispatch: "1")
        var TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = getJsonFromTable_Re(tableName: DBHelper.TABLE_DISTRIBUTOR_DISPATCH_PRODUCT, db: database, isDispatch: "0")
        
        // For Sample and FOC Invalid
        TABLE_DISTRIBUTOR_DISPATCH = addDistributorDispatchForSampleAndFOC(TABLE_DISTRIBUTOR_DISPATCH)
        TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = addDistributorDispatchForSampleAndFOCProduct(TABLE_DISTRIBUTOR_DISPATCH_PRODUCT)
        
        // Amit Vaghela changes
        let TABLE_ishop_distributor_received = getJsonFromTable_Re(tableName: DBHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED, db: database, isDispatch: "1")
        let TABLE_ishop_distributor_received_product = getJsonFromTable_Re(tableName: DBHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT, db: database, isDispatch: "0")
        let TABLE_ishop_reatialer_received = getJsonFromTable_Re(tableName: DBHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED, db: database, isDispatch: "1")
        let TABLE_ishop_reatialer_received_product = getJsonFromTable_Re(tableName: DBHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT, db: database, isDispatch: "0")
        
        let TABLE_bf_ishop_cfa_return = getJsonFromTable_Re(tableName: DBHelper.TABLE_CFA_RETURN, db: database, isDispatch: "1")
        let TABLE_bf_ishop_cfa_return_product = getJsonFromTable_Re(tableName: DBHelper.TABLE_CFA_RETURN_PRODUCT, db: database, isDispatch: "0")
        
        let TABLE_bf_ishop_distributor_return_request = getJsonFromTable_Re(tableName: DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST, db: database, isDispatch: "1")
        let TABLE_bf_ishop_distributor_return_request_product = getJsonFromTable_Re(tableName: DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT, db: database, isDispatch: "0")
        
        let TABLE_SALES_REP_INITIATED_PRODUCT = getJsonFromTable_Re(tableName: DBHelper.TABLE_SALES_REP_INITIATED_PRODUCT, db: database, isDispatch: "2")
        
        let TABLE_CFA_DAMAGE = getJsonFromTable_Re(tableName: DBHelper.TABLE_CFA_DAMAGE, db: database, isDispatch: "0")
        let TABLE_CFA_DAMAGE_PRODUCT = getJsonFromTable_Re(tableName: DBHelper.TABLE_CFA_DAMAGE_PRODUCT, db: database, isDispatch: "0")
        
        let TABLE_DIST_DAMAGE = getJsonFromTable_Re(tableName: DBHelper.TABLE_DISTRIBUTOR_DAMAGE, db: database, isDispatch: "0")
        let TABLE_DIST_DAMAGE_PRODUCT = getJsonFromTable_Re(tableName: DBHelper.TABLE_DISTRIBUTOR_DAMAGE_PRODUCT, db: database, isDispatch: "0")
        
        let TABLE_RET_DAMAGE = getJsonFromTable_Re(tableName: DBHelper.TABLE_RETAILER_DAMAGE, db: database, isDispatch: "0")
        let TABLE_RET_DAMAGE_PRODUCT = getJsonFromTable_Re(tableName: DBHelper.TABLE_RETAILER_DAMAGE_PRODUCT, db: database, isDispatch: "0")
        
        /* TODO Change By Praveen */
        let TABLE_VIDEO_HELP_DETAIL = getJsonFromTable_Re(tableName: DBHelper.TABLE_HELP_VIDEO_DETAIL, db: database, isDispatch: "0")
        
        
        //var jsonObject[String: Any] = [String: Any]()
        //var object = Synchronization()
        var jsonObject = JSON()
        //var object = JSON()
        
        let getDistributorReturnSyncData_js = JSON(getDistributorReturnSyncData())
        if getDistributorReturnSyncData_js != nil && !getDistributorReturnSyncData_js.isEmpty {
            jsonObject["ishop_distributor_return"] = getDistributorReturnSyncData_js
        }
        let getDistributorReturnProductSyncData_js = JSON(getDistributorReturnProductSyncData())
        //object.ishop_distributor_return = getDistributorReturnSyncData_js
        //object.ishop_distributor_return_product = getDistributorReturnProductSyncData()
        if getDistributorReturnProductSyncData_js != nil && !getDistributorReturnProductSyncData_js.isEmpty {
            jsonObject["ishop_distributor_return_product"] = getDistributorReturnProductSyncData_js
        }
        
        //var main_JSON_obj = JSON()
        //let toller_value = JSON(TABLE_TOLLER_DISPATCH)
        //print(toller_value)
        
        do {
            
            // let jsonObject1 = try getJsonFromObject(object)
            
            //jsonObject = try jsonObject(jsonObject1)
            
            
            if TABLE_TOLLER_DISPATCH != nil && !TABLE_TOLLER_DISPATCH.isEmpty {
                jsonObject["ishop_toller_dispatch"] = JSON(TABLE_TOLLER_DISPATCH)
                //                main_JSON_obj["ishop_toller_dispatch"] = JSON(TABLE_TOLLER_DISPATCH)
                
            }
            
            if TABLE_TOLLER_DISPATCH_PRODUCT != nil && !TABLE_TOLLER_DISPATCH_PRODUCT.isEmpty {
                jsonObject["ishop_toller_dispatch_product"] = JSON(TABLE_TOLLER_DISPATCH_PRODUCT)
            }
            
            if TABLE_RETAILER_DISPATCH != nil && !TABLE_RETAILER_DISPATCH.isEmpty {
                jsonObject["ishop_retailer_dispatch"] = JSON(TABLE_RETAILER_DISPATCH)
            }
            
            if TABLE_RETAILER_DISPATCH_PRODUCT != nil && !TABLE_RETAILER_DISPATCH_PRODUCT.isEmpty {
                jsonObject["ishop_retailer_dispatch_product"] = JSON(TABLE_RETAILER_DISPATCH_PRODUCT)
            }
            
            if TABLE_CFA_DISPATCH != nil && !TABLE_CFA_DISPATCH.isEmpty {
                jsonObject["ishop_cfa_dispatch"] = JSON(TABLE_CFA_DISPATCH)
            }
            
            if TABLE_CFA_DISPATCH_PRODUCT != nil && !TABLE_CFA_DISPATCH_PRODUCT.isEmpty {
                jsonObject["ishop_cfa_dispatch_product"] = JSON(TABLE_CFA_DISPATCH_PRODUCT)
            }
            
            if TABLE_SAMPLE_DISPATCH != nil && !TABLE_SAMPLE_DISPATCH.isEmpty {
                jsonObject["ishop_sample_dispatch"] = JSON(TABLE_SAMPLE_DISPATCH)
            }
            
            if TABLE_SAMPLE_DISPATCH_PRODUCT != nil && !TABLE_SAMPLE_DISPATCH_PRODUCT.isEmpty {
                jsonObject["ishop_sample_dispatch_product"] = JSON(TABLE_SAMPLE_DISPATCH_PRODUCT)
            }
            
            if TABLE_CFA_RETURN != nil && !TABLE_CFA_RETURN.isEmpty {
                jsonObject["ishop_cfa_return"] = JSON(TABLE_CFA_RETURN)
            }
            
            if TABLE_DISTRIBUTOR_DISPATCH != nil && !TABLE_DISTRIBUTOR_DISPATCH.isEmpty {
                jsonObject["ishop_distributor_dispatch"] = JSON(TABLE_DISTRIBUTOR_DISPATCH)
            }
            
            if TABLE_DISTRIBUTOR_DISPATCH_PRODUCT != nil && !TABLE_DISTRIBUTOR_DISPATCH_PRODUCT.isEmpty {
                jsonObject["ishop_distributor_dispatch_product"] = JSON(TABLE_DISTRIBUTOR_DISPATCH_PRODUCT)
            }
            
            if TABLE_ishop_distributor_received != nil && !TABLE_ishop_distributor_received.isEmpty {
                jsonObject["ishop_distributor_received"] = JSON(TABLE_ishop_distributor_received)
            }
            
            if TABLE_ishop_distributor_received_product != nil && !TABLE_ishop_distributor_received_product.isEmpty {
                jsonObject["ishop_distributor_received_product"] = JSON(TABLE_ishop_distributor_received_product)
            }
            
            if TABLE_ishop_reatialer_received != nil && !TABLE_ishop_reatialer_received.isEmpty {
                jsonObject["ishop_retailer_received"] = JSON(TABLE_ishop_reatialer_received)
            }
            
            if TABLE_ishop_reatialer_received_product != nil && !TABLE_ishop_reatialer_received_product.isEmpty {
                jsonObject["ishop_retailer_received_product"] = JSON(TABLE_ishop_reatialer_received_product)
            }
            
            if TABLE_bf_ishop_cfa_return != nil && !TABLE_bf_ishop_cfa_return.isEmpty {
                jsonObject["ishop_cfa_return"] = JSON(TABLE_bf_ishop_cfa_return)
            }
            
            if TABLE_bf_ishop_cfa_return_product != nil && !TABLE_bf_ishop_cfa_return_product.isEmpty {
                jsonObject["ishop_cfa_return_product"] = JSON(TABLE_bf_ishop_cfa_return_product)
            }
            
            if TABLE_bf_ishop_distributor_return_request != nil && !TABLE_bf_ishop_distributor_return_request.isEmpty {
                jsonObject["ishop_distributor_return_request"] = JSON(TABLE_bf_ishop_distributor_return_request)
            }
            
            if TABLE_bf_ishop_distributor_return_request_product != nil && !TABLE_bf_ishop_distributor_return_request_product.isEmpty {
                jsonObject["ishop_distributor_return_request_product"] = JSON(TABLE_bf_ishop_distributor_return_request_product)
            }
            
            if TABLE_SALES_REP_INITIATED_PRODUCT != nil && !TABLE_SALES_REP_INITIATED_PRODUCT.isEmpty {
                jsonObject["sales_rep_initiated_product"] = JSON(TABLE_SALES_REP_INITIATED_PRODUCT)
            }
            
            if TABLE_CFA_DAMAGE != nil && !TABLE_CFA_DAMAGE.isEmpty {
                jsonObject["ishop_cfa_damage"] = JSON(TABLE_CFA_DAMAGE)
            }
            
            if TABLE_CFA_DAMAGE_PRODUCT != nil && !TABLE_CFA_DAMAGE_PRODUCT.isEmpty {
                jsonObject["ishop_cfa_damage_product"] = JSON(TABLE_CFA_DAMAGE_PRODUCT)
            }
            
            if TABLE_DIST_DAMAGE != nil && !TABLE_DIST_DAMAGE.isEmpty {
                jsonObject["ishop_distributor_damage"] = JSON(TABLE_DIST_DAMAGE)
            }
            
            if TABLE_DIST_DAMAGE_PRODUCT != nil && !TABLE_DIST_DAMAGE_PRODUCT.isEmpty {
                jsonObject["ishop_distributor_damage_product"] = JSON(TABLE_DIST_DAMAGE_PRODUCT)
            }
            
            if TABLE_RET_DAMAGE != nil && !TABLE_RET_DAMAGE.isEmpty {
                jsonObject["ishop_retailer_damage"] = JSON(TABLE_RET_DAMAGE)
            }
            
            if TABLE_RET_DAMAGE_PRODUCT != nil && !TABLE_RET_DAMAGE_PRODUCT.isEmpty {
                jsonObject["ishop_retailer_damage_product"] = JSON(TABLE_RET_DAMAGE_PRODUCT)
            }
            
            if TABLE_VIDEO_HELP_DETAIL != nil && !TABLE_VIDEO_HELP_DETAIL.isEmpty {
                jsonObject["bf_master_cpm_help_video_details"] = JSON(TABLE_VIDEO_HELP_DETAIL)
            }
            
            if TABLE_SAVE_OFFLINE_LOG != nil && !TABLE_SAVE_OFFLINE_LOG.isEmpty {
                jsonObject["bf_ishop_save_offline_log_android_cpm"] = JSON(TABLE_SAVE_OFFLINE_LOG)
            }
            
            if TABLE_DEVICE_TOKEN != nil && !TABLE_DEVICE_TOKEN.isEmpty {
                jsonObject["table_device_token"] = JSON(TABLE_DEVICE_TOKEN)
            }
            
            if TABLE_TRANSACTION_ERROR != nil && !TABLE_TRANSACTION_ERROR.isEmpty {
                jsonObject["bf_ishop_transaction_error_log"] = JSON(TABLE_TRANSACTION_ERROR)
            }
            
            if TABLE_ISHOP_PALLET_DETAILS != nil && !TABLE_ISHOP_PALLET_DETAILS.isEmpty {
                jsonObject["bf_ishop_pallet_details"] = JSON(TABLE_ISHOP_PALLET_DETAILS)
            }
            
            //writeStringAsFile(jsonObject.toString(), "RE_CPM", context)
            
            writeStringAsFile(fileName: "RE_CPM", fileContents: jsonObject.description)
            
            //DHAVALP_FILE
            print("SYNCHRONIZATION JSON : \(jsonObject)")
            return jsonObject.description
        } catch let error as NSError {
            //            print("Error: \(error.localizedDescription)")
            //            if let callback = callback {
            //                callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error))
            //            }
            //            SynchronizationService.isSuccess = false
            //            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error)
            //            print("error ->> \(error)")
            return "json not found"
        }
    }

    
    func getSynchronizationMaster() -> String {
        let TABLE_TRANSACTION_ERROR = JSON()
        let TABLE_ISHOP_PALLET_DETAILS = JSON()
        let TABLE_DEVICE_TOKEN = JSON()
        let TABLE_SAVE_OFFLINE_LOG = JSON()
        let TABLE_TOLLER_DISPATCH = JSON()
        let TABLE_TOLLER_DISPATCH_PRODUCT = JSON()
        let TABLE_RETAILER_DISPATCH = JSON()
        let TABLE_RETAILER_DISPATCH_PRODUCT = JSON()
        let TABLE_CFA_DISPATCH = JSON()
        let TABLE_CFA_DISPATCH_PRODUCT = JSON()
        let TABLE_SAMPLE_DISPATCH = JSON()
        let TABLE_SAMPLE_DISPATCH_PRODUCT = JSON()
        let TABLE_CFA_RETURN = JSON()
        var TABLE_DISTRIBUTOR_DISPATCH = JSON()
        var TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = JSON()
        
        // For Sample and FOC Invalid
        TABLE_DISTRIBUTOR_DISPATCH = []
        TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = []
        
        // Amit Vaghela changes
        var TABLE_ishop_distributor_received = JSON()
        var TABLE_ishop_distributor_received_product = JSON()
        var TABLE_ishop_reatialer_received = JSON()
        var TABLE_ishop_reatialer_received_product = JSON()
        var TABLE_bf_ishop_cfa_return = JSON()
        var TABLE_bf_ishop_cfa_return_product = JSON()
        var TABLE_bf_ishop_distributor_return_request = JSON()
        var TABLE_bf_ishop_distributor_return_request_product = JSON()
        var TABLE_SALES_REP_INITIATED_PRODUCT = JSON()
        var TABLE_CFA_DAMAGE = JSON()
        var TABLE_CFA_DAMAGE_PRODUCT = JSON()
        var TABLE_DIST_DAMAGE = JSON()
        var TABLE_DIST_DAMAGE_PRODUCT = JSON()
        var TABLE_RET_DAMAGE = JSON()
        var TABLE_RET_DAMAGE_PRODUCT = JSON()
        var TABLE_VIDEO_HELP_DETAIL = JSON()


        //var object = Synchronization()
        var object = JSON()
        object["ishop_distributor_return"] = []
        object["ishop_distributor_return_product"] = []
        
        
        
        do {
            
            //let jsonObject1 = try getJsonFromObject(object)
            
            //var jsonObject = try JSONSerialization.jsonObject(with: JSONSerialization.data(withJSONObject: object, options: []), options: []) as! [String: Any]
            
            var jsonObject = JSON(object)

            if TABLE_TOLLER_DISPATCH.count > 0 {
                jsonObject["ishop_toller_dispatch"] = TABLE_TOLLER_DISPATCH
            }
            if TABLE_TOLLER_DISPATCH_PRODUCT.count > 0 {
                jsonObject["ishop_toller_dispatch_product"] = TABLE_TOLLER_DISPATCH_PRODUCT
            }
            if TABLE_RETAILER_DISPATCH.count > 0 {
                jsonObject["ishop_retailer_dispatch"] = TABLE_RETAILER_DISPATCH
            }
            if TABLE_RETAILER_DISPATCH_PRODUCT.count > 0 {
                jsonObject["ishop_retailer_dispatch_product"] = TABLE_RETAILER_DISPATCH_PRODUCT
            }
            if TABLE_CFA_DISPATCH.count > 0 {
                jsonObject["ishop_cfa_dispatch"] = TABLE_CFA_DISPATCH
            }
            if TABLE_CFA_DISPATCH_PRODUCT.count > 0 {
                jsonObject["ishop_cfa_dispatch_product"] = TABLE_CFA_DISPATCH_PRODUCT
            }
            if TABLE_SAMPLE_DISPATCH.count > 0 {
                jsonObject["ishop_sample_dispatch"] = TABLE_SAMPLE_DISPATCH
            }
            if TABLE_SAMPLE_DISPATCH_PRODUCT.count > 0 {
                jsonObject["ishop_sample_dispatch_product"] = TABLE_SAMPLE_DISPATCH_PRODUCT
            }
            if TABLE_CFA_RETURN.count > 0 {
                jsonObject["ishop_cfa_return"] = TABLE_CFA_RETURN
            }
            if TABLE_DISTRIBUTOR_DISPATCH.count > 0 {
                jsonObject["ishop_distributor_dispatch"] = TABLE_DISTRIBUTOR_DISPATCH
            }
            if TABLE_DISTRIBUTOR_DISPATCH_PRODUCT.count > 0 {
                jsonObject["ishop_distributor_dispatch_product"] = TABLE_DISTRIBUTOR_DISPATCH_PRODUCT
            }
            if TABLE_ishop_distributor_received.count > 0 {
                jsonObject["ishop_distributor_received"] = TABLE_ishop_distributor_received
            }
            if TABLE_ishop_distributor_received_product.count > 0 {
                jsonObject["ishop_distributor_received_product"] = TABLE_ishop_distributor_received_product
            }
            if TABLE_ishop_reatialer_received.count > 0 {
                jsonObject["ishop_retailer_received"] = TABLE_ishop_reatialer_received
            }
            if TABLE_ishop_reatialer_received_product.count > 0 {
                jsonObject["ishop_retailer_received_product"] = TABLE_ishop_reatialer_received_product
            }
            if TABLE_bf_ishop_cfa_return.count > 0 {
                jsonObject["ishop_cfa_return"] = TABLE_bf_ishop_cfa_return
            }
            if TABLE_bf_ishop_cfa_return_product.count > 0 {
                jsonObject["ishop_cfa_return_product"] = TABLE_bf_ishop_cfa_return_product
            }
            if TABLE_bf_ishop_distributor_return_request.count > 0 {
                jsonObject["ishop_distributor_return_request"] = TABLE_bf_ishop_distributor_return_request
            }
            if TABLE_bf_ishop_distributor_return_request_product.count > 0 {
                jsonObject["ishop_distributor_return_request_product"] = TABLE_bf_ishop_distributor_return_request_product
            }
            if TABLE_SALES_REP_INITIATED_PRODUCT.count > 0 {
                jsonObject["sales_rep_initiated_product"] = TABLE_SALES_REP_INITIATED_PRODUCT
            }
            if TABLE_CFA_DAMAGE.count > 0 {
                jsonObject["ishop_cfa_damage"] = TABLE_CFA_DAMAGE
            }
            if TABLE_CFA_DAMAGE_PRODUCT.count > 0 {
                jsonObject["ishop_cfa_damage_product"] = TABLE_CFA_DAMAGE_PRODUCT
            }
            if TABLE_DIST_DAMAGE.count > 0 {
                jsonObject["ishop_distributor_damage"] = TABLE_DIST_DAMAGE
            }
            if TABLE_DIST_DAMAGE_PRODUCT.count > 0 {
                jsonObject["ishop_distributor_damage_product"] = TABLE_DIST_DAMAGE_PRODUCT
            }
            if TABLE_RET_DAMAGE.count > 0 {
                jsonObject["ishop_retailer_damage"] = TABLE_RET_DAMAGE
            }
            if TABLE_RET_DAMAGE_PRODUCT.count > 0 {
                jsonObject["ishop_retailer_damage_product"] = TABLE_RET_DAMAGE_PRODUCT
            }
            if TABLE_VIDEO_HELP_DETAIL.count > 0 {
                jsonObject["bf_master_cpm_help_video_details"] = TABLE_VIDEO_HELP_DETAIL
            }

            if TABLE_SAVE_OFFLINE_LOG.count > 0 {
                jsonObject["bf_ishop_save_offline_log_android_cpm"] = TABLE_SAVE_OFFLINE_LOG
            }

            if TABLE_DEVICE_TOKEN.count > 0 {
                jsonObject["table_device_token"] = TABLE_DEVICE_TOKEN
            }

            if TABLE_TRANSACTION_ERROR.count > 0 {
                jsonObject["bf_ishop_transaction_error_log"] = TABLE_TRANSACTION_ERROR
            }

            if TABLE_ISHOP_PALLET_DETAILS.count > 0 {
                jsonObject["bf_ishop_pallet_details"] = TABLE_ISHOP_PALLET_DETAILS
            }

            writeStringAsFile(jsonObject.description, fileName: "RE_CPM", context: nil)
            print("SYNCHRONIZATION JSON : \(jsonObject)")
            return jsonObject.description
        } catch {
//            if let callback = callback {
//                callback.onDatabaseError(String(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(error: error))
//            }
//            SynchronizationService.isSuccess = false
//            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(error: error)
//            print("error ->> \(error)")
            return "json not found"
        }
    }
    
    func getRequestFileName(userId: String) -> String {
        var prefix = "jsonData_Android"
        
        do {
            //prefix = "\(prefix)_\(userId)_\(getRandomNumber())_"
            prefix = "\(prefix)_\(userId)_temp_"
            let currentDateAndTime = DateFormatter.localizedString(from: Date(), dateStyle: .short, timeStyle: .short)
            
            let formatter = DateFormatter()
            formatter.dateFormat = "ddMMyyyyHHmmss"
            let currentDateandTime = formatter.string(from: Date())
            
            return prefix + currentDateandTime + ".txt"
        } catch {
            print(error.localizedDescription)
        }
        
        return ""
    }

    func getRandomNumber() -> Int {
        return Int(arc4random_uniform(UInt32.max))
    }
    
    class ScopedStorage {
        // Replace 'YourAppDirectoryName' with the actual directory name
        static let EXTERNAL_STORAGE_RECPM_SYNC_REQUEST = "RECPM_SYNC_REQUEST"
        static let EXTERNAL_STORAGE_RECPM_SYNC_REQUEST_ZIP_LOCATION = "RECPM_SYNC_REQUEST_ZIP_LOCATION"

        static func getInstance(context: AnyObject) -> ScopedStorage {
            return ScopedStorage()
        }

//        func createDelete(_ path: String) throws -> URL {
//            // Replace with the actual implementation for creating a directory
//            // at the given path
//            return URL(fileURLWithPath: path)
//        }

        static func getPath(fileName: String) -> String {
                var path = ""
                do {
                    var root: URL
                    if #available(iOS 14.0, *) {
                        root = try FileManager.default.url(for: .documentDirectory, in: .userDomainMask, appropriateFor: nil, create: false)
                    } else {
                        root = try FileManager.default.url(for: .documentDirectory, in: .userDomainMask, appropriateFor: nil, create: false)
                    }

                    let fileURL = root.appendingPathComponent(fileName)

                    if FileManager.default.fileExists(atPath: fileURL.path) {
                        path = fileURL.path
                    } else {
                        path = root.path
                    }
                } catch {
                    print("Error getting file path: \(error.localizedDescription)")
                }

                print("TAG_GETPATH", path)
                return path
            }
        
        static func createDelete(fileName: String) throws -> URL {
                let root: URL
                do {
                    if #available(iOS 14.0, *) {
                        root = try FileManager.default.url(for: .documentDirectory, in: .userDomainMask, appropriateFor: nil, create: true)
                    } else {
                        root = try FileManager.default.url(for: .documentDirectory, in: .userDomainMask, appropriateFor: nil, create: true)
                    }

                    let fileURL = root.appendingPathComponent(fileName)

                    if FileManager.default.fileExists(atPath: fileURL.path) {
                        try FileManager.default.removeItem(at: fileURL)
                    }
                    try FileManager.default.createDirectory(at: fileURL, withIntermediateDirectories: true, attributes: nil)

                } catch {
                    throw error
                }

                return root
            }
    }

    class DatabaseHelperExtended {
        // Replace with the actual implementation for error log insertion
        func insertTransactionErrorLog(context: AnyObject, className: String, methodName: String, exception: String, exceptionMessage: String, errorCode: String, errorMessage: String, userID: String) {
            // Actual implementation here
        }
    }

    func getFileName(filenameWithExtension: String) -> String {
        return (filenameWithExtension as NSString).deletingPathExtension
    }
    
    func generateNoteOnSDForAll(sFileName: String, sBody: String, context: AnyObject) -> String? {
        do {
            let root = try SwiftEcpSyncPlugin.ScopedStorage.createDelete(fileName: ScopedStorage.EXTERNAL_STORAGE_RECPM_SYNC_REQUEST)
            
            let child_cir = root.appendingPathComponent(ScopedStorage.EXTERNAL_STORAGE_RECPM_SYNC_REQUEST)
            print(root)
            print(child_cir)
            
            let gpxfile = child_cir.appendingPathComponent(sFileName)
            print(gpxfile)
            try sBody.write(to: gpxfile, atomically: true, encoding: .utf8)
            
            print(sFileName)
            sleep(3)
            
            var path =  SwiftEcpSyncPlugin.ScopedStorage.getPath(fileName: ScopedStorage.EXTERNAL_STORAGE_RECPM_SYNC_REQUEST) + "/" + sFileName
            print(path)
            return  path
        } catch {
            print(error.localizedDescription)
//            databaseHelperExtended.insertTransactionErrorLog(context: context, className: String(describing: context), methodName: "callSyncAPI", exception: AppUtil.getStackTrace(error), exceptionMessage: AppUtil.getStackTrace(error), errorCode: "", errorMessage: "", userID: userID)
        }
        return nil
    }
    
    func getJsonFromTable_Re(tableName: String, db: FMDatabase, isDispatch: String) -> [[String: Any]] {
        db.open()
        var jsonTableData = [[String: Any]]()
        var qry = ""
        
        if isDispatch.lowercased() == "1" {
            if tableName.lowercased() == DBHelper.TABLE_CFA_DISPATCH.lowercased() {
                            qry = "SELECT * FROM \(tableName) WHERE sync_flag = 'Y' AND isDispatch = 1 GROUP BY cfa_dispatch_id"
                        } else {
                            qry = "SELECT * FROM \(tableName) WHERE sync_flag = 'Y' AND isDispatch = 1"
                        }
        } else if isDispatch.lowercased() == "2" {
            qry = "SELECT * FROM \(tableName) WHERE sync_flag = 'Y'"
        } else {
            switch tableName {
            case DBHelper.TABLE_TOLLER_DISPATCH_PRODUCT:
                qry = "SELECT * FROM \(tableName) WHERE sync_flag = 'Y'"
            case DBHelper.TABLE_CFA_DISPATCH_PRODUCT:
                qry = "SELECT bicdp.* FROM bf_ishop_cfa_dispatch_product AS bicdp " +
                      "INNER JOIN bf_ishop_cfa_dispatch AS bicd ON bicdp.cfa_dispatch_id = bicd.cfa_dispatch_id " +
                      "WHERE bicdp.sync_flag = 'Y' AND bicd.isDispatch = 1"
            case DBHelper.TABLE_DISTRIBUTOR_DISPATCH_PRODUCT:
                qry = "SELECT biddp.* FROM bf_ishop_distributor_dispatch_product AS biddp " +
                      "INNER JOIN bf_ishop_distributor_dispatch AS bidd ON biddp.distributor_dispatch_id = bidd.distributor_dispatch_id " +
                      "WHERE biddp.sync_flag = 'Y' AND bidd.isDispatch = 1"
            case DBHelper.TABLE_RETAILER_DISPATCH_PRODUCT:
                qry = "SELECT birdp.* FROM bf_ishop_retailer_dispatch_product AS birdp " +
                      "INNER JOIN bf_ishop_retailer_dispatch AS bird ON birdp.retailer_dispatch_id = bird.retailer_dispatch_id " +
                      "WHERE birdp.sync_flag = 'Y' AND bird.isDispatch = 1"
            case DBHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT:
                qry = "SELECT birdp.* FROM bf_ishop_distributor_received_product AS birdp " +
                      "INNER JOIN bf_ishop_distributor_received AS bird ON birdp.distributor_received_id = bird.distributor_received_id " +
                      "WHERE birdp.sync_flag = 'Y' AND bird.isDispatch = 1"
            case DBHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT:
                qry = "SELECT birdp.* FROM bf_ishop_retailer_received_product AS birdp " +
                      "INNER JOIN bf_ishop_retailer_received AS bird ON birdp.retailer_received_id = bird.retailer_received_id " +
                      "WHERE birdp.sync_flag = 'Y' AND bird.isDispatch = 1"
            case DBHelper.TABLE_CFA_RETURN_PRODUCT:
                qry = "SELECT birdp.* FROM bf_ishop_cfa_return_product AS birdp " +
                      "INNER JOIN bf_ishop_cfa_return AS bird ON birdp.cfa_return_id = bird.cfa_return_id " +
                      "WHERE birdp.sync_flag = 'Y' AND bird.isDispatch = 1"
            case DBHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT:
                qry = """
                    SELECT birdp.*
                    FROM bf_ishop_distributor_return_request_product AS birdp
                    INNER JOIN bf_ishop_distributor_return_request AS bird
                    ON birdp.distributor_return_request_id = bird.distributor_return_request_id
                    WHERE birdp.sync_flag = 'Y'
                    AND bird.isDispatch = 1;
                """
            case DBHelper.TABLE_CustomerType_Details:
                qry = "Select * from CustomerType_Details;"
            case DBHelper.TABLE_CFA_DAMAGE:
                qry = "Select * from bf_ishop_cfa_damage WHERE isDamage='1' AND sync_flag='Y';"
            case DBHelper.TABLE_CFA_DAMAGE_PRODUCT:
                qry = """
                    SELECT bicdp.*
                    FROM bf_ishop_cfa_damage_product AS bicdp
                    INNER JOIN bf_ishop_cfa_damage AS bicd
                    ON bicd.cfa_damage_id = bicdp.cfa_damage_id
                    WHERE bicdp.sync_flag = 'Y' AND bicd.isDamage = '1';
                """
            case DBHelper.TABLE_DISTRIBUTOR_DAMAGE:
                qry = "Select * from bf_ishop_distributor_damage WHERE isDamage='1' AND sync_flag='Y';"
            case DBHelper.TABLE_DISTRIBUTOR_DAMAGE_PRODUCT:
                qry = """
                    SELECT bicdp.*
                    FROM bf_ishop_distributor_damage_product AS bicdp
                    INNER JOIN bf_ishop_distributor_damage AS bicd
                    ON bicd.distributor_damage_id = bicdp.distributor_damage_id
                    WHERE bicdp.sync_flag = 'Y' AND bicd.isDamage = '1';
                """
            case DBHelper.TABLE_RETAILER_DAMAGE:
                qry = "Select * from bf_ishop_retailer_damage WHERE isDamage='1' AND sync_flag='Y';"
            case DBHelper.TABLE_RETAILER_DAMAGE_PRODUCT:
                qry = """
                    SELECT bicdp.*
                    FROM bf_ishop_retailer_damage_product AS bicdp
                    INNER JOIN bf_ishop_retailer_damage AS bicd
                    ON bicd.retailer_damage_id = bicdp.retailer_damage_id
                    WHERE bicdp.sync_flag = 'Y' AND bicd.isDamage = '1';
                """
            case DBHelper.TABLE_HELP_VIDEO_DETAIL:
                qry = """
                    Select video_type_details_id, video_type_id, customer_id, isDownload, created_on,
                    modified_on, sync_flag, sync_date, sync_by_user, country_id, imeino AS imei_no
                    from bf_master_cpm_help_video_details where sync_flag = 'Y'
                """
            case DBHelper.TABLE_SAVE_OFFLINE_LOG:
                qry = "select * from \(tableName)"
            case DBHelper.TABLE_DEVICE_TOKEN:
                qry = "select * from \(tableName)"
            case DBHelper.TABLE_TRANSACTION_ERROR_LOG:
                qry = """
                select * from \(tableName)
                """
            default:
                qry = """
SELECT * FROM \(tableName) WHERE sync_flag='Y'
"""
            }
        }
        
        qry = qry.trim().replacingOccurrences(of: "\\", with: "")
        
        if let c = db.executeQuery(qry, withArgumentsIn: []) {
                while c.next() {
                    let totalColumn = c.columnCount
                    var rowObject = [String: Any]()
                    
                    for columnIndex in 0..<c.columnCount {
                            let columnName = c.columnName(for: columnIndex)

                            // Get the value of the column
                            if let columnValue = c.object(forColumnIndex: columnIndex) {
                                // Check the class of the columnValue to determine its type
                                if columnValue is String {
                                    if columnName != "isDispatch" {
                                        rowObject[columnName!] = c.string(forColumn: columnName!) ?? ""
                                    }
                                    //print("\(columnName) is a String: \(columnValue as? String ?? "")")
                                } else if columnValue is Int {
                                    //print("\(columnName) is an Int: \(columnValue as? Int ?? 0)")
                                    if columnName != "id" && columnName != "_id" && columnName != "intglcode" {
                                        rowObject[columnName!] = c.long(forColumn: columnName!)
                                    }
                                } else if columnValue is Double {
                                    // Handle the REAL type
                                    rowObject[columnName!] = c.double(forColumn: columnName!)
                                    //print("\(columnName) is a Double (REAL): \(columnValue as? Double ?? 0.0)")
                                } else if columnValue is Bool {
                                    rowObject[columnName!] = c.bool(forColumn: columnName!)
                                    //print("\(columnName) is a Bool: \(columnValue as? Bool ?? false)")
                                } else {
                                    rowObject[columnName!] = ""
                                    // Handle other types as needed
                                    //print("\(columnName) has an unknown type")
                                }
                            } else {
                                rowObject[columnName!] = ""
                               // print("\(columnName) has a nil value")
                            }
                        }

                    jsonTableData.append(rowObject)
                }

                c.close()
            }
        
        db.close()
        
        return jsonTableData
    }



    // Function to write string to file, replace with your actual implementation
    func writeStringAsFile(_ content: String, fileName: String, context: Any?) {
        // Your implementation to write content to a file
    }

    func insertRecordDynamicIFFCO(tableName:String, jsonArray:JSON)->Bool{

        // DispatchQueue.global(qos: .background).async {
        var success = true

        do{
            let isTranTable = (tableName == DBHelper.IFFCO_TABLE_CPM_CUSTOMER_DISPATCH
                || tableName == DBHelper.IFFCO_TABLE_CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS
                || tableName == DBHelper.IFFCO_TABLE_CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS
                || tableName == DBHelper.IFFCO_TABLE_CPM_CUSTOMER_STICKER_BLOCK
                || tableName == DBHelper.IFFCO_TABLE_CPM_CUSTOMER_STICKER_BLOCK_REMOVE
                || tableName == DBHelper.IFFCO_TABLE_PERSON_MST
                || tableName == DBHelper.IFFCO_TABLE_CUSTOMER_MST
                || tableName == DBHelper.IFFCO_TABLE_PRODUCT_SKU_MST
                || tableName == DBHelper.IFFCO_TABLE_CUSTOMER_TYPE_MST
                || tableName == DBHelper.IFFCO_TABLE_CPM_BLOCK_TYPE
                || tableName == DBHelper.IFFCO_TABLE_POLITICAL_GEOGRAPHY_LEVEL_MST
                || tableName == DBHelper.IFFCO_TABLE_POLITICAL_GEOGRAPHY_DETAILS
                || tableName == DBHelper.IFFCO_TABLE_CPM_PALLET_MST
                || tableName == DBHelper.IFFCO_TABLE_CPM_SKU_STRICKER_Details
                || tableName == DBHelper.IFFCO_TABLE_CPM_STRICKER_Details)
            print(tableName)

            /*if(tableName == "CPM_Sticker_Details" || tableName == "Customer_Type_Country_Mst"){
             let deleteQuery = "DELETE FROM \(tableName)"
             self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
             }*/

            /*if(tableName != "CPM_Sticker_Details"){
             return true
             }*/

            if !isTranTable && self.database.open()
            {
                let deleteQuery = "DELETE FROM \(tableName)"
                self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                //// print("here one")
            }else{
                if (tableName != DBHelper.IFFCO_TABLE_CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS
                    && tableName != DBHelper.IFFCO_TABLE_CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS
                    && tableName != DBHelper.IFFCO_TABLE_CPM_CUSTOMER_STICKER_BLOCK
                    && tableName != DBHelper.IFFCO_TABLE_CPM_CUSTOMER_STICKER_BLOCK_REMOVE) {

                    let deleteQuery = "DELETE FROM \(tableName) WHERE CHR_SYNC = 'N'"
                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                }
                // print("here two")
            }

//            if(tableName == "CPM_STICKER_DETAILS"){
//                return parseJsonStickerDetailsIFFCO_CPM_STICKER_DETAILS(Tourplan_Daily: jsonArray)
//                //return true
//            } else if(tableName == "CPM_SKU_STICKER_DETAILS"){
//                return parseJsonStickerDetailsIFFCO_CPM_SKU_STICKER_DETAILS(Tourplan_Daily: jsonArray)
//                //return true
//            } else{

                if(jsonArray.count>0){

                    var sbQuery = ""

                    sbQuery = "INSERT INTO \(tableName) ("

                    let keys = jsonArray[0].dictionaryValue.keys.sorted()

                    var sbQuery2 = ""
                    for (position, name) in keys.enumerated() {
                        if(name=="CHR_TRAN"){
                            continue
                        }
                        sbQuery2.append(name)
                        sbQuery2.append(",")
                    }

                    sbQuery2 = sbQuery2.trim()
                    sbQuery2 = String(sbQuery2.dropLast())

                    sbQuery.append(sbQuery2)
                    sbQuery.append(" ) VALUES ")

                    let arraySize = jsonArray.count
                    let BATCHSIZE = 150
                    let intBatch = Int(CGFloat(ceil(Double(Double(arraySize) * 1.00 / Double(BATCHSIZE)))))-1
                    let intRemainder = Int(Double(arraySize).truncatingRemainder(dividingBy: Double(BATCHSIZE)))
                    var intMaxRecords = Int(BATCHSIZE)

                    //print("intBatch:\(intBatch)")
                    //print("intRemainder:\(intRemainder)")
                    //print("intMaxRecords:\(intMaxRecords)")

                    //print("here 1:\(sbQuery)")

                    for b in 0...intBatch {
                         try autoreleasepool {

                              var finalInsert=""
                              finalInsert.append(sbQuery)
                              if (b == intBatch) {
                                   intMaxRecords = intRemainder == 0 ? BATCHSIZE : intRemainder;
                              }

                              var valuesBuiler=""
                              var deleteValues = [String]()
                              var deleteQ=""
                              let innerLoopSize = Int((b * Int(BATCHSIZE)) + intMaxRecords)-1
                              let tmp1 = Int((b * BATCHSIZE))

                              //print("BATCHSIZE:\(BATCHSIZE)")
                              //print("innerLoopSize:\(innerLoopSize)")
                              //print("tmp1:\(tmp1)")

                              for m in tmp1...innerLoopSize {
                                   //let jsonObject = jsonArray[m]
                                   if(jsonArray[m].dictionaryValue.keys.contains("CHR_TRAN")){
                                        let chrTran = jsonArray[m].dictionaryValue["CHR_TRAN"]?.string

                                        if (jsonArray[m].dictionaryValue.keys.contains("VAR_SYNC_CODE")) {
                                             deleteQ.append(deleteValues.count <= 0 ? "?" : ",?")
                                             deleteValues.append((jsonArray[m].dictionaryValue["VAR_SYNC_CODE"]?.string)!)
                                        }
                                        if (chrTran != nil && chrTran!.caseInsensitiveCompare("d") == .orderedSame) {
                                             continue
                                        }
                                   }

                                   if (!valuesBuiler.isEmpty){
                                        valuesBuiler.append(",")
                                   }

                                   valuesBuiler.append("(")

                                   for (pos, key) in jsonArray[m].dictionaryValue.keys.sorted().enumerated() {

                                        let hasNext = (pos != jsonArray[m].dictionaryValue.keys.count-1)
                                        if (key=="CHR_TRAN") {
                                             if (!hasNext && valuesBuiler.contains(",")) {
                                                  valuesBuiler.remove(at: valuesBuiler.lastIndex(of: ",")!)
                                             }
                                             continue
                                        }

                                        let tmp = jsonArray[m].dictionaryValue[key]?.string

                                        if (tmp != nil && !(tmp?.isEmpty)! && tmp != "null") {
                                             valuesBuiler.append("'")
                                             valuesBuiler.append(tmp!.replace(target: "'", withString: "''"))
                                             valuesBuiler.append("'")
                                        }else if(tmp == "null" || tmp == "NULL"){
                                             valuesBuiler.append("NULL")
                                        }else{
                                             let ddd = nullToNil(value: jsonArray[m].dictionaryValue[key] as AnyObject)

                                             if let actualVariable = ddd {
                                                  valuesBuiler = valuesBuiler + " \(actualVariable)"
                                             }
                                        }
                                        valuesBuiler.append(hasNext ? "," : "")
                                        valuesBuiler = valuesBuiler.trim()
                                        if(valuesBuiler.contains(",,") || valuesBuiler.contains(", ,") || valuesBuiler.contains("( ,") || valuesBuiler.contains("(,")){
                                             if(valuesBuiler.contains(",,")){
                                                  let newString = valuesBuiler.replacingOccurrences(of: ",,", with: ",'',", options: .literal, range: nil)
                                                  valuesBuiler = newString
                                             }
                                             if(valuesBuiler.contains(", ,")){
                                                  let newString1 = valuesBuiler.replacingOccurrences(of: ", ,", with: ",'',", options: .literal, range: nil)
                                                  valuesBuiler = newString1
                                             }

                                             if(valuesBuiler.contains("(,")){
                                                  let newString3 = valuesBuiler.replacingOccurrences(of: "(,", with: "('',", options: .literal, range: nil)
                                                  valuesBuiler = newString3
                                             }

                                             if(valuesBuiler.contains("( ,")){
                                                  let newString3 = valuesBuiler.replacingOccurrences(of: "( ,", with: "('',", options: .literal, range: nil)
                                                  valuesBuiler = newString3
                                             }
                                        }
                                   }
                                   valuesBuiler.append(")")

                                   if(valuesBuiler.contains(", )")){
                                        let newString2 = valuesBuiler.replacingOccurrences(of: ", )", with: ",'')", options: .literal, range: nil)
                                        valuesBuiler = newString2
                                   }

                                   if(valuesBuiler.contains(",)")){
                                        let newString3 = valuesBuiler.replacingOccurrences(of: ",)", with: ",'')", options: .literal, range: nil)
                                        valuesBuiler = newString3
                                   }
                              }
                              finalInsert.append(valuesBuiler)
                              //print("##INSERTED##   \(finalInsert)")

                              if(isTranTable){
                                   let deleteQuery = "DELETE FROM \(tableName) WHERE VAR_SYNC_CODE IN (\(deleteQ))"
                                   self.database.executeUpdate(deleteQuery, withArgumentsIn: deleteValues)
                                   //print("##DELETED##\(deleteCount)")
                              }

                              try self.database.executeUpdate(finalInsert, withArgumentsIn: [])
                              print("##INSERTED##   \(finalInsert)")
                         }
                    }
                }
            //}
        } catch let error as NSError {
            print("##insertRecordDynamic##   \(error.debugDescription)")
            NSLog("insertRecordDynamic \(error.debugDescription)")
            self.self.syncJSON.setValue("---insertRecordDynamic failed---\(error.debugDescription)", forKey: "34")
            success=false
        }
        //}

        return success
    }

     func insertRecordDynamicForLAB(tableName:String, jsonArray:JSON)->Bool{

          // DispatchQueue.global(qos: .background).async {
          var success = true

          do{
               let isTranTable = (tableName == DBHelper.TABLE_LAB_CUSTOMER_DISPATCH
                    || tableName == DBHelper.TABLE_LAB_CUSTOMER_DISPATCH_PRODUCT_DETAILS
                    || tableName == DBHelper.TABLE_LAB_STORE
                    || tableName == DBHelper.TABLE_LAB_DISPOSAL
                    || tableName == DBHelper.TABLE_LAB_MATERIAL_ALLOCATION
                    || tableName == DBHelper.TABLE_LAB_MATERIAL_RETURN
                    || tableName == DBHelper.TABLE_PERSON_MST
                    || tableName == DBHelper.TABLE_PRODUCT_SKU_MST
                    || tableName == DBHelper.TABLE_CUSTOMER_TYPE_COUNTRY_MST
                    || tableName == DBHelper.TABLE_POLITICAL_GEOGRAPHY_LEVEL_COUNTRY_MST
                    || tableName == DBHelper.TABLE_POLITICAL_GEOGRAPHY_DETAILS
                    || tableName == DBHelper.TABLE_LAB_STICKER_DETAILS)
               print(tableName)

               /*if(tableName == "CPM_Sticker_Details" || tableName == "Customer_Type_Country_Mst"){
                let deleteQuery = "DELETE FROM \(tableName)"
                self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                }*/

               /*if(tableName != "CPM_Sticker_Details"){
                return true
                }*/

               if !isTranTable && self.database.open()
               {
                    let deleteQuery = "DELETE FROM \(tableName)"
                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                    //// print("here one")
               }else{
                    if (tableName != DBHelper.TABLE_LAB_CUSTOMER_DISPATCH_PRODUCT_DETAILS) {

                         let deleteQuery = "DELETE FROM \(tableName) WHERE chrSync = 'N'"
                         self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                    }
                    // print("here two")
               }

               if(tableName == "LAB_Sticker_Details"){
                    return parseJsonStickerDetailsForLAB(Tourplan_Daily: jsonArray)
               }else{

                    if(jsonArray.count>0){

                         var sbQuery = ""

                         sbQuery = "INSERT INTO \(tableName) ("

                         let keys = jsonArray[0].dictionaryValue.keys.sorted()

                         var sbQuery2 = ""
                         for (position, name) in keys.enumerated() {
                              if(name=="chrTran"){
                                   continue
                              }
                              sbQuery2.append(name)
                              sbQuery2.append(",")
                         }

                         sbQuery2 = sbQuery2.trim()
                         sbQuery2 = String(sbQuery2.dropLast())

                         sbQuery.append(sbQuery2)
                         sbQuery.append(" ) VALUES ")

                         let arraySize = jsonArray.count
                         //let BATCHSIZE = 150
                         let BATCHSIZE = 50
                         let intBatch = Int(CGFloat(ceil(Double(Double(arraySize) * 1.00 / Double(BATCHSIZE)))))-1
                         let intRemainder = Int(Double(arraySize).truncatingRemainder(dividingBy: Double(BATCHSIZE)))
                         var intMaxRecords = Int(BATCHSIZE)

                         //print("intBatch:\(intBatch)")
                         //print("intRemainder:\(intRemainder)")
                         //print("intMaxRecords:\(intMaxRecords)")

                         //print("here 1:\(sbQuery)")

                         for b in 0...intBatch {
                              try autoreleasepool {
                                   var finalInsert=""
                                   finalInsert.append(sbQuery)
                                   if (b == intBatch) {
                                        intMaxRecords = intRemainder == 0 ? BATCHSIZE : intRemainder;
                                   }

                                   var valuesBuiler=""
                                   var deleteValues = [String]()
                                   var deleteQ=""
                                   let innerLoopSize = Int((b * Int(BATCHSIZE)) + intMaxRecords)-1
                                   let tmp1 = Int((b * BATCHSIZE))

                                   //print("BATCHSIZE:\(BATCHSIZE)")
                                   //print("innerLoopSize:\(innerLoopSize)")
                                   //print("tmp1:\(tmp1)")

                                   for m in tmp1...innerLoopSize {
                                        //let jsonObject = jsonArray[m]
                                        if(jsonArray[m].dictionaryValue.keys.contains("chrTran")){
                                             let chrTran = jsonArray[m].dictionaryValue["chrTran"]?.string

                                             if (jsonArray[m].dictionaryValue.keys.contains("varSync_Code")) {
                                                  deleteQ.append(deleteValues.count <= 0 ? "?" : ",?")
                                                  deleteValues.append((jsonArray[m].dictionaryValue["varSync_Code"]?.string)!)
                                             }
                                             if (chrTran != nil && chrTran!.caseInsensitiveCompare("d") == .orderedSame) {
                                                  continue
                                             }
                                        }

                                        if (!valuesBuiler.isEmpty){
                                             valuesBuiler.append(",")
                                        }

                                        valuesBuiler.append("(")

                                        for (pos, key) in jsonArray[m].dictionaryValue.keys.sorted().enumerated() {
                                             let hasNext = (pos != jsonArray[m].dictionaryValue.keys.count-1)
                                             if (key=="chrTran") {
                                                  if (!hasNext && valuesBuiler.contains(",")) {
                                                       valuesBuiler.remove(at: valuesBuiler.lastIndex(of: ",")!)
                                                  }
                                                  continue
                                             }

                                             let tmp = jsonArray[m].dictionaryValue[key]?.string

                                             if (tmp != nil && !(tmp?.isEmpty)! && tmp != "null") {
                                                  valuesBuiler.append("'")
                                                  valuesBuiler.append(tmp!.replace(target: "'", withString: "''"))
                                                  valuesBuiler.append("'")
                                             }else if(tmp == "null" || tmp == "NULL"){
                                                  valuesBuiler.append("NULL")
                                             }else{

                                                  let ddd = nullToNil(value: jsonArray[m].dictionaryValue[key] as AnyObject)

                                                  if let actualVariable = ddd {
                                                       valuesBuiler = valuesBuiler + " \(actualVariable)"
                                                  }
                                             }
                                             valuesBuiler.append(hasNext ? "," : "")
                                             valuesBuiler = valuesBuiler.trim()
                                             if(valuesBuiler.contains(",,") || valuesBuiler.contains(", ,") || valuesBuiler.contains("( ,") || valuesBuiler.contains("(,")){
                                                  if(valuesBuiler.contains(",,")){
                                                       let newString = valuesBuiler.replacingOccurrences(of: ",,", with: ",'',", options: .literal, range: nil)
                                                       valuesBuiler = newString
                                                  }
                                                  if(valuesBuiler.contains(", ,")){
                                                       let newString1 = valuesBuiler.replacingOccurrences(of: ", ,", with: ",'',", options: .literal, range: nil)
                                                       valuesBuiler = newString1
                                                  }

                                                  if(valuesBuiler.contains("(,")){
                                                       let newString3 = valuesBuiler.replacingOccurrences(of: "(,", with: "('',", options: .literal, range: nil)
                                                       valuesBuiler = newString3
                                                  }

                                                  if(valuesBuiler.contains("( ,")){
                                                       let newString3 = valuesBuiler.replacingOccurrences(of: "( ,", with: "('',", options: .literal, range: nil)
                                                       valuesBuiler = newString3
                                                  }
                                             }
                                        }
                                        valuesBuiler.append(")")

                                        if(valuesBuiler.contains(", )")){
                                             let newString2 = valuesBuiler.replacingOccurrences(of: ", )", with: ",'')", options: .literal, range: nil)
                                             valuesBuiler = newString2
                                        }

                                        if(valuesBuiler.contains(",)")){
                                             let newString3 = valuesBuiler.replacingOccurrences(of: ",)", with: ",'')", options: .literal, range: nil)
                                             valuesBuiler = newString3
                                        }
                                   }
                                   finalInsert.append(valuesBuiler)
                                   valuesBuiler = ""
                                   //print("##INSERTED##   \(finalInsert)")

                                   if(isTranTable){
                                        let deleteQuery = "DELETE FROM \(tableName) WHERE varSync_Code IN (\(deleteQ))"
                                        self.database.executeUpdate(deleteQuery, withArgumentsIn: deleteValues)
                                        //print("##DELETED##\(deleteCount)")
                                   }

                                   try self.database.executeUpdate(finalInsert, withArgumentsIn: [])
                                   //print("##INSERTED##   \(finalInsert)")
                                   finalInsert = ""
                              }
                         }
                    }
               }
          } catch let error as NSError {
               print("##insertRecordDynamic##   \(error.debugDescription)")
               NSLog("insertRecordDynamic \(error.debugDescription)")
               success=false
          }
          //}

          return success
     }



    func parseJsonStickerDetails(Tourplan_Daily:JSON)->Bool{
        //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
        if(Tourplan_Daily.count > 0){

            do{
                var k = 0
                while (k < Tourplan_Daily.count){
                    let chrTran = Tourplan_Daily[k]["chrTran"].stringValue

                    if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                        continue
                    }

                    let intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                    let fk_StickerGlCode = Tourplan_Daily[k]["fk_StickerGlCode"].intValue
                    let varRef_Id = Tourplan_Daily[k]["varRef_Id"].stringValue
                    let varSystem_Name = Tourplan_Daily[k]["varSystem_Name"].stringValue
                    let fk_CustomerGlCode = Tourplan_Daily[k]["fk_CustomerGlCode"].intValue
                    let fk_CountryGlCode = Tourplan_Daily[k]["fk_CountryGlCode"].intValue
                    let fk_PBGGlCode = Tourplan_Daily[k]["fk_PBGGlCode"].intValue
                    let fk_PRDGlCode = Tourplan_Daily[k]["fk_PRDGlCode"].intValue
                    var fk_Product_SKUGlCode : Int = 0


                    if Tourplan_Daily[k]["fk_Product_SKUGlCode"] == nil {
                        fk_Product_SKUGlCode = 0
                    }else{
                        fk_Product_SKUGlCode = Tourplan_Daily[k]["fk_Product_SKUGlCode"].intValue
                    }


                    let varStickerType = Tourplan_Daily[k]["varStickerType"].stringValue
                    let varDINo = Tourplan_Daily[k]["varDINo"].stringValue
                    let varBatch_No = Tourplan_Daily[k]["varBatch_No"].stringValue

                    var dtMFGDate:String = ""
                    if Tourplan_Daily[k]["dtMFGDate"] == nil {
                        dtMFGDate = ""
                    }else{
                        dtMFGDate = Tourplan_Daily[k]["dtMFGDate"].stringValue
                    }

                    let dtExpireDate = Tourplan_Daily[k]["dtExpireDate"].stringValue
                    let varSticker_From_Range = Tourplan_Daily[k]["varSticker_From_Range"].stringValue
                    let varSticker_To_Range = Tourplan_Daily[k]["varSticker_To_Range"].stringValue
                    let varBTC_No_In = Tourplan_Daily[k]["varBTC_No_In"].stringValue
                    let varBTC_No_Out = Tourplan_Daily[k]["varBTC_No_Out"].stringValue
                    let varQR_Code_In = Tourplan_Daily[k]["varQR_Code_In"].stringValue
                    let varQR_Code_Out = Tourplan_Daily[k]["varQR_Code_Out"].stringValue

                    let varSticker_No = Tourplan_Daily[k]["varSticker_No"].stringValue

                    var chrPallet:String = ""
                    if Tourplan_Daily[k]["chrPallet"] == nil {
                        chrPallet = ""
                    }else{
                        chrPallet = Tourplan_Daily[k]["chrPallet"].stringValue
                    }

                    var fk_PalletGlCode:Int = 0
                    if Tourplan_Daily[k]["fk_PalletGlCode"] == nil {
                        fk_PalletGlCode = 0
                    }else{
                        fk_PalletGlCode = Tourplan_Daily[k]["fk_PalletGlCode"].intValue
                    }

                    /* let chrPallet = Tourplan_Daily[k]["chrPallet"].stringValue*/
                    /*let fk_PalletGlCode = Tourplan_Daily[k]["fk_PalletGlCode"].intValue*/

                    let fk_StatusGlCode = Tourplan_Daily[k]["fk_StatusGlCode"].intValue
                    let fk_Sticker_GeneratedBy = Tourplan_Daily[k]["fk_Sticker_GeneratedBy"].intValue
                    let dtSticker_GeneratedDate = Tourplan_Daily[k]["dtSticker_GeneratedDate"].stringValue

                    var chrExternal_Customer:String = ""
                    if Tourplan_Daily[k]["chrExternal_Customer"] == nil {
                        chrExternal_Customer = ""
                    }else{
                        chrExternal_Customer = Tourplan_Daily[k]["chrExternal_Customer"].stringValue
                    }

                    let fk_Last_DispatchedBy = Tourplan_Daily[k]["fk_Last_DispatchedBy"].intValue
                    let fk_Last_PreviousDispatchBy = Tourplan_Daily[k]["fk_Last_PreviousDispatchBy"].intValue
                    let fk_Last_DispatchedTo = Tourplan_Daily[k]["fk_Last_DispatchedTo"].intValue

                    let dtLast_DispatchedDate = Tourplan_Daily[k]["dtLast_DispatchedDate"].stringValue
                    let fk_Last_ReceivedBy = Tourplan_Daily[k]["fk_Last_ReceivedBy"].intValue

                    var dtLast_RejectedDate:String = ""
                    if Tourplan_Daily[k]["dtLast_RejectedDate"] == nil {
                        dtLast_RejectedDate = ""
                    }else{
                        dtLast_RejectedDate = Tourplan_Daily[k]["dtLast_RejectedDate"].stringValue
                    }

                    var chrDamage:String = ""
                    if Tourplan_Daily[k]["chrDamage"] == nil {
                        chrDamage = ""
                    }else{
                        chrDamage = Tourplan_Daily[k]["chrDamage"].stringValue
                    }

                    var dtDamageDateTime:String = ""
                    if Tourplan_Daily[k]["dtDamageDateTime"] == nil {
                        dtDamageDateTime = ""
                    }else{
                        dtDamageDateTime = Tourplan_Daily[k]["dtDamageDateTime"].stringValue
                    }

                    let fk_DamageBy = Tourplan_Daily[k]["fk_DamageBy"].intValue

                    var chrLiquidated:String = ""
                    if Tourplan_Daily[k]["chrLiquidated"] == nil {
                        chrLiquidated = ""
                    }else{
                        chrLiquidated = Tourplan_Daily[k]["chrLiquidated"].stringValue
                    }
                    
                    var chrActive:String = ""
                    if Tourplan_Daily[k]["chrActive"] == nil {
                        chrActive = ""
                    }else{
                        chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                    }

                    var chrSync:String = ""
                    if Tourplan_Daily[k]["chrSync"] == nil {
                        chrSync = ""
                    }else{
                        chrSync = Tourplan_Daily[k]["chrSync"].stringValue
                    }

                    var varSync_Code:String = ""
                    if Tourplan_Daily[k]["varSync_Code"] == nil {
                        varSync_Code = ""
                    }else{
                        varSync_Code = Tourplan_Daily[k]["varSync_Code"].stringValue
                    }

                    var dtSyncDate:String = ""
                    if Tourplan_Daily[k]["dtSyncDate"] == nil {
                        dtSyncDate = ""
                    }else{
                        dtSyncDate = Tourplan_Daily[k]["dtSyncDate"].stringValue
                    }

                    var dtEntryDate:String = ""
                    if Tourplan_Daily[k]["dtEntryDate"] == nil {
                        dtEntryDate = ""
                    }else{
                        dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                    }

                    var ref_Entry_By:Int = 0
                    if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                        ref_Entry_By = 0
                    }else{
                        ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].intValue
                    }


                    var intPrintQty:Int = 0
                    if Tourplan_Daily[k]["intPrintQty"] == nil {
                        intPrintQty = 0
                    }else{
                        intPrintQty = Tourplan_Daily[k]["intPrintQty"].intValue
                    }

                    var dtModifiedDate:String = ""
                    if Tourplan_Daily[k]["dtModifiedDate"] == nil {
                        dtModifiedDate = ""
                    }else{
                        dtModifiedDate = Tourplan_Daily[k]["dtModifiedDate"].stringValue
                    }

                    var ref_Modified_By:Int = 0
                    if Tourplan_Daily[k]["ref_Modified_By"] == nil {
                        ref_Modified_By = 0
                    }else{
                        ref_Modified_By = Tourplan_Daily[k]["ref_Modified_By"].intValue
                    }

                    var fk_Last_RejectedBy:Int = 0
                    if Tourplan_Daily[k]["fk_Last_RejectedBy"] == nil {
                        ref_Modified_By = 0
                    }else{
                        fk_Last_RejectedBy = Tourplan_Daily[k]["fk_Last_RejectedBy"].intValue
                    }



                    var varLastStage:String = ""
                    if Tourplan_Daily[k]["varLastStage"] == nil {
                        varLastStage = ""
                    }else{
                        varLastStage = Tourplan_Daily[k]["varLastStage"].stringValue
                    }

                    var dtLast_ReceivedDate:String = ""
                    if Tourplan_Daily[k]["dtLast_ReceivedDate"] == nil {
                        dtLast_ReceivedDate = ""
                    }else{
                        dtLast_ReceivedDate = Tourplan_Daily[k]["dtLast_ReceivedDate"].stringValue
                    }

                    var chrConsume:String = ""
                    if Tourplan_Daily[k]["chrConsume"] == nil {
                        chrConsume = ""
                    }else{
                        chrConsume = Tourplan_Daily[k]["chrConsume"].stringValue
                    }

                    var dtConsumeDateTime:String = ""
                    if Tourplan_Daily[k]["dtConsumeDateTime"] == nil {
                        dtConsumeDateTime = ""
                    }else{
                        dtConsumeDateTime = Tourplan_Daily[k]["dtConsumeDateTime"].stringValue
                    }

                    var fk_ConsumeBy:Int = 0
                    if Tourplan_Daily[k]["fk_ConsumeBy"] == nil {
                        fk_ConsumeBy = 0
                    }else{
                        fk_ConsumeBy = Tourplan_Daily[k]["fk_ConsumeBy"].intValue
                    }

                    var chrScrap:String = ""
                    if Tourplan_Daily[k]["chrScrap"] == nil {
                        chrScrap = ""
                    }else{
                        chrScrap = Tourplan_Daily[k]["chrScrap"].stringValue
                    }

                    var dtScrapDateTime:String = ""
                    if Tourplan_Daily[k]["dtScrapDateTime"] == nil {
                        dtScrapDateTime = ""
                    }else{
                        dtScrapDateTime = Tourplan_Daily[k]["dtScrapDateTime"].stringValue
                    }

                    var fk_ScrapBy:Int = 0
                    if Tourplan_Daily[k]["fk_ScrapBy"] == nil {
                        fk_ScrapBy = 0
                    }else{
                        fk_ScrapBy = Tourplan_Daily[k]["fk_ScrapBy"].intValue
                    }

                    /*var dtLast_ReceivedDate:String = ""
                     if Tourplan_Daily[k]["dtLast_ReceivedDate"] == nil {
                     dtLast_ReceivedDate = ""
                     }else{
                     dtLast_ReceivedDate = Tourplan_Daily[k]["dtLast_ReceivedDate"].stringValue
                     }*/

                    //print("fk_CampGlCode JJ \(fk_CampGlCode)")

                    /*if(checkTourplan_DailyCount(fk_DrGlCode: fk_DrGlCode, fk_EmpGlCode_Planned: fk_EmpGlCode_Planned, fk_DivisionGlCode: fk_DivisionGlCode, dtPlanDate: dtPlanDate) > 0){

                     let update = "update Tourplan_Daily set fk_PurposeGlCode = ?,fk_DrGlCode = ?, fk_EmpGlCode_Planned = ?, dtEntryDate = ?, fk_DivisionGlCode = ?, fk_PersonGlCode = ?, chrDeleteFlag = ?, dtPlanDate = ?, fk_CampGlCode = ?, varTime = ?,  fk_DesiGlCode = ?, chrSyncFlag = ? where fk_DrGlCode = \(fk_DrGlCode) and fk_EmpGlCode_Planned = \(fk_EmpGlCode_Planned) and dtPlanDate = '\(dtPlanDate)' "

                     try database.executeUpdate(update, values: [fk_PurposeGlCode, fk_DrGlCode,fk_EmpGlCode_Planned,dtEntryDate,fk_DivisionGlCode,fk_PersonGlCode,chrDeleteFlag,dtPlanDate,fk_CampGlCode,varTime,fk_DesiGlCode,chrSyncFlag])

                     }else{*/


                    let deleteQuery = "DELETE FROM CPM_Sticker_Details WHERE varSync_Code IN ('\(varSync_Code)')"
                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                    print("delete from sticker details----\(fk_StickerGlCode)-------\(varSync_Code)")

                    try self.database.executeUpdate("insert into CPM_Sticker_Details (intGlCode, fk_StickerGlCode,varRef_Id,varSystem_Name,fk_CustomerGlCode,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varStickerType,varDINo,varBatch_No,dtMFGDate,dtExpireDate,intPrintQty,varSticker_From_Range,varSticker_To_Range,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,chrPallet,fk_PalletGlCode,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,chrExternal_Customer,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,fk_Last_DispatchedTo,dtLast_DispatchedDate,fk_Last_ReceivedBy,dtLast_ReceivedDate,fk_Last_RejectedBy,dtLast_RejectedDate,chrDamage,dtDamageDateTime,fk_DamageBy,chrLiquidated,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage,chrConsume,dtConsumeDateTime,fk_ConsumeBy,chrScrap,dtScrapDateTime,fk_ScrapBy) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", values: [intGlCode,fk_StickerGlCode,varRef_Id,varSystem_Name,fk_CustomerGlCode,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varStickerType,varDINo,varBatch_No,dtMFGDate,dtExpireDate,intPrintQty,varSticker_From_Range,varSticker_To_Range,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,chrPallet,fk_PalletGlCode,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,chrExternal_Customer,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,fk_Last_DispatchedTo,dtLast_DispatchedDate,fk_Last_ReceivedBy,dtLast_ReceivedDate,fk_Last_RejectedBy,dtLast_RejectedDate,chrDamage,dtDamageDateTime,fk_DamageBy,chrLiquidated,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage,chrConsume,dtConsumeDateTime,fk_ConsumeBy,chrScrap,dtScrapDateTime,fk_ScrapBy])
                    //}

                    k += 1
                }
            }catch{
                print("error Tourplan_Daily")

                return false
            }

            return true
        }

        return false
        //}
    }

    func parseJsonStickerDetailsIFFCO_CPM_STICKER_DETAILS(Tourplan_Daily:JSON)->Bool{
        //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
        if(Tourplan_Daily.count > 0){

            do{
                var k = 0
                while (k < Tourplan_Daily.count){
                    let chrTran = Tourplan_Daily[k]["chrTran"].stringValue

                    if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                        continue
                    }

                    let INT_GLCODE = Tourplan_Daily[k]["INT_GLCODE"].intValue
                    let FK_SYSTEM_GLCODE = Tourplan_Daily[k]["FK_SYSTEM_GLCODE"].intValue
                    let FK_CUSTOMER_GLCODE = Tourplan_Daily[k]["FK_CUSTOMER_GLCODE"].intValue
                    let VAR_REF_ID = Tourplan_Daily[k]["VAR_REF_ID"].stringValue
                    let VAR_STICKER_TYPE = Tourplan_Daily[k]["VAR_STICKER_TYPE"].stringValue
                    let CHR_PALLET = Tourplan_Daily[k]["CHR_PALLET"].stringValue
                    
                    let INT_BATCH_ID = Tourplan_Daily[k]["INT_BATCH_ID"].intValue
                    let VAR_BATCH_NO = Tourplan_Daily[k]["VAR_BATCH_NO"].stringValue
                    
                    var DT_MFG_DATE:String = ""
                    if Tourplan_Daily[k]["DT_MFG_DATE"] == nil {
                        DT_MFG_DATE = ""
                    }else{
                        DT_MFG_DATE = Tourplan_Daily[k]["DT_MFG_DATE"].stringValue
                    }

                    let DT_EXPIRE_DATE = Tourplan_Daily[k]["DT_EXPIRE_DATE"].stringValue
                    
                    var FK_STICKER_GLCODE:Int = 0
                    if Tourplan_Daily[k]["FK_STICKER_GLCODE"] == nil {
                        FK_STICKER_GLCODE = 0
                    }else{
                        FK_STICKER_GLCODE = Tourplan_Daily[k]["FK_STICKER_GLCODE"].intValue
                    }
                    
                    var VAR_STICKER_SYNC_CODE:String = ""
                    if Tourplan_Daily[k]["VAR_STICKER_SYNC_CODE"] == nil {
                        VAR_STICKER_SYNC_CODE = ""
                    }else{
                        VAR_STICKER_SYNC_CODE = Tourplan_Daily[k]["VAR_STICKER_SYNC_CODE"].stringValue
                    }
                    
                    var FK_PBG_GLCODE:Int = 0
                                       if Tourplan_Daily[k]["FK_PBG_GLCODE"] == nil {
                                           FK_PBG_GLCODE = 0
                                       }else{
                                           FK_PBG_GLCODE = Tourplan_Daily[k]["FK_PBG_GLCODE"].intValue
                                       }
                    
                    var FK_PRD_GLCODE:Int = 0
                                       if Tourplan_Daily[k]["FK_PRD_GLCODE"] == nil {
                                           FK_PRD_GLCODE = 0
                                       }else{
                                           FK_PRD_GLCODE = Tourplan_Daily[k]["FK_PRD_GLCODE"].intValue
                                       }
                    
                    var FK_PRODUCT_SKU_GLCODE:Int = 0
                                       if Tourplan_Daily[k]["FK_PRODUCT_SKU_GLCODE"] == nil {
                                           FK_PRODUCT_SKU_GLCODE = 0
                                       }else{
                                           FK_PRODUCT_SKU_GLCODE = Tourplan_Daily[k]["FK_PRODUCT_SKU_GLCODE"].intValue
                                       }
                    
                    let VAR_BTC_NO = Tourplan_Daily[k]["VAR_BTC_NO"].stringValue
                    let VAR_QR_CODE = Tourplan_Daily[k]["VAR_QR_CODE"].stringValue
                    
                    var CHR_SCANNED_STATUS:String = ""
                    if Tourplan_Daily[k]["CHR_SCANNED_STATUS"] == nil {
                        CHR_SCANNED_STATUS = ""
                    }else{
                        CHR_SCANNED_STATUS = Tourplan_Daily[k]["CHR_SCANNED_STATUS"].stringValue
                    }
                    
                    var DT_SCANNED_DATE:String = ""
                    if Tourplan_Daily[k]["DT_SCANNED_DATE"] == nil {
                        DT_SCANNED_DATE = ""
                    }else{
                        DT_SCANNED_DATE = Tourplan_Daily[k]["DT_SCANNED_DATE"].stringValue
                    }
                    
                    var VAR_REJECT_REASON:String = ""
                    if Tourplan_Daily[k]["VAR_REJECT_REASON"] == nil {
                        VAR_REJECT_REASON = ""
                    }else{
                        VAR_REJECT_REASON = Tourplan_Daily[k]["VAR_REJECT_REASON"].stringValue
                    }
                    
                    var CHR_CONFIRM:String = ""
                    if Tourplan_Daily[k]["CHR_CONFIRM"] == nil {
                        CHR_CONFIRM = ""
                    }else{
                        CHR_CONFIRM = Tourplan_Daily[k]["CHR_CONFIRM"].stringValue
                    }
                    
                    var DT_CONFIRM_DATE:String = ""
                    if Tourplan_Daily[k]["DT_CONFIRM_DATE"] == nil {
                        DT_CONFIRM_DATE = ""
                    }else{
                        DT_CONFIRM_DATE = Tourplan_Daily[k]["DT_CONFIRM_DATE"].stringValue
                    }
                    
                    var DEC_QTYKGL:double_t = 0.0
                    if Tourplan_Daily[k]["DEC_QTYKGL"] == nil {
                        DEC_QTYKGL = 0.0
                    }else{
                        DEC_QTYKGL = Tourplan_Daily[k]["DEC_QTYKGL"].doubleValue
                    }
                    
                    var FK_PALLET_GLCODE:Int = 0
                                       if Tourplan_Daily[k]["FK_PALLET_GLCODE"] == nil {
                                           FK_PALLET_GLCODE = 0
                                       }else{
                                           FK_PALLET_GLCODE = Tourplan_Daily[k]["FK_PALLET_GLCODE"].intValue
                                       }

                    var VAR_PALLET_SYNC_CODE:String = ""
                    if Tourplan_Daily[k]["VAR_PALLET_SYNC_CODE"] == nil {
                        VAR_PALLET_SYNC_CODE = ""
                    }else{
                        VAR_PALLET_SYNC_CODE = Tourplan_Daily[k]["VAR_PALLET_SYNC_CODE"].stringValue
                    }
                    
                    var CHR_SHIPPER_BOX_BREAK:String = ""
                    if Tourplan_Daily[k]["CHR_SHIPPER_BOX_BREAK"] == nil {
                        CHR_SHIPPER_BOX_BREAK = ""
                    }else{
                        CHR_SHIPPER_BOX_BREAK = Tourplan_Daily[k]["CHR_SHIPPER_BOX_BREAK"].stringValue
                    }
                    
                    var DT_SHIPPER_BOX_BREAK_DATE:String = ""
                    if Tourplan_Daily[k]["DT_SHIPPER_BOX_BREAK_DATE"] == nil {
                        DT_SHIPPER_BOX_BREAK_DATE = ""
                    }else{
                        DT_SHIPPER_BOX_BREAK_DATE = Tourplan_Daily[k]["DT_SHIPPER_BOX_BREAK_DATE"].stringValue
                    }
                    
                    var FK_SHIPPER_BOX_BREAK_BY:Int = 0
                    if Tourplan_Daily[k]["FK_SHIPPER_BOX_BREAK_BY"] == nil {
                        FK_SHIPPER_BOX_BREAK_BY = 0
                    }else{
                        FK_SHIPPER_BOX_BREAK_BY = Tourplan_Daily[k]["FK_SHIPPER_BOX_BREAK_BY"].intValue
                    }
                    
                    var FK_STATUS_GLCODE:Int = 0
                    if Tourplan_Daily[k]["FK_STATUS_GLCODE"] == nil {
                        FK_STATUS_GLCODE = 0
                    }else{
                        FK_STATUS_GLCODE = Tourplan_Daily[k]["FK_STATUS_GLCODE"].intValue
                    }
                    
                    var FK_STICKER_GENERATED_BY:Int = 0
                    if Tourplan_Daily[k]["FK_STICKER_GENERATED_BY"] == nil {
                        FK_STICKER_GENERATED_BY = 0
                    }else{
                        FK_STICKER_GENERATED_BY = Tourplan_Daily[k]["FK_STICKER_GENERATED_BY"].intValue
                    }
                    
                    var DT_STICKER_GENERATED_DATE:String = ""
                    if Tourplan_Daily[k]["DT_STICKER_GENERATED_DATE"] == nil {
                        DT_STICKER_GENERATED_DATE = ""
                    }else{
                        DT_STICKER_GENERATED_DATE = Tourplan_Daily[k]["DT_STICKER_GENERATED_DATE"].stringValue
                    }
                    
                    var FK_LAST_DISPATCHED_TO:Int = 0
                    if Tourplan_Daily[k]["FK_LAST_DISPATCHED_TO"] == nil {
                        FK_LAST_DISPATCHED_TO = 0
                    }else{
                        FK_LAST_DISPATCHED_TO = Tourplan_Daily[k]["FK_LAST_DISPATCHED_TO"].intValue
                    }
                    
                    var FK_LAST_DISPATCHED_BY:Int = 0
                    if Tourplan_Daily[k]["FK_LAST_DISPATCHED_BY"] == nil {
                        FK_LAST_DISPATCHED_BY = 0
                    }else{
                        FK_LAST_DISPATCHED_BY = Tourplan_Daily[k]["FK_LAST_DISPATCHED_BY"].intValue
                    }
                    
                    var FK_LAST_PREVIOUS_DISPATCH_BY:Int = 0
                    if Tourplan_Daily[k]["FK_LAST_PREVIOUS_DISPATCH_BY"] == nil {
                        FK_LAST_PREVIOUS_DISPATCH_BY = 0
                    }else{
                        FK_LAST_PREVIOUS_DISPATCH_BY = Tourplan_Daily[k]["FK_LAST_PREVIOUS_DISPATCH_BY"].intValue
                    }
                    
                    var DT_LAST_DISPATCHED_DATE:String = ""
                    if Tourplan_Daily[k]["DT_LAST_DISPATCHED_DATE"] == nil {
                        DT_LAST_DISPATCHED_DATE = ""
                    }else{
                        DT_LAST_DISPATCHED_DATE = Tourplan_Daily[k]["DT_LAST_DISPATCHED_DATE"].stringValue
                    }
                    
                    var FK_LAST_RECEIVED_BY:Int = 0
                                       if Tourplan_Daily[k]["FK_LAST_RECEIVED_BY"] == nil {
                                           FK_LAST_RECEIVED_BY = 0
                                       }else{
                                           FK_LAST_RECEIVED_BY = Tourplan_Daily[k]["FK_LAST_RECEIVED_BY"].intValue
                                       }
                                       
                                       var DT_LAST_RECEIVED_DATE:String = ""
                                       if Tourplan_Daily[k]["DT_LAST_RECEIVED_DATE"] == nil {
                                           DT_LAST_RECEIVED_DATE = ""
                                       }else{
                                           DT_LAST_RECEIVED_DATE = Tourplan_Daily[k]["DT_LAST_RECEIVED_DATE"].stringValue
                                       }
                    
                    var FK_LAST_REJECTED_BY:Int = 0
                    if Tourplan_Daily[k]["FK_LAST_REJECTED_BY"] == nil {
                        FK_LAST_REJECTED_BY = 0
                    }else{
                        FK_LAST_REJECTED_BY = Tourplan_Daily[k]["FK_LAST_REJECTED_BY"].intValue
                    }
                    
                    var DT_LAST_REJECTED_DATE:String = ""
                    if Tourplan_Daily[k]["DT_LAST_REJECTED_DATE"] == nil {
                        DT_LAST_REJECTED_DATE = ""
                    }else{
                        DT_LAST_REJECTED_DATE = Tourplan_Daily[k]["DT_LAST_REJECTED_DATE"].stringValue
                    }
                    
                    var CHR_BLOCK:String = ""
                    if Tourplan_Daily[k]["CHR_BLOCK"] == nil {
                        CHR_BLOCK = ""
                    }else{
                        CHR_BLOCK = Tourplan_Daily[k]["CHR_BLOCK"].stringValue
                    }
                    
                    var FK_BLOCK_TYPE_GLCODE:Int = 0
                                       if Tourplan_Daily[k]["FK_BLOCK_TYPE_GLCODE"] == nil {
                                           FK_BLOCK_TYPE_GLCODE = 0
                                       }else{
                                           FK_BLOCK_TYPE_GLCODE = Tourplan_Daily[k]["FK_BLOCK_TYPE_GLCODE"].intValue
                                       }
                    
                    var DT_BLOCK_DATE:String = ""
                    if Tourplan_Daily[k]["DT_BLOCK_DATE"] == nil {
                        DT_BLOCK_DATE = ""
                    }else{
                        DT_BLOCK_DATE = Tourplan_Daily[k]["DT_BLOCK_DATE"].stringValue
                    }
                    
                    var FK_BLOCK_BY:Int = 0
                                       if Tourplan_Daily[k]["FK_BLOCK_BY"] == nil {
                                           FK_BLOCK_BY = 0
                                       }else{
                                           FK_BLOCK_BY = Tourplan_Daily[k]["FK_BLOCK_BY"].intValue
                                       }
                    
                    var CHR_LIQUIDATED:String = ""
                    if Tourplan_Daily[k]["CHR_LIQUIDATED"] == nil {
                        CHR_LIQUIDATED = ""
                    }else{
                        CHR_LIQUIDATED = Tourplan_Daily[k]["CHR_LIQUIDATED"].stringValue
                    }
                    
                    var DT_LIQUIDATED_DATE:String = ""
                    if Tourplan_Daily[k]["DT_LIQUIDATED_DATE"] == nil {
                        DT_LIQUIDATED_DATE = ""
                    }else{
                        DT_LIQUIDATED_DATE = Tourplan_Daily[k]["DT_LIQUIDATED_DATE"].stringValue
                    }
                    
                    var FK_LIQUIDATED_BY:Int = 0
                    if Tourplan_Daily[k]["FK_LIQUIDATED_BY"] == nil {
                        FK_LIQUIDATED_BY = 0
                    }else{
                        FK_LIQUIDATED_BY = Tourplan_Daily[k]["FK_LIQUIDATED_BY"].intValue
                    }
                    
                    var CHR_ACTIVE:String = ""
                    if Tourplan_Daily[k]["CHR_ACTIVE"] == nil {
                        CHR_ACTIVE = ""
                    }else{
                        CHR_ACTIVE = Tourplan_Daily[k]["CHR_ACTIVE"].stringValue
                    }
                    
                    var CHR_SYNC:String = ""
                    if Tourplan_Daily[k]["CHR_SYNC"] == nil {
                        CHR_SYNC = ""
                    }else{
                        CHR_SYNC = Tourplan_Daily[k]["CHR_SYNC"].stringValue
                    }
                    
                    var VAR_SYNC_CODE:String = ""
                    if Tourplan_Daily[k]["VAR_SYNC_CODE"] == nil {
                        VAR_SYNC_CODE = ""
                    }else{
                        VAR_SYNC_CODE = Tourplan_Daily[k]["VAR_SYNC_CODE"].stringValue
                    }
                    
                    var DT_SYNC_DATE:String = ""
                    if Tourplan_Daily[k]["DT_SYNC_DATE"] == nil {
                        DT_SYNC_DATE = ""
                    }else{
                        DT_SYNC_DATE = Tourplan_Daily[k]["DT_SYNC_DATE"].stringValue
                    }
                    
                    var DT_ENTRY_DATE:String = ""
                    if Tourplan_Daily[k]["DT_ENTRY_DATE"] == nil {
                        DT_ENTRY_DATE = ""
                    }else{
                        DT_ENTRY_DATE = Tourplan_Daily[k]["DT_ENTRY_DATE"].stringValue
                    }
                    
                    var REF_ENTRY_BY:Int = 0
                                       if Tourplan_Daily[k]["REF_ENTRY_BY"] == nil {
                                           REF_ENTRY_BY = 0
                                       }else{
                                           REF_ENTRY_BY = Tourplan_Daily[k]["REF_ENTRY_BY"].intValue
                                       }
                                       
                    var DT_MODIFIED_DATE:String = ""
                    if Tourplan_Daily[k]["DT_MODIFIED_DATE"] == nil {
                        DT_MODIFIED_DATE = ""
                    }else{
                        DT_MODIFIED_DATE = Tourplan_Daily[k]["DT_MODIFIED_DATE"].stringValue
                    }
                    
                    var REF_MODIFIED_BY:Int = 0
                    if Tourplan_Daily[k]["REF_MODIFIED_BY"] == nil {
                        REF_MODIFIED_BY = 0
                    }else{
                        REF_MODIFIED_BY = Tourplan_Daily[k]["REF_MODIFIED_BY"].intValue
                    }
              
                    let deleteQuery = "DELETE FROM CPM_STICKER_DETAILS WHERE VAR_SYNC_CODE IN ('\(VAR_SYNC_CODE)')"
                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                    print("delete from sticker details----\(FK_STICKER_GLCODE)-------\(VAR_SYNC_CODE)")

                    try self.database.executeUpdate("insert into CPM_STICKER_DETAILS (INT_GLCODE,VAR_REF_ID,FK_SYSTEM_GLCODE,FK_CUSTOMER_GLCODE,VAR_STICKER_TYPE,CHR_PALLET,INT_BATCH_ID,VAR_BATCH_NO,DT_MFG_DATE,DT_EXPIRE_DATE,FK_STICKER_GLCODE,VAR_STICKER_SYNC_CODE,FK_PBG_GLCODE,FK_PRD_GLCODE,FK_PRODUCT_SKU_GLCODE,VAR_BTC_NO,VAR_QR_CODE,CHR_SCANNED_STATUS,DT_SCANNED_DATE,VAR_REJECT_REASON,CHR_CONFIRM,DT_CONFIRM_DATE,DEC_QTYKGL,FK_PALLET_GLCODE,VAR_PALLET_SYNC_CODE,CHR_SHIPPER_BOX_BREAK,DT_SHIPPER_BOX_BREAK_DATE,FK_SHIPPER_BOX_BREAK_BY,FK_STATUS_GLCODE,FK_STICKER_GENERATED_BY,DT_STICKER_GENERATED_DATE,FK_LAST_DISPATCHED_TO,FK_LAST_DISPATCHED_BY,FK_LAST_PREVIOUS_DISPATCH_BY,DT_LAST_DISPATCHED_DATE,FK_LAST_RECEIVED_BY,DT_LAST_RECEIVED_DATE,FK_LAST_REJECTED_BY,DT_LAST_REJECTED_DATE,CHR_BLOCK,FK_BLOCK_TYPE_GLCODE,DT_BLOCK_DATE,FK_BLOCK_BY,CHR_LIQUIDATED,DT_LIQUIDATED_DATE,FK_LIQUIDATED_BY,CHR_ACTIVE,CHR_SYNC,VAR_SYNC_CODE,DT_SYNC_DATE,DT_ENTRY_DATE,REF_ENTRY_BY,DT_MODIFIED_DATE,REF_MODIFIED_BY) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", values: [INT_GLCODE,VAR_REF_ID,FK_SYSTEM_GLCODE,FK_CUSTOMER_GLCODE,VAR_STICKER_TYPE,CHR_PALLET,INT_BATCH_ID,VAR_BATCH_NO,DT_MFG_DATE,DT_EXPIRE_DATE,FK_STICKER_GLCODE,VAR_STICKER_SYNC_CODE,FK_PBG_GLCODE,FK_PRD_GLCODE,FK_PRODUCT_SKU_GLCODE,VAR_BTC_NO,VAR_QR_CODE,CHR_SCANNED_STATUS,DT_SCANNED_DATE,VAR_REJECT_REASON,CHR_CONFIRM,DT_CONFIRM_DATE,DEC_QTYKGL,FK_PALLET_GLCODE,VAR_PALLET_SYNC_CODE,CHR_SHIPPER_BOX_BREAK,DT_SHIPPER_BOX_BREAK_DATE,FK_SHIPPER_BOX_BREAK_BY,FK_STATUS_GLCODE,FK_STICKER_GENERATED_BY,DT_STICKER_GENERATED_DATE,FK_LAST_DISPATCHED_TO,FK_LAST_DISPATCHED_BY,FK_LAST_PREVIOUS_DISPATCH_BY,DT_LAST_DISPATCHED_DATE,FK_LAST_RECEIVED_BY,DT_LAST_RECEIVED_DATE,FK_LAST_REJECTED_BY,DT_LAST_REJECTED_DATE,CHR_BLOCK,FK_BLOCK_TYPE_GLCODE,DT_BLOCK_DATE,FK_BLOCK_BY,CHR_LIQUIDATED,DT_LIQUIDATED_DATE,FK_LIQUIDATED_BY,CHR_ACTIVE,CHR_SYNC,VAR_SYNC_CODE,DT_SYNC_DATE,DT_ENTRY_DATE,REF_ENTRY_BY,DT_MODIFIED_DATE,REF_MODIFIED_BY])
                    //}

                    k += 1
                }
            }catch{
                print("Insert Error CPM_STICKER_DETAILS")

                return false
            }

            return true
        }

        return false
        //}
    }
    
    func parseJsonStickerDetailsIFFCO_CPM_SKU_STICKER_DETAILS(Tourplan_Daily:JSON)->Bool{
        //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
        if(Tourplan_Daily.count > 0){

            do{
                var k = 0
                while (k < Tourplan_Daily.count){
                    let chrTran = Tourplan_Daily[k]["chrTran"].stringValue

                    if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                        continue
                    }

                    let INT_GLCODE = Tourplan_Daily[k]["INT_GLCODE"].intValue
                    let FK_SYSTEM_GLCODE = Tourplan_Daily[k]["FK_SYSTEM_GLCODE"].intValue
                    let FK_CUSTOMER_GLCODE = Tourplan_Daily[k]["FK_CUSTOMER_GLCODE"].intValue
                    let VAR_REF_ID = Tourplan_Daily[k]["VAR_REF_ID"].stringValue
                    let VAR_STICKER_TYPE = Tourplan_Daily[k]["VAR_STICKER_TYPE"].stringValue
                    let FK_PBG_GLCODE = Tourplan_Daily[k]["FK_PBG_GLCODE"].intValue
                    let FK_PRD_GLCODE = Tourplan_Daily[k]["FK_PRD_GLCODE"].intValue
              
                    let INT_BATCH_ID = Tourplan_Daily[k]["INT_BATCH_ID"].intValue
                    let VAR_BATCH_NO = Tourplan_Daily[k]["VAR_BATCH_NO"].stringValue
                    
                    var DT_MFG_DATE:String = ""
                    if Tourplan_Daily[k]["DT_MFG_DATE"] == nil {
                        DT_MFG_DATE = ""
                    }else{
                        DT_MFG_DATE = Tourplan_Daily[k]["DT_MFG_DATE"].stringValue
                    }

                    let DT_EXPIRE_DATE = Tourplan_Daily[k]["DT_EXPIRE_DATE"].stringValue
                    
                    var FK_STICKER_DETAIL_GLCODE:Int = 0
                    if Tourplan_Daily[k]["FK_STICKER_DETAIL_GLCODE"] == nil {
                        FK_STICKER_DETAIL_GLCODE = 0
                    }else{
                        FK_STICKER_DETAIL_GLCODE = Tourplan_Daily[k]["FK_STICKER_DETAIL_GLCODE"].intValue
                    }
                    
                    var VAR_STICKER_DETAIL_SYNC_CODE:String = ""
                    if Tourplan_Daily[k]["VAR_STICKER_DETAIL_SYNC_CODE"] == nil {
                        VAR_STICKER_DETAIL_SYNC_CODE = ""
                    }else{
                        VAR_STICKER_DETAIL_SYNC_CODE = Tourplan_Daily[k]["VAR_STICKER_DETAIL_SYNC_CODE"].stringValue
                    }
                    
                    var FK_PRODUCT_SKU_GLCODE:Int = 0
                                       if Tourplan_Daily[k]["FK_PRODUCT_SKU_GLCODE"] == nil {
                                           FK_PRODUCT_SKU_GLCODE = 0
                                       }else{
                                           FK_PRODUCT_SKU_GLCODE = Tourplan_Daily[k]["FK_PRODUCT_SKU_GLCODE"].intValue
                                       }
                 
                    let VAR_SKU_BTC_NO = Tourplan_Daily[k]["VAR_SKU_BTC_NO"].stringValue
                    let VAR_SKU_QR_CODE = Tourplan_Daily[k]["VAR_SKU_QR_CODE"].stringValue
                    
                    var VAR_HELPER_CODE:String = ""
                    if Tourplan_Daily[k]["VAR_HELPER_CODE"] == nil {
                        VAR_HELPER_CODE = ""
                    }else{
                        VAR_HELPER_CODE = Tourplan_Daily[k]["VAR_HELPER_CODE"].stringValue
                    }
                    
                    var INT_SEQUENCE:Int = 0
                    if Tourplan_Daily[k]["INT_SEQUENCE"] == nil {
                        INT_SEQUENCE = 0
                    }else{
                        INT_SEQUENCE = Tourplan_Daily[k]["INT_SEQUENCE"].intValue
                    }
                    
                    var CHR_SCANNED_STATUS:String = ""
                    if Tourplan_Daily[k]["CHR_SCANNED_STATUS"] == nil {
                        CHR_SCANNED_STATUS = ""
                    }else{
                        CHR_SCANNED_STATUS = Tourplan_Daily[k]["CHR_SCANNED_STATUS"].stringValue
                    }
                    
                    var DT_SCANNED_DATE:String = ""
                    if Tourplan_Daily[k]["DT_SCANNED_DATE"] == nil {
                        DT_SCANNED_DATE = ""
                    }else{
                        DT_SCANNED_DATE = Tourplan_Daily[k]["DT_SCANNED_DATE"].stringValue
                    }
                    
                    var VAR_REJECT_REASON:String = ""
                    if Tourplan_Daily[k]["VAR_REJECT_REASON"] == nil {
                        VAR_REJECT_REASON = ""
                    }else{
                        VAR_REJECT_REASON = Tourplan_Daily[k]["VAR_REJECT_REASON"].stringValue
                    }
                    
                    var FK_STATUS_GLCODE:Int = 0
                                                          if Tourplan_Daily[k]["FK_STATUS_GLCODE"] == nil {
                                                              FK_STATUS_GLCODE = 0
                                                          }else{
                                                              FK_STATUS_GLCODE = Tourplan_Daily[k]["FK_STATUS_GLCODE"].intValue
                                                          }
                    
                    var CHR_MAPPED:String = ""
                    if Tourplan_Daily[k]["CHR_MAPPED"] == nil {
                        CHR_MAPPED = ""
                    }else{
                        CHR_MAPPED = Tourplan_Daily[k]["CHR_MAPPED"].stringValue
                    }
                    
                    var FK_STICKER_GENERATED_BY:Int = 0
                    if Tourplan_Daily[k]["FK_STICKER_GENERATED_BY"] == nil {
                        FK_STICKER_GENERATED_BY = 0
                    }else{
                        FK_STICKER_GENERATED_BY = Tourplan_Daily[k]["FK_STICKER_GENERATED_BY"].intValue
                    }
                    
                    var DT_STICKER_GENERATED_DATE:String = ""
                    if Tourplan_Daily[k]["DT_STICKER_GENERATED_DATE"] == nil {
                        DT_STICKER_GENERATED_DATE = ""
                    }else{
                        DT_STICKER_GENERATED_DATE = Tourplan_Daily[k]["DT_STICKER_GENERATED_DATE"].stringValue
                    }
                    
                    var REF_MAPPED_BY:Int = 0
                    if Tourplan_Daily[k]["REF_MAPPED_BY"] == nil {
                        REF_MAPPED_BY = 0
                    }else{
                        REF_MAPPED_BY = Tourplan_Daily[k]["REF_MAPPED_BY"].intValue
                    }
                    
                    var FK_LAST_DISPATCHED_TO:Int = 0
                    if Tourplan_Daily[k]["FK_LAST_DISPATCHED_TO"] == nil {
                        FK_LAST_DISPATCHED_TO = 0
                    }else{
                        FK_LAST_DISPATCHED_TO = Tourplan_Daily[k]["FK_LAST_DISPATCHED_TO"].intValue
                    }
                    
                    var FK_LAST_DISPATCHED_BY:Int = 0
                    if Tourplan_Daily[k]["FK_LAST_DISPATCHED_BY"] == nil {
                        FK_LAST_DISPATCHED_BY = 0
                    }else{
                        FK_LAST_DISPATCHED_BY = Tourplan_Daily[k]["FK_LAST_DISPATCHED_BY"].intValue
                    }
                    
                    var FK_LAST_PREVIOUSDISPATCHBY:Int = 0
                    if Tourplan_Daily[k]["FK_LAST_PREVIOUSDISPATCHBY"] == nil {
                        FK_LAST_PREVIOUSDISPATCHBY = 0
                    }else{
                        FK_LAST_PREVIOUSDISPATCHBY = Tourplan_Daily[k]["FK_LAST_PREVIOUSDISPATCHBY"].intValue
                    }
                    
                
                    var DT_LAST_DISPATCHED_DATE:String = ""
                    if Tourplan_Daily[k]["DT_LAST_DISPATCHED_DATE"] == nil {
                        DT_LAST_DISPATCHED_DATE = ""
                    }else{
                        DT_LAST_DISPATCHED_DATE = Tourplan_Daily[k]["DT_LAST_DISPATCHED_DATE"].stringValue
                    }
                    
                    var FK_LAST_RECEIVED_BY:Int = 0
                                       if Tourplan_Daily[k]["FK_LAST_RECEIVED_BY"] == nil {
                                           FK_LAST_RECEIVED_BY = 0
                                       }else{
                                           FK_LAST_RECEIVED_BY = Tourplan_Daily[k]["FK_LAST_RECEIVED_BY"].intValue
                                       }
                                       
                                       var DTLAST_RECEIVED_DATE:String = ""
                                       if Tourplan_Daily[k]["DTLAST_RECEIVED_DATE"] == nil {
                                           DTLAST_RECEIVED_DATE = ""
                                       }else{
                                           DTLAST_RECEIVED_DATE = Tourplan_Daily[k]["DTLAST_RECEIVED_DATE"].stringValue
                                       }
                    
                    var FK_LAST_REJECTED_BY:Int = 0
                    if Tourplan_Daily[k]["FK_LAST_REJECTED_BY"] == nil {
                        FK_LAST_REJECTED_BY = 0
                    }else{
                        FK_LAST_REJECTED_BY = Tourplan_Daily[k]["FK_LAST_REJECTED_BY"].intValue
                    }
                    
                    var DTLAST_REJECTED_DATE:String = ""
                    if Tourplan_Daily[k]["DTLAST_REJECTED_DATE"] == nil {
                        DTLAST_REJECTED_DATE = ""
                    }else{
                        DTLAST_REJECTED_DATE = Tourplan_Daily[k]["DTLAST_REJECTED_DATE"].stringValue
                    }
                    
                    var CHR_BLOCK:String = ""
                    if Tourplan_Daily[k]["CHR_BLOCK"] == nil {
                        CHR_BLOCK = ""
                    }else{
                        CHR_BLOCK = Tourplan_Daily[k]["CHR_BLOCK"].stringValue
                    }
                    
                    var FK_BLOCK_TYPE_GLCODE:Int = 0
                                       if Tourplan_Daily[k]["FK_BLOCK_TYPE_GLCODE"] == nil {
                                           FK_BLOCK_TYPE_GLCODE = 0
                                       }else{
                                           FK_BLOCK_TYPE_GLCODE = Tourplan_Daily[k]["FK_BLOCK_TYPE_GLCODE"].intValue
                                       }
                    
                    var DT_BLOCK_DATE:String = ""
                    if Tourplan_Daily[k]["DT_BLOCK_DATE"] == nil {
                        DT_BLOCK_DATE = ""
                    }else{
                        DT_BLOCK_DATE = Tourplan_Daily[k]["DT_BLOCK_DATE"].stringValue
                    }
                    
                    var FK_BLOCK_BY:Int = 0
                                       if Tourplan_Daily[k]["FK_BLOCK_BY"] == nil {
                                           FK_BLOCK_BY = 0
                                       }else{
                                           FK_BLOCK_BY = Tourplan_Daily[k]["FK_BLOCK_BY"].intValue
                                       }
                    
                    var CHR_LIQUIDATED:String = ""
                    if Tourplan_Daily[k]["CHR_LIQUIDATED"] == nil {
                        CHR_LIQUIDATED = ""
                    }else{
                        CHR_LIQUIDATED = Tourplan_Daily[k]["CHR_LIQUIDATED"].stringValue
                    }
                    
                    var DT_LIQUIDATED_DATE:String = ""
                    if Tourplan_Daily[k]["DT_LIQUIDATED_DATE"] == nil {
                        DT_LIQUIDATED_DATE = ""
                    }else{
                        DT_LIQUIDATED_DATE = Tourplan_Daily[k]["DT_LIQUIDATED_DATE"].stringValue
                    }
                    
                    var FK_LIQUIDATED_BY:Int = 0
                    if Tourplan_Daily[k]["FK_LIQUIDATED_BY"] == nil {
                        FK_LIQUIDATED_BY = 0
                    }else{
                        FK_LIQUIDATED_BY = Tourplan_Daily[k]["FK_LIQUIDATED_BY"].intValue
                    }
                    
                    var CHR_ACTIVE:String = ""
                    if Tourplan_Daily[k]["CHR_ACTIVE"] == nil {
                        CHR_ACTIVE = ""
                    }else{
                        CHR_ACTIVE = Tourplan_Daily[k]["CHR_ACTIVE"].stringValue
                    }
                    
                    var CHR_SYNC:String = ""
                    if Tourplan_Daily[k]["CHR_SYNC"] == nil {
                        CHR_SYNC = ""
                    }else{
                        CHR_SYNC = Tourplan_Daily[k]["CHR_SYNC"].stringValue
                    }
                    
                    var VAR_SYNC_CODE:String = ""
                    if Tourplan_Daily[k]["VAR_SYNC_CODE"] == nil {
                        VAR_SYNC_CODE = ""
                    }else{
                        VAR_SYNC_CODE = Tourplan_Daily[k]["VAR_SYNC_CODE"].stringValue
                    }
                    
                    var DT_SYNC_DATE:String = ""
                    if Tourplan_Daily[k]["DT_SYNC_DATE"] == nil {
                        DT_SYNC_DATE = ""
                    }else{
                        DT_SYNC_DATE = Tourplan_Daily[k]["DT_SYNC_DATE"].stringValue
                    }
                    
                    var DT_ENTRY_DATE:String = ""
                    if Tourplan_Daily[k]["DT_ENTRY_DATE"] == nil {
                        DT_ENTRY_DATE = ""
                    }else{
                        DT_ENTRY_DATE = Tourplan_Daily[k]["DT_ENTRY_DATE"].stringValue
                    }
                    
                    var REF_ENTRY_BY:Int = 0
                                       if Tourplan_Daily[k]["REF_ENTRY_BY"] == nil {
                                           REF_ENTRY_BY = 0
                                       }else{
                                           REF_ENTRY_BY = Tourplan_Daily[k]["REF_ENTRY_BY"].intValue
                                       }
                                       
                    var DT_MODIFIED_DATE:String = ""
                    if Tourplan_Daily[k]["DT_MODIFIED_DATE"] == nil {
                        DT_MODIFIED_DATE = ""
                    }else{
                        DT_MODIFIED_DATE = Tourplan_Daily[k]["DT_MODIFIED_DATE"].stringValue
                    }
                    
                    var REF_MODIFIED_BY:Int = 0
                    if Tourplan_Daily[k]["REF_MODIFIED_BY"] == nil {
                        REF_MODIFIED_BY = 0
                    }else{
                        REF_MODIFIED_BY = Tourplan_Daily[k]["REF_MODIFIED_BY"].intValue
                    }
              
                    let deleteQuery = "DELETE FROM CPM_SKU_STICKER_DETAILS WHERE VAR_SYNC_CODE IN ('\(VAR_SYNC_CODE)')"
                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                    print("delete from sticker details----\(FK_STICKER_DETAIL_GLCODE)-------\(VAR_SYNC_CODE)")

                    try self.database.executeUpdate("insert into CPM_SKU_STICKER_DETAILS (INT_GLCODE,VAR_REF_ID,FK_SYSTEM_GLCODE,FK_CUSTOMER_GLCODE,FK_PBG_GLCODE,FK_PRD_GLCODE,VAR_STICKER_TYPE,INT_BATCH_ID,VAR_BATCH_NO,DT_MFG_DATE,DT_EXPIRE_DATE,FK_STICKER_DETAIL_GLCODE,VAR_STICKER_DETAIL_SYNC_CODE,FK_PRODUCT_SKU_GLCODE,VAR_SKU_BTC_NO,VAR_SKU_QR_CODE,VAR_HELPER_CODE,INT_SEQUENCE,CHR_SCANNED_STATUS,DT_SCANNED_DATE,VAR_REJECT_REASON,FK_STATUS_GLCODE,CHR_MAPPED,FK_STICKER_GENERATED_BY,DT_STICKER_GENERATED_DATE,REF_MAPPED_BY,FK_LAST_DISPATCHED_TO,FK_LAST_DISPATCHED_BY,FK_LAST_PREVIOUSDISPATCHBY,DT_LAST_DISPATCHED_DATE,FK_LAST_RECEIVED_BY,DTLAST_RECEIVED_DATE,FK_LAST_REJECTED_BY,DTLAST_REJECTED_DATE,CHR_BLOCK,FK_BLOCK_TYPE_GLCODE,DT_BLOCK_DATE,FK_BLOCK_BY,CHR_LIQUIDATED,DT_LIQUIDATED_DATE,FK_LIQUIDATED_BY,CHR_ACTIVE,CHR_SYNC,VAR_SYNC_CODE,DT_SYNC_DATE,DT_ENTRY_DATE,REF_ENTRY_BY,DT_MODIFIED_DATE,REF_MODIFIED_BY) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", values: [INT_GLCODE,VAR_REF_ID,FK_SYSTEM_GLCODE,FK_CUSTOMER_GLCODE,FK_PBG_GLCODE,FK_PRD_GLCODE,VAR_STICKER_TYPE,INT_BATCH_ID,VAR_BATCH_NO,DT_MFG_DATE,DT_EXPIRE_DATE,FK_STICKER_DETAIL_GLCODE,VAR_STICKER_DETAIL_SYNC_CODE,FK_PRODUCT_SKU_GLCODE,VAR_SKU_BTC_NO,VAR_SKU_QR_CODE,VAR_HELPER_CODE,INT_SEQUENCE,CHR_SCANNED_STATUS,DT_SCANNED_DATE,VAR_REJECT_REASON,FK_STATUS_GLCODE,CHR_MAPPED,FK_STICKER_GENERATED_BY,DT_STICKER_GENERATED_DATE,REF_MAPPED_BY,FK_LAST_DISPATCHED_TO,FK_LAST_DISPATCHED_BY,FK_LAST_PREVIOUSDISPATCHBY,DT_LAST_DISPATCHED_DATE,FK_LAST_RECEIVED_BY,DTLAST_RECEIVED_DATE,FK_LAST_REJECTED_BY,DTLAST_REJECTED_DATE,CHR_BLOCK,FK_BLOCK_TYPE_GLCODE,DT_BLOCK_DATE,FK_BLOCK_BY,CHR_LIQUIDATED,DT_LIQUIDATED_DATE,FK_LIQUIDATED_BY,CHR_ACTIVE,CHR_SYNC,VAR_SYNC_CODE,DT_SYNC_DATE,DT_ENTRY_DATE,REF_ENTRY_BY,DT_MODIFIED_DATE,REF_MODIFIED_BY])
                    //}

                    k += 1
                }
            }catch{
                print("Insert Error CPM_SKU_STICKER_DETAILS")

                return false
            }

            return true
        }

        return false
        //}
    }

    func parseJsonStickerDetailsForLAB(Tourplan_Daily:JSON)->Bool{
        //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
        if(Tourplan_Daily.count > 0){

            do{
                var k = 0
                while (k < Tourplan_Daily.count){
                    let chrTran = Tourplan_Daily[k]["chrTran"].stringValue

                    if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                        continue
                    }

                    let intGlCode = Tourplan_Daily[k]["intGlCode"].intValue //Done
                    let fk_StickerGlCode = Tourplan_Daily[k]["fk_StickerGlCode"].intValue //Done
                    let varRef_Id = Tourplan_Daily[k]["varRef_Id"].stringValue //Done
                    var varRef_Id_Counter : Int = 0
                    if Tourplan_Daily[k]["intRef_Id_Counter"] == nil {
                        varRef_Id_Counter = 0
                    }else{
                        varRef_Id_Counter = Tourplan_Daily[k]["intRef_Id_Counter"].intValue
                    }
                    //let varRef_Id_Counter = Tourplan_Daily[k]["intRef_Id_Counter"].intValue // Done
                    let varSystem_Name = Tourplan_Daily[k]["varSystem_Name"].stringValue  //Done
                    let fk_CustomerGlCode = Tourplan_Daily[k]["fk_CustomerGlCode"].intValue //Done
                    let fk_CountryGlCode = Tourplan_Daily[k]["fk_CountryGlCode"].intValue //Done
                    let fk_PBGGlCode = Tourplan_Daily[k]["fk_PBGGlCode"].intValue //Done
                    let fk_PRDGlCode = Tourplan_Daily[k]["fk_PRDGlCode"].intValue //Done
                    var fk_Product_SKUGlCode : Int = 0


                    if Tourplan_Daily[k]["fk_Product_SKUGlCode"] == nil {
                        fk_Product_SKUGlCode = 0
                    }else{
                        fk_Product_SKUGlCode = Tourplan_Daily[k]["fk_Product_SKUGlCode"].intValue
                    }


                    //let varStickerType = Tourplan_Daily[k]["varStickerType"].stringValue
                    let varGRNO = Tourplan_Daily[k]["varGRNO"].stringValue
                    let varBatch_No = Tourplan_Daily[k]["varBatch_No"].stringValue

                    var dtMFGDate:String = ""
                    if Tourplan_Daily[k]["dtMFGDate"] == nil {
                        dtMFGDate = ""
                    }else{
                        dtMFGDate = Tourplan_Daily[k]["dtMFGDate"].stringValue
                    }

                    let dtExpireDate = Tourplan_Daily[k]["dtExpireDate"].stringValue
                    //let varSticker_From_Range = Tourplan_Daily[k]["varSticker_From_Range"].stringValue
                    //let varSticker_To_Range = Tourplan_Daily[k]["varSticker_To_Range"].stringValue
                    let varBTC_No_In = Tourplan_Daily[k]["varBTC_No_In"].stringValue
                    let varBTC_No_Out = Tourplan_Daily[k]["varBTC_No_Out"].stringValue
                    let varQR_Code_In = Tourplan_Daily[k]["varQR_Code_In"].stringValue
                    let varQR_Code_Out = Tourplan_Daily[k]["varQR_Code_Out"].stringValue

                    let varSticker_No = Tourplan_Daily[k]["varSticker_No"].stringValue

                    var dtLastGRDate:String = ""
                    if Tourplan_Daily[k]["dtLastGRDate"] == nil {
                        dtLastGRDate = ""
                    }else{
                        dtLastGRDate = Tourplan_Daily[k]["dtLastGRDate"].stringValue
                    }

                    var decTotalQtyInKG:double_t = 0
                    if Tourplan_Daily[k]["decTotalQtyInKG"] == nil {
                        decTotalQtyInKG = 0
                    }else{
                        decTotalQtyInKG = Tourplan_Daily[k]["decTotalQtyInKG"].doubleValue
                    }

                    var decCurrentQtyInKG:double_t = 0
                    if Tourplan_Daily[k]["decCurrentQtyInKG"] == nil {
                        decCurrentQtyInKG = 0
                    }else{
                        decCurrentQtyInKG = Tourplan_Daily[k]["decCurrentQtyInKG"].doubleValue
                    }


                    /* let chrPallet = Tourplan_Daily[k]["chrPallet"].stringValue*/
                    /*let fk_PalletGlCode = Tourplan_Daily[k]["fk_PalletGlCode"].intValue*/

                    let fk_StatusGlCode = Tourplan_Daily[k]["fk_StatusGlCode"].intValue
                    let fk_Sticker_GeneratedBy = Tourplan_Daily[k]["fk_Sticker_GeneratedBy"].intValue
                    let dtSticker_GeneratedDate = Tourplan_Daily[k]["dtSticker_GeneratedDate"].stringValue


                    var fk_ChemistGlCode : Int = 0
                    if Tourplan_Daily[k]["fk_ChemistGlCode"] == nil {
                        fk_ChemistGlCode = 0
                    }else{
                        fk_ChemistGlCode = Tourplan_Daily[k]["fk_ChemistGlCode"].intValue
                    }

                    var fk_LocationGlCode : Int = 0
                    if Tourplan_Daily[k]["fk_LocationGlCode"] == nil {
                        fk_LocationGlCode = 0
                    }else{
                        fk_LocationGlCode = Tourplan_Daily[k]["fk_LocationGlCode"].intValue
                    }

                    let fk_Last_DispatchedBy = Tourplan_Daily[k]["fk_Last_DispatchedBy"].intValue
                    let fk_Last_PreviousDispatchBy = Tourplan_Daily[k]["fk_Last_PreviousDispatchBy"].intValue
                    let fk_Last_DispatchedTo = Tourplan_Daily[k]["fk_Last_DispatchedTo"].intValue

                    let dtLast_DispatchedDate = Tourplan_Daily[k]["dtLast_DispatchedDate"].stringValue
                    //let fk_Last_ReceivedBy = Tourplan_Daily[k]["chrDisposal"].intValue

                    var chrDisposal:String = ""
                    if Tourplan_Daily[k]["chrDisposal"] == nil {
                        chrDisposal = ""
                    }else{
                        chrDisposal = Tourplan_Daily[k]["chrDisposal"].stringValue
                    }


                    var dtDisposalDateTime:String = ""
                    if Tourplan_Daily[k]["dtDisposalDateTime"] == nil {
                        dtDisposalDateTime = ""
                    }else{
                        dtDisposalDateTime = Tourplan_Daily[k]["dtDisposalDateTime"].stringValue
                    }

                    let fk_Disposal_Status_GlCode = Tourplan_Daily[k]["fk_Disposal_Status_GlCode"].intValue

                    let fk_DisposalBy = Tourplan_Daily[k]["fk_DisposalBy"].intValue

                    var chrActive:String = ""
                    if Tourplan_Daily[k]["chrActive"] == nil {
                        chrActive = ""
                    }else{
                        chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                    }

                    var chrSync:String = ""
                    if Tourplan_Daily[k]["chrSync"] == nil {
                        chrSync = ""
                    }else{
                        chrSync = Tourplan_Daily[k]["chrSync"].stringValue
                    }

                    var varSync_Code:String = ""
                    if Tourplan_Daily[k]["varSync_Code"] == nil {
                        varSync_Code = ""
                    }else{
                        varSync_Code = Tourplan_Daily[k]["varSync_Code"].stringValue
                    }

                    var dtSyncDate:String = ""
                    if Tourplan_Daily[k]["dtSyncDate"] == nil {
                        dtSyncDate = ""
                    }else{
                        dtSyncDate = Tourplan_Daily[k]["dtSyncDate"].stringValue
                    }

                    var dtEntryDate:String = ""
                    if Tourplan_Daily[k]["dtEntryDate"] == nil {
                        dtEntryDate = ""
                    }else{
                        dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                    }

                    var ref_Entry_By:Int = 0
                    if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                        ref_Entry_By = 0
                    }else{
                        ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].intValue
                    }

                    var dtModifiedDate:String = ""
                    if Tourplan_Daily[k]["dtModifiedDate"] == nil {
                        dtModifiedDate = ""
                    }else{
                        dtModifiedDate = Tourplan_Daily[k]["dtModifiedDate"].stringValue
                    }

                    var ref_Modified_By:Int = 0
                    if Tourplan_Daily[k]["ref_Modified_By"] == nil {
                        ref_Modified_By = 0
                    }else{
                        ref_Modified_By = Tourplan_Daily[k]["ref_Modified_By"].intValue
                    }

                    var varLastStage:String = ""
                    if Tourplan_Daily[k]["varLastStage"] == nil {
                        varLastStage = ""
                    }else{
                        varLastStage = Tourplan_Daily[k]["varLastStage"].stringValue
                    }



                    var intRowNo:Int = 0
                    if Tourplan_Daily[k]["intRowNo"] == nil {
                        intRowNo = 0
                    }else{
                        intRowNo = Tourplan_Daily[k]["intRowNo"].intValue
                    }

                    /*var dtLast_ReceivedDate:String = ""
                     if Tourplan_Daily[k]["dtLast_ReceivedDate"] == nil {
                     dtLast_ReceivedDate = ""
                     }else{
                     dtLast_ReceivedDate = Tourplan_Daily[k]["dtLast_ReceivedDate"].stringValue
                     }*/

                    //print("fk_CampGlCode JJ \(fk_CampGlCode)")

                    /*if(checkTourplan_DailyCount(fk_DrGlCode: fk_DrGlCode, fk_EmpGlCode_Planned: fk_EmpGlCode_Planned, fk_DivisionGlCode: fk_DivisionGlCode, dtPlanDate: dtPlanDate) > 0){

                     let update = "update Tourplan_Daily set fk_PurposeGlCode = ?,fk_DrGlCode = ?, fk_EmpGlCode_Planned = ?, dtEntryDate = ?, fk_DivisionGlCode = ?, fk_PersonGlCode = ?, chrDeleteFlag = ?, dtPlanDate = ?, fk_CampGlCode = ?, varTime = ?,  fk_DesiGlCode = ?, chrSyncFlag = ? where fk_DrGlCode = \(fk_DrGlCode) and fk_EmpGlCode_Planned = \(fk_EmpGlCode_Planned) and dtPlanDate = '\(dtPlanDate)' "

                     try database.executeUpdate(update, values: [fk_PurposeGlCode, fk_DrGlCode,fk_EmpGlCode_Planned,dtEntryDate,fk_DivisionGlCode,fk_PersonGlCode,chrDeleteFlag,dtPlanDate,fk_CampGlCode,varTime,fk_DesiGlCode,chrSyncFlag])

                     }else{*/

                    //46
                    //30

                    let deleteQuery = "DELETE FROM LAB_Sticker_Details WHERE varSync_Code IN ('\(varSync_Code)')"
                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                    print("delete from sticker details----\(fk_StickerGlCode)-------\(varSync_Code)")

                    try self.database.executeUpdate("insert into LAB_Sticker_Details (intGlCode,fk_StickerGlCode,fk_CustomerGlCode,varRef_Id,intRef_Id_Counter,varSystem_Name,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varGRNO,varBatch_No,dtMFGDate,dtExpireDate,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,dtLastGRDate,decTotalQtyInKG,decCurrentQtyInKG,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,fk_ChemistGlCode,fk_LocationGlCode,fk_Last_DispatchedTo,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,dtLast_DispatchedDate,chrDisposal,fk_Disposal_Status_GlCode,dtDisposalDateTime,fk_DisposalBy,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage,intRowNo) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", values: [intGlCode,fk_StickerGlCode,fk_CustomerGlCode,varRef_Id,varRef_Id_Counter,varSystem_Name,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varGRNO,varBatch_No,dtMFGDate,dtExpireDate,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,dtLastGRDate,decTotalQtyInKG,decCurrentQtyInKG,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,fk_ChemistGlCode,fk_LocationGlCode,fk_Last_DispatchedTo,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,dtLast_DispatchedDate,chrDisposal,fk_Disposal_Status_GlCode,dtDisposalDateTime,fk_DisposalBy,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage,intRowNo])
                    //}

                    k += 1
                }
            }catch{
                print("error Tourplan_Daily")

                return false
            }

            return true
        }

        return false
        //}
    }

    func nullToNil(value : AnyObject?) -> AnyObject? {
        if value is NSNull {
            return nil
        } else {
            return value
        }
    }

    func intValueForKey(key: String, inDictionary dictionary: [String: AnyObject]) throws -> Int {
        if let value = dictionary[key]?.integerValue {
            return value
        } else {
            throw NSError(domain: "Invalid key", code: -1, userInfo: nil)
        }
    }

    func stringValueForKey(key: String, inDictionary dictionary: [String: AnyObject]) throws -> String {
        if let value = dictionary[key]?.stringValue {
            return value
        } else {
            throw NSError(domain: "Invalid key", code: -1, userInfo: nil)
        }
    }

    func unzipFile(zipPath: String, destinationPath:String) -> Bool{
        var fileUnZip = false
        var filePath = ""
        filePath = zipPath
        //let s:Bool =  SSZipArchive.unzipFile(atPath: zipPath, toDestination: destinationPath)
        print(zipPath)
        
       /* if !filePath.contains(".zip") {
            // If not, append ".zip" to the end of the string
            filePath.append(".zip")
        }*/
        
        print("final zipPath:\(filePath)")
        
        print(destinationPath)

        var s:Bool = false
        let success = SSZipArchive.isFilePasswordProtected(atPath: filePath)
        if success {
            print("Yes, it's password protected.")
            //info.text = "Yes, it's password protected."

            s   = SSZipArchive.unzipFile(atPath: filePath,
                                         toDestination: destinationPath,
                                         preserveAttributes: true,
                                         overwrite: true,
                                         nestedZipLevel: 1,
                                         password: ZipPassword,
                                         error: nil,
                                         delegate: nil,
                                         progressHandler: nil,
                                         completionHandler: nil)
        } else {
            print("No, it's not password protected.")
            //info.text = "No, it's not password protected."
            s =  SSZipArchive.unzipFile(atPath: filePath, toDestination: destinationPath)
        }

        if(s){
            fileUnZip = true
            //print("unzip zip file")
        }else{
            fileUnZip = false
            //print("not unzip zip file")
        }
        return fileUnZip
    }

    func writeLog(key: String, value: String){
        let todaysDate = getCurrentDateTimeFormated()
        let logData = "\(key) $$$ \(value) $$$ Date Time:- \(todaysDate)"
        ////print(logData)
        hashMap[key] = logData
    }

    func updateProgress(type:Int, message:String, min: Int, max: Int){

        if(type==444){
            returnItems = ["type": "\(type)","Details": message,"progress": "\(randomNumber(MIN: min, MAX: max))"]
            NotificationCenter.default.post(name: notificationName, object: nil)
        }
        else if(type==555 || type==666){
            var status=""
            if(type==2){
                status="N"
            }else{
                status="Y"
            }

            self.SyncDone(type:type,message:message,min:min,max:max)

//            self.callUpload(urlUpload: urlUpload, logUploadMethod: logUploadMethod, fk_EmpGlCode: fk_EmpGlCode, SyncId: self.SyncId, DeviceSyncStatus: status, DeviceSyncJson: status, ClientName: ClientName, imei: imei, version: version, userName: userName,type: type,message: message,min: min,max: max)

            /*if(type==3){

             }else{
             returnItems = ["type": "\(type)","Details": message,"progress": "\(randomNumber(MIN: min, MAX: max))"]
             NotificationCenter.default.post(name: notificationName, object: nil)
             }*/
            //sleep(3)


        }
    }

    func deleteTable(database:FMDatabase, tableName:String){
        if database.open()
        {
            let deleteQuery = "DELETE FROM \(tableName) WHERE chrSync = 'N'"
            database.executeUpdate(deleteQuery, withArgumentsIn: [])
        }
    }

    func getJsonFromTable(database:FMDatabase,tableName:String)->JSON{
        //var varIntRowCount:String = ""
        if database.open()
        {
            let selectQuery = "SELECT * FROM \(tableName) WHERE chrSync = 'N'"
            //print(selectQuery)

            if let rs = database.executeQuery(selectQuery, withArgumentsIn: [])
            {
                var data = [JSON]()

                while(rs.next()){
                    let dir = rs.resultDictionary
                    //print(dir)
                    let json = JSON(dir)
                    data.append(json)
                }
                return JSON(data)
            }
        }

        return JSON("[]")
    }
    
    func getJsonFromTableIFFCO(database:FMDatabase,tableName:String)->JSON{
        //var varIntRowCount:String = ""
        if database.open()
        {
            let selectQuery = "SELECT * FROM \(tableName) WHERE CHR_SYNC = 'N'"
            //print(selectQuery)

            if let rs = database.executeQuery(selectQuery, withArgumentsIn: [])
            {
                var data = [JSON]()

                while(rs.next()){
                    let dir = rs.resultDictionary
                    //print(dir)
                    let json = JSON(dir)
                    data.append(json)
                }
                return JSON(data)
            }
        }

        return JSON("[]")
    }

    func writeTransactionTablesToFile(tableName: String, NumberOfRecordPerArray: Int, intRowNumber: Int, filePath: String) {

        var isExit:Bool = false
        var fileCount:Int = 0
        var tmpRowNumber = intRowNumber

        //var jsonArray = [JSON]()

        repeat {
            let selectQuery = "SELECT * FROM \(tableName) WHERE chrSync = 'N' AND intGlCode > \(tmpRowNumber) LIMIT 2000"

            let selectQueryCount = "SELECT COUNT(*) as Count FROM \(tableName) WHERE chrSync = 'N' AND intGlCode > \(tmpRowNumber) LIMIT 2000"

            //print(selectQuery)

            var count = 0
            if let rs = database.executeQuery(selectQueryCount, withArgumentsIn: []) {
                while rs.next() {
                    count = Int(rs.int(forColumn: "Count"))
                    print("Total Records:", count)
                }
            }
            if(count>0){
                if let rs = database.executeQuery(selectQuery, withArgumentsIn: [])
                {
                    var data = [JSON]()

                    var limitCount=0
                    while(rs.next()){
                        let dir = rs.resultDictionary
                        //print(dir)
                        let json = JSON(dir)
                        //print(json)
                        data.append(json)
                        limitCount+=1

                        isExit = limitCount==count

                        if(data.count >= 1000 || isExit){
                            fileCount+=1;
                            generateTextFile(root: filePath, sFileName: "\(tableName)$_\(fileCount).txt", sBody: "\(data)")
                            //tmpRowNumber = data[data.count-1].arrayValue.last!["intGlCode"].intValue
                            tmpRowNumber = dir!["intGlCode"] as! Int
                            data.removeAll()
                        }
                    }
                }
            }else{
                isExit = true
            }

        } while !isExit;
    }
    
    
    
    
    func writeTransactionTablesToFileIFFCO(tableName: String, NumberOfRecordPerArray: Int, intRowNumber: Int, filePath: String) {

        var isExit:Bool = false
        var fileCount:Int = 0
        var tmpRowNumber = intRowNumber

        //var jsonArray = [JSON]()

        repeat {
            let selectQuery = "SELECT * FROM \(tableName) WHERE CHR_SYNC = 'N' AND INT_GLCODE > \(tmpRowNumber) LIMIT 2000"

            let selectQueryCount = "SELECT COUNT(*) as Count FROM \(tableName) WHERE CHR_SYNC = 'N' AND INT_GLCODE > \(tmpRowNumber) LIMIT 2000"

            //print(selectQuery)

            var count = 0
            if let rs = database.executeQuery(selectQueryCount, withArgumentsIn: []) {
                while rs.next() {
                    count = Int(rs.int(forColumn: "Count"))
                    print("Total Records:", count)
                }
            }
            if(count>0){
                if let rs = database.executeQuery(selectQuery, withArgumentsIn: [])
                {
                    var data = [JSON]()

                    var limitCount=0
                    while(rs.next()){
                        let dir = rs.resultDictionary
                        //print(dir)
                        let json = JSON(dir)
                        //print(json)
                        data.append(json)
                        limitCount+=1

                        isExit = limitCount==count

                        if(data.count >= 1000 || isExit){
                            fileCount+=1;
                            generateTextFile(root: filePath, sFileName: "\(tableName)$_\(fileCount).txt", sBody: "\(data)")
                            //tmpRowNumber = data[data.count-1].arrayValue.last!["intGlCode"].intValue
                            tmpRowNumber = dir!["INT_GLCODE"] as! Int
                            data.removeAll()
                        }
                    }
                }
            }else{
                isExit = true
            }

        } while !isExit;
    }
    
    func writeStringAsFile(fileName: String, fileContents: String){

        //print("Generate File")
        //print(root)
        //print(sFileName)
        
        //ROOT_PATH
        let filePathSyncBackUp = documentsPath.appendingPathComponent("CPM_LOGS")
        let fileMainDir_log = filePathSyncBackUp?.appendingPathComponent("LOGS_RE_CPM")


        let filePath = fileMainDir_log!.appendingPathComponent("/" + fileName).path

        do {
            try fileContents.write(toFile: filePath, atomically: false, encoding: String.Encoding.utf8)
        }
        catch let error as NSError {
            print("An error took place: \(error)")
        }
    }

    func generateTextFile(root: String, sFileName: String, sBody: String){

        //print("Generate File")
        //print(root)
        //print(sFileName)


        let filePath = root.appending("/" + sFileName)

        do {
            try sBody.write(toFile: filePath, atomically: false, encoding: String.Encoding.utf8)
        }
        catch let error as NSError {
            print("An error took place: \(error)")
        }
    }

    func callUpload(urlUpload: String, logUploadMethod: String, fk_EmpGlCode: String, SyncId: Int, DeviceSyncStatus: String, DeviceSyncJson: String, ClientName: String, imei: String, version: String, userName: String,type:Int,message:String,min:Int,max:Int){
        let DeviceSyncJson="\(self.hashMap)"
        //print("DeviceSyncJson ### \(DeviceSyncJson)")

        self.uploadLogToServerAfterSync(urlUpload: urlUpload, logUploadMethod: logUploadMethod, PersonId: fk_EmpGlCode, SyncId: self.SyncId, DeviceSyncStatus: DeviceSyncStatus, DeviceSyncJson: DeviceSyncJson, SubModuleName: ClientName, DeviceId: imei, Version: version, APIToken: userName,type: type,message: message,min: min,max: max)
    }

    func uploadLogToServerAfterSync(urlUpload: String, logUploadMethod: String, PersonId: String, SyncId: Int, DeviceSyncStatus: String, DeviceSyncJson: String, SubModuleName: String, DeviceId: String, Version: String, APIToken: String,type:Int,message:String,min:Int,max:Int){
    print("uploadLogToServerAfterSync START \(DeviceSyncStatus)")
//        let parameters = [
//            "PersonId": "\(PersonId)",
//            "SyncId": "\(SyncId)",
//            "DeviceSyncStatus": "\(DeviceSyncStatus)",
//            "DeviceSyncJson": "\(self.syncJSONInString())",
//            "SubModuleName": "\(SubModuleName)",
//            "DeviceId": "\(DeviceId)",
//            "Version": "\(Version)",
//            "APIToken": "\(APIToken)",
//
//            "SyncType": "\(self.syncType)",
//            "SyncLogJson": "{\"Sync_Log\":[\"\(self.requestJSONInString())\"]}",
//            "ExtraFields": ""
//        ]

        var parameters = [String: String]()
        var headers = HTTPHeaders()
               
//         if(packageName == "com.ecubix.iffcocpm"){
        if(packageName == "com.vcs.iffcocpm"){
                  parameters = [
                       "PersonId": "\(PersonId)",
                       "SyncId": "\(SyncId)",
                       "DeviceSyncStatus": "\(DeviceSyncStatus)",
                       "DeviceSyncJson": "\(self.syncJSONInString())",
                       "SubModuleName": "\(SubModuleName)",
                       "DeviceId": "\(DeviceId)",
                       "Version": "\(Version)",
                       "APIToken": "\(APIToken)",
                       "CustomerID": "\(CustomerId)",
                       "SyncType": "\(self.syncType)",
                       "SyncLogJson": "{\"Sync_Log\":[\"\(self.requestJSONInString())\"]}",
                       "ExtraFields": "",
                       "Action": ""
                   ]
                   
                   headers = [
                         "X-ApiKey": "i3BalYxQL",
                         "Content-Type": "application/x-www-form-urlencoded"
                     ]
               } else {
                   parameters = [
                       "PersonId": "\(PersonId)",
                       "SyncId": "\(SyncId)",
                       "DeviceSyncStatus": "\(DeviceSyncStatus)",
                       "DeviceSyncJson": "\(self.syncJSONInString())",
                       "SubModuleName": "\(SubModuleName)",
                       "DeviceId": "\(DeviceId)",
                       "Version": "\(Version)",
                       "APIToken": "\(APIToken)",

                       "SyncType": "\(self.syncType)",
                       "SyncLogJson": "{\"Sync_Log\":[\"\(self.requestJSONInString())\"]}",
                       "ExtraFields": ""
                   ]
               
               }
        
        print(parameters)
        print(logURL)
        print(logMethod)
        let web = logURL + logMethod
        //logMethod = methodSyncID
        //let web = urlUpload + logUploadMethod
        //let web = "https://basf-dlite3-fulfil.ecubix.com/service/services.asmx/DeviceSyncLog"
        print(web)
        self.alamofireManager!.request(web, method: .post, parameters: parameters,headers: headers).validate(statusCode: 200..<300)

            .responseString { response in
                print("logUploadMethod -------- Success: \(logUploadMethod) \(response.result)")

                /* DispatchQueue.main.async {

                 //self.SyncDone(type:type,message:message,min:min,max:max)
                 }*/
        }

        //sleep(2)


    }

    func SyncDone(type:Int,message:String,min:Int,max:Int){
        self.returnItems = ["type": "\(type)","Details": message,"progress": "\(self.randomNumber(MIN: min, MAX: max))"]
        NotificationCenter.default.post(name: self.notificationName, object: nil)
    }

    func getCurrentDateTimeFormated() -> String{
        let date : Date = Date()
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
        return dateFormatter.string(from: date)
    }

    //File Sync END

    @objc func onBatteryStateDidChange(_ notification: Notification?) {
        //print("onBatteryStateDidChange")
        sendBatteryStateEvent()
    }

    func sendBatteryStateEvent() {
        if eventSink == nil {
            //print("eventSink nil")
            return
        }

        eventSink?(returnItems)

    }

    public func onListen(withArguments arguments: Any?, eventSink: @escaping FlutterEventSink) -> FlutterError? {
        self.eventSink = eventSink
        //UIDevice.current.isBatteryMonitoringEnabled = true
        //sendBatteryStateEvent()
        NotificationCenter.default.addObserver(self, selector: #selector(onBatteryStateDidChange(_:)), name: notificationName, object: nil)
        return nil
    }

    public func onCancel(withArguments arguments: Any?) -> FlutterError? {
        NotificationCenter.default.removeObserver(self)
        eventSink = nil
        return nil
    }

    /*func handle(_ call: FlutterMethodCall?, result: FlutterResult) {
     if ("getBatteryLevel" == call?.method) {
     let batteryLevel: Int = getBatteryLevel()
     if batteryLevel == -1 {
     result(FlutterError(code: "UNAVAILABLE", message: "Battery info unavailable", details: nil))
     } else {
     result(batteryLevel)
     }
     } else {
     result(FlutterMethodNotImplemented)
     }
     }*/

    /*func getBatteryLevel() -> Int {
     let device = UIDevice.current
     device.isBatteryMonitoringEnabled = true
     if device.batteryState == .unknown {
     return -1
     } else {
     return Int(device.batteryLevel * 100)
     }
     }*/

    func SyncData(userName:String,fk_EmpGlCode:String,ClientName:String,version:String,imei:String,uploadMethod:String,urlUpload:String,databaseName:String, dbPassword:String, isDbEncripted:String,CustomerId:String,DeviceSyncStatus:String,CustomerCode:String,SystemName:String,LastSyncDate:String,ServerSyncId:String,packageName:String)->String{

        self.userName=userName;
        self.fk_EmpGlCode=fk_EmpGlCode;
        self.ClientName=ClientName;
        self.version=version;
        self.imei=imei;
        self.uploadMethod=uploadMethod;
        self.logUploadMethod=urlUpload;
        self.urlUpload=urlUpload;
        self.packageName = packageName
        self.CustomerId=CustomerId;
        self.DeviceSyncStatus=DeviceSyncStatus
        self.CustomerCode=CustomerCode;
        self.SystemName=SystemName;
        self.LastSyncDate=LastSyncDate;
        self.ServerSyncId=ServerSyncId;

        print("*****************")
        print(logUploadMethod)
        print(uploadMethod)

        //xx
        requestJSON.setValue(Date().getJsonLogTime(), forKey: "SYNC_START")

        //returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 1,MAX: 5))"]
        //NotificationCenter.default.post(name: notificationName, object: nil)
        self.updateProgress(type: 1, message: "progress", min: 1, max: 5)

        var isGoahead:Bool = true
        var isGoaheadMessage:String = ""

        let date = Date()
        let calendar = Calendar.current

        let year = calendar.component(.year, from: date)
        let month = calendar.component(.month, from: date)
        let day = calendar.component(.day, from: date)

        let hour = calendar.component(.hour, from: date)
        let minute = calendar.component(.minute, from: date)
        let second = calendar.component(.second, from: date)
        let packageName : String = dict["packageName"] ?? ""

        let dirName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"

        let fileName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"
        var zipName:String
        if(packageName == "com.ecubix.basflab"){
            zipName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_BASF-LAB-Database"
            self.zipNameFinal = zipName
//         } else if(packageName == "com.ecubix.iffcocpm"){
        } else if(packageName == "com.vcs.iffcocpm"){
            zipName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_IFFCO_CPM_Database"
            self.zipNameFinal = zipName
        } else if(packageName == "com.ecubix.basfhkre-ret"){
            zipName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_BASF-Retailer-Database"
            self.zipNameFinal = zipName
        } else {
//            zipName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_BASF-HK-Database"
            zipName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_F_Re_CPM"
            self.zipNameFinal = zipName
        }
        // App database path
        let filePathFrom = documentsPath.appendingPathComponent(databaseName)?.path
        let filePathTo = documentsPath.appendingPathComponent("SyncDatabase")?.path
        //let filePathTo1 = documentsPath.appendingPathComponent("SyncDatabase/\(databaseName)")?.path
        //let filePathTo2 = documentsPath.appendingPathComponent("SyncDatabase/\(fileName)")?.path
        let fileManager = FileManager.default

        //createDirSyncDb(documentsPath)

        if fileManager.fileExists(atPath: filePathTo!) {
            do {
                try fileManager.removeItem(atPath: filePathTo!)
            } catch let error as NSError {
                NSLog("delete directory \(error.debugDescription)")
                isGoahead = false;
                isGoaheadMessage = "error:101";
            }
            createDirSyncDb(documentsPath: documentsPath)
        } else {
            createDirSyncDb(documentsPath: documentsPath)
        }

        if(isGoahead){
            /*if fileManager.fileExists(atPath: filePathTo1!) {
                //print("filePathTo1 exist")
            }
            if fileManager.fileExists(atPath: filePathTo2!) {
                //print("filePathTo2 exist")
            }*/
            //databaseName = "BASF-HK-Database"
            let filePathToZip = documentsPath.appendingPathComponent("SyncDatabase/\(zipName).zip")?.path

            let newDirectory = documentsPath.appendingPathComponent("SyncDatabase/\(dirName)")?.path

            let newDirectory1 = documentsPath.appendingPathComponent("SyncDatabase/\(dirName)/\(fileName)")?.path

            do {
                try fileManager.createDirectory(atPath: newDirectory!, withIntermediateDirectories: false, attributes: nil)
            } catch let error as NSError {
                //print(error.localizedDescription);
                //print("error create newDirectory")
                //print("Ooops! Something went wrong createDirectory: \(error)")
                isGoahead = false;
                isGoaheadMessage = "error:103 \(error)";
            }

            requestJSON.setValue(Date().getJsonLogTime(), forKey: "EXPORT_FILE_START")
            syncJSON.setValue("---Export Database Start---", forKey: "1")

            //copy from SyncDatabase to document
            if fileManager.fileExists(atPath: filePathFrom!) {
                do {
                    try fileManager.copyItem(atPath: filePathFrom!, toPath: newDirectory1!)

                    requestJSON.setValue(Date().getJsonLogTime(), forKey: "EXPORT_FILE_END")
                    syncJSON.setValue("---Export Database End---", forKey: "2")

                } catch let error as NSError {
                    NSLog("Unable to copy file \(error.debugDescription)")
                    //print("Ooops! Something went wrong copyItem: \(error)")
                    isGoahead = false;
                    isGoaheadMessage = "error:103";
                    syncJSON.setValue("---Export database failed---", forKey: "9")
                }
            }

            //returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 6,MAX: 10))"]
            //NotificationCenter.default.post(name: notificationName, object: nil)
            self.updateProgress(type: 1, message: "progress", min: 6, max: 10)

            if(isGoahead){
                requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_START")
                syncJSON.setValue("---Create Zip File Start---", forKey: "3")

                if(isDbEncripted == "true"){
                    let success = SSZipArchive.createZipFile(atPath: filePathToZip!,
                                                             withContentsOfDirectory: newDirectory!,
                                                             keepParentDirectory: false,
                                                             compressionLevel: 5,
                                                             password: ZipPassword,
                                                             aes: true,
                                                             progressHandler: nil)
                    //let success = SSZipArchive.createZipFile(atPath: filePathToZip!, withContentsOfDirectory: newDirectory!)
                    if(success){
                        requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_END")
                        syncJSON.setValue("---Create Zip File End---", forKey: "4")
                        isGoahead = true
                    }else{
                        isGoahead = false
                        isGoaheadMessage = "Error creating zip"
                        syncJSON.setValue("---Failed to create zip file---", forKey: "8")
                    }
                }else{
                    let success = SSZipArchive.createZipFile(atPath: filePathToZip!, withContentsOfDirectory: newDirectory!)
                    if(success){
                        isGoahead = true
                        requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_END")
                        syncJSON.setValue("---Create Zip File End---", forKey: "4")
                    }else{
                        isGoahead = false
                        isGoaheadMessage = "Error creating zip"
                        syncJSON.setValue("---Failed to create zip file---", forKey: "8")
                    }
                }

                var fileData: NSData? = nil
                var fileData1:String  = ""
                do {
                    /******* HOME *******/

                    var fileSizeValue: UInt64 = 0
                    do {

                        let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: filePathToZip!)

                        if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                            fileSizeValue = UInt64(truncating: fileNumberSize)

                            let byteCountFormatter = ByteCountFormatter()
                            byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                            //print(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))

                            requestJSON.setValue(zipName, forKey: "CREATE_ZIP_FILE_NAME")
                            syncJSON.setValue("---Create ZIP File Name---/\(zipName)", forKey: "5")

                            requestJSON.setValue(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)), forKey: "CREATE_ZIP_SIZE")
                            syncJSON.setValue("---ZIP Size---/\(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))", forKey: "6")
                        }
                    } catch {
                        //print(error.localizedDescription)
                        syncJSON.setValue("---Failed to create zip file---", forKey: "8")
                    }

                    try fileData = NSData(contentsOfFile: filePathToZip!, options: NSData.ReadingOptions.mappedIfSafe)

                    fileData1 = fileData!.base64EncodedString(options: NSData.Base64EncodingOptions([]))
                    /*********************/
                    //print(fileData)
                    //print(fileData1)
                }
                catch _ as NSError {
                    //print("Ooops! Something went wrong renamefile: \(error)")
                    isGoahead = false
                    isGoaheadMessage = "error:104"
                    syncJSON.setValue("---Failed to create zip file---", forKey: "8")
                }

                //returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 11,MAX: 25))"]
                //NotificationCenter.default.post(name: notificationName, object: nil)
                self.updateProgress(type: 1, message: "progress", min: 11, max: 20)

                if(isGoahead){
                    requestJSON.setValue(Date().getJsonLogTime(), forKey: "UPLOAD_API_CALL_START")
                    syncJSON.setValue("---Upload API call start---", forKey: "7")

                    let web = urlUpload+uploadMethod

                    return UploadDatabaseFileZipOld(fileData1: fileData1, zipName: zipName, web: web, filePathTo: filePathTo!, fileManager: fileManager, databaseName: databaseName, action: "FileUpload",packageName:packageName)

                    /*let parameters = [
                        "FileArray": "\(fileData1)",
                        "FileName": "\(zipName).zip",
                        "DeviceId": "\(imei)","PersonId": "\(fk_EmpGlCode)","Version": "\(version)","SubModuleName": "\(ClientName)","APIToken": "\(userName)",
                    ]

                    //print(parameters)
                    self.startTimmerDetails(min: 25, max: 39)

                    self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)

                        .responseString { response in
                            //print("Success: \(response.result)")
                            //print(response.timeline)

                            switch response.result {
                            case .success(let jsonData):
                                //print("Success with JSON: \(jsonData)")

                                /**** comment temp to check file ******/
                                // delete sync directory
                                if fileManager.fileExists(atPath: filePathTo!) {
                                    //print("FILE AVAILABLE")
                                    //var error: NSError?
                                    do {
                                        try fileManager.removeItem(atPath: filePathTo!)
                                    } catch let error as NSError {
                                        NSLog("delete directory \(error.debugDescription)")
                                        //FIRCrashMessage("delete directory:error:5")
                                    }

                                    self.createDirSyncDb(documentsPath: self.documentsPath)
                                    //createDirectory(documentsPath: documentsPath)
                                }


                                //print(jsonData)
                                do{
                                    //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 26,MAX: 40))"]
                                    //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                    self.stopTimer()
                                    self.updateProgress(type: 1, message: "progress", min: 40, max: 40)

                                    let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData

                                    let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]

                                    let anyObj = JSON(json)
                                    print("responce")
                                    print(anyObj)


                                    //print("**********************")
                                    //print("*******SYNC RESPONSE********")
                                    //print("**********************")
                                    //print(anyObj)
                                    //print("**********************")
                                    //print("**********************")
                                    //print("**********************")

                                    var isValid:String = ""
                                    var Message:String = ""
                                    var Message1:String = ""

                                    if anyObj["Status"].exists(){

                                        //print("inside Status")

                                        //let list: Array<JSON> = anyObj["Status"].arrayValue

                                        /*isValid = list[0]["isValid"].stringValue
                                         Message = list[0]["Message"].stringValue*/

                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Response"].stringValue
                                        Message1 =  anyObj["Message"].stringValue

                                    }else{
                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Response"].stringValue
                                        Message1 =  anyObj["Message"].stringValue
                                    }

                                    if anyObj["SyncId"].exists(){
                                        self.SyncId = anyObj["SyncId"].intValue
                                    }

                                    if(isValid.lowercased() == "1"){
                                        //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 41,MAX: 45))"]
                                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                        self.updateProgress(type: 1, message: "progress", min: 41, max: 41)
                                        if (self.isConnectedToNetwork() == true ){
                                            self.startTimmerDetails(min: 41, max: 55)
                                            self.downloadFile(urlStr: Message,zipFileName: "\(zipName).zip",databaseName: databaseName,Message: Message1)
                                        }else{
                                            isGoaheadMessage = "NO_INTERNET"
                                            //self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                            //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                        }
                                    }else{


                                        isGoaheadMessage = "server error:!, please try again \(anyObj)";
                                        //self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                    }
                                }catch{
                                    isGoaheadMessage = "server error:@, please try again \(jsonData)";
                                    //self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                    //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }



                            case .failure(let error):
                                //print("Request failed with error: \(error)")

                                let message = "# Oops something went wrong, please try again \(error)"
                                isGoaheadMessage = message;
                                //self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                            }
                    }

                    return isGoaheadMessage
                    */

                }else{
                    //returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                    //NotificationCenter.default.post(name: notificationName, object: nil)
                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                    return isGoaheadMessage
                }
            }else{
                //returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                //NotificationCenter.default.post(name: notificationName, object: nil)
                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                return isGoaheadMessage
            }
        }else{
            //returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
            //NotificationCenter.default.post(name: notificationName, object: nil)
            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
            return isGoaheadMessage
        }
    }

    func requestJSONInString() -> String{
        let jsonData: NSData
        do {
            jsonData = try JSONSerialization.data(withJSONObject: requestJSON, options: JSONSerialization.WritingOptions()) as NSData
            return NSString(data: jsonData as Data, encoding: String.Encoding.utf8.rawValue)! as String
        } catch _ {
            print ("JSON Failure")
        }

        return ""
    }

    func syncJSONInString() -> String{
        let jsonData: NSData
        do {
            jsonData = try JSONSerialization.data(withJSONObject: syncJSON, options: JSONSerialization.WritingOptions()) as NSData
            return NSString(data: jsonData as Data, encoding: String.Encoding.utf8.rawValue)! as String
        } catch _ {
            print ("JSON Failure")
        }

        return ""
    }

    var isProgressFirstTime:Bool = false
    var isCheckDownloadFirstTime:Bool = false
    
    func UploadDatabaseFileZipOld(fileData1: String, zipName:String, web:String, filePathTo:String, fileManager:FileManager, databaseName:String, action:String,packageName:String) -> String{

        var isGoaheadMessage:String = "Done"

        syncJSON.setValue("---Convert DB File---", forKey: "12")

        var parameters = [String: String]()
        var headers = HTTPHeaders()
        
//         if(packageName == "com.ecubix.iffcocpm"){
        if(packageName == "com.vcs.iffcocpm"){
            parameters = [
                "FileArray": "\(action == "Process" || action == "CHECK_DOWNLOAD" ? "" : "\(fileData1)")",
                               "FileName": "\(zipName).zip",
                               "DeviceId": "\(imei)",
                               "PersonId": "\(fk_EmpGlCode)",
                               "Version": "\(version)",
                               "SubModuleName": "\(ClientName)",
                               "APIToken": "\(userName)",
                
                "ZipPassword": "",
                "CustomerId": "\(CustomerId)",
                "DeviceSyncStatus": "\(DeviceSyncStatus)",
                "CustomerCode": "\(CustomerCode)",
                "SystemName": "\(SystemName)",
                "LastSyncDate": "\(LastSyncDate)",
                "ServerSyncId": "\(ServerSyncId)",
                
                 "Action": "\(action)",
                               "JsonData": "{\"Sync_Log\":[\"\(requestJSONInString())\"]}",
                               "ExtraFields": "",
                               "SyncId": "\(action == "Process" || action == "CHECK_DOWNLOAD" ? "\(self.SyncId)" : "")",
            ]
            
            headers = [
                  "X-ApiKey": "i3BalYxQL",
                  "Content-Type": "application/x-www-form-urlencoded"
              ]
        } else {
            parameters = [
                "FileArray": "\(action == "Process" || action == "CHECK_DOWNLOAD" ? "" : "\(fileData1)")",
                "FileName": "\(zipName).zip",
                "DeviceId": "\(imei)",
                "PersonId": "\(fk_EmpGlCode)",
                "Version": "\(version)",
                "SubModuleName": "\(ClientName)",
                "APIToken": "\(userName)",

                "Action": "\(action)",
                "JsonData": "{\"Sync_Log\":[\"\(requestJSONInString())\"]}",
                "ExtraFields": "",
                "SyncId": "\(action == "Process" || action == "CHECK_DOWNLOAD" ? "\(self.SyncId)" : "")",
            ]
        
        }

        if(action == "Process"){
            print(parameters)
        }

        let configuration = URLSessionConfiguration.default
        var timeout: Double = 1800000
        
        if(action == "Process" || action == "CHECK_DOWNLOAD"){
            if(action == "Process"){
                if(!isProgressFirstTime){
                    isProgressFirstTime=true;
                self.startTimmerDetails(min: 35, max: 45)
                }
            } else if(action == "CHECK_DOWNLOAD"){
                if(!isCheckDownloadFirstTime){
                    isCheckDownloadFirstTime=true;
                self.startTimmerDetails(min: 45, max: 60)
                }
            }
//            timeout = 120
        }else{
            self.startTimmerDetails(min: 21, max: 34)
        }
        
        configuration.timeoutIntervalForRequest = timeout
        configuration.timeoutIntervalForResource = timeout // seconds
        alamofireManager = Alamofire.Session(configuration: configuration)
       
        self.alamofireManager!.request(web, method: .post, parameters: parameters,headers: headers).validate(statusCode: 200..<300)

            .responseString {

                response in
                switch response.result {
                case .success(let jsonData):

                    if fileManager.fileExists(atPath: filePathTo) {
                        do {
                            try fileManager.removeItem(atPath: filePathTo)
                        } catch let error as NSError {
                            NSLog("delete directory \(error.debugDescription)")
                        }

                        self.createDirSyncDb(documentsPath: self.documentsPath)
                    }

                    do{
//                        self.stopTimer()z
//                        if(action == "Process"){
//                            self.updateProgress(type: 1, message: "progress", min: 45, max: 45)
//                        } else if(action == "CHECK_DOWNLOAD"){
//                            self.updateProgress(type: 1, message: "progress", min: 60, max: 60)
//                        } else{
//                            self.updateProgress(type: 1, message: "progress", min: 35, max: 35)
//                        }

                        let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData

                        let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]

                        let anyObj = JSON(json)
                        print("responce")
                        print(anyObj)

                        var isValid:String = ""
                        var Message:String = ""
                        var Message1:String = ""

                        if anyObj["Status"].exists(){
                            isValid =  anyObj["Status"].stringValue
                            Message =  anyObj["Response"].stringValue
                            Message1 =  anyObj["Message"].stringValue
                        }else{
                            isValid =  anyObj["Status"].stringValue
                            Message =  anyObj["Response"].stringValue
                            Message1 =  anyObj["Message"].stringValue
                        }

                        if anyObj["SyncId"].exists(){
                            self.SyncId = anyObj["SyncId"].intValue
                        }

                        if(isValid.lowercased() == "1"){

                            if(action == "Process" || action == "CHECK_DOWNLOAD"){
                                self.stopTimer()
                                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "PROCESS_API_CALL_END")
                                self.syncJSON.setValue("---Process API Call End---", forKey: "16")

                                //self.updateProgress(type: 1, message: "progress", min: 41, max: 41)
                                if (self.isConnectedToNetwork() == true ){
                                    
                                    self.startTimmerDetails(min: 61, max: 65)
                                    self.downloadFile(urlStr: Message,zipFileName: "\(zipName).zip",databaseName: databaseName,Message: Message1)
                                }else{
                                    isGoaheadMessage = "NO_INTERNET"
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }
                            }else{
                                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "UPLOAD_API_CALL_END")
                                self.syncJSON.setValue("---Upload API Call End---", forKey: "17")

                                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "PROCESS_API_CALL_START")
                                self.syncJSON.setValue("---Process API Call Start---", forKey: "18")

                                self.UploadDatabaseFileZipOld(fileData1: fileData1, zipName: zipName, web: web, filePathTo: filePathTo, fileManager: fileManager, databaseName: databaseName, action: "Process",packageName: packageName)


                            }
                        } else if(isValid.lowercased() == "3" && action == "CHECK_DOWNLOAD"){
                            do {
                                sleep(120)
                                self.UploadDatabaseFileZipOld(fileData1: fileData1, zipName: zipName, web: web, filePathTo: filePathTo, fileManager: fileManager, databaseName: databaseName, action: "CHECK_DOWNLOAD",packageName: packageName)
                            }
                        }else{
                            isGoaheadMessage = "server error:!, please try again \(anyObj)";
                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                            self.syncJSON.setValue("---Response Error---\(anyObj)", forKey: "19")
                        }
                    }catch{
                        isGoaheadMessage = "server error:@, please try again \(jsonData)";
                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        self.syncJSON.setValue("---Exception Error---\(jsonData)", forKey: "22")
                    }

                case .failure(let error):
                    switch error {
                            case .sessionTaskFailed(URLError.timedOut):
                                print("Request timeout!")
                                if(action == "Process" || action == "CHECK_DOWNLOAD") {
                                    self.UploadDatabaseFileZipOld(fileData1: fileData1, zipName: zipName, web: web, filePathTo: filePathTo, fileManager: fileManager, databaseName: databaseName, action: "CHECK_DOWNLOAD",packageName: packageName)
                                }
                            default:
                                print("Other error!")
                                let message = "# Oops something went wrong, please try again \(error)"
                                isGoaheadMessage = message;
                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                self.syncJSON.setValue("---API CALL FAIL---\(error)", forKey: "20")

                                let httpStatusCode = response.response?.statusCode
                                self.syncJSON.setValue("---Response Status Not Getting 200---\(String(describing: httpStatusCode))", forKey: "21")
                            }
                    
//                    if AFError.sessionTaskFailed(error: URLError.timedOut as! Error) {
//
//                    } else {
//                       // print("====RESPONSE CODE :: \(String(describing: error.inv))");
//
//                    }
                }
        }
        return isGoaheadMessage
    }

    func SyncDataForLAB(userName:String,fk_EmpGlCode:String,ClientName:String,version:String,imei:String,uploadMethod:String,urlUpload:String,databaseName:String, dbPassword:String, isDbEncripted:String)->String{

        self.userName=userName;
        self.fk_EmpGlCode=fk_EmpGlCode;
        self.ClientName=ClientName;
        self.version=version;
        self.imei=imei;
        self.uploadMethod=uploadMethod;
        self.logUploadMethod=urlUpload;
        self.urlUpload=urlUpload;

        print("*****************")
        print(logUploadMethod)
        print(uploadMethod)

        //returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 1,MAX: 5))"]
        //NotificationCenter.default.post(name: notificationName, object: nil)
        self.updateProgress(type: 1, message: "progress", min: 1, max: 5)

        var isGoahead:Bool = true
        var isGoaheadMessage:String = ""

        let date = Date()
        let calendar = Calendar.current

        let year = calendar.component(.year, from: date)
        let month = calendar.component(.month, from: date)
        let day = calendar.component(.day, from: date)

        let hour = calendar.component(.hour, from: date)
        let minute = calendar.component(.minute, from: date)
        let second = calendar.component(.second, from: date)

        let dirName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"

        let fileName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"
        let zipName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_BASF-LAB-Database"
        self.zipNameFinal = zipName
        // App database path
        let filePathFrom = documentsPath.appendingPathComponent(databaseName)?.path
        let filePathTo = documentsPath.appendingPathComponent("SyncDatabase")?.path
        let filePathTo1 = documentsPath.appendingPathComponent("SyncDatabase/\(databaseName)")?.path
        let filePathTo2 = documentsPath.appendingPathComponent("SyncDatabase/\(fileName)")?.path
        let fileManager = FileManager.default

        //createDirSyncDb(documentsPath)

        if fileManager.fileExists(atPath: filePathTo!) {
            do {
                try fileManager.removeItem(atPath: filePathTo!)
            } catch let error as NSError {
                NSLog("delete directory \(error.debugDescription)")
                isGoahead = false;
                isGoaheadMessage = "error:101";

            }
            createDirSyncDb(documentsPath: documentsPath)
        } else {
            createDirSyncDb(documentsPath: documentsPath)
        }

        if(isGoahead){
            if fileManager.fileExists(atPath: filePathTo1!) {
                //print("filePathTo1 exist")
            }
            if fileManager.fileExists(atPath: filePathTo2!) {
                //print("filePathTo2 exist")
            }
            //databaseName = "BASF-HK-Database"
            let filePathToZip = documentsPath.appendingPathComponent("SyncDatabase/\(zipName).zip")?.path

            let newDirectory = documentsPath.appendingPathComponent("SyncDatabase/\(dirName)")?.path

            let newDirectory1 = documentsPath.appendingPathComponent("SyncDatabase/\(dirName)/\(fileName)")?.path

            do {
                try fileManager.createDirectory(atPath: newDirectory!, withIntermediateDirectories: false, attributes: nil)
            } catch let error as NSError {
                isGoahead = false;
                isGoaheadMessage = "error:103 \(error)";
            }

            //copy from SyncDatabase to document
            if fileManager.fileExists(atPath: filePathFrom!) {
                do {
                    try fileManager.copyItem(atPath: filePathFrom!, toPath: newDirectory1!)
                } catch let error as NSError {
                    NSLog("Unable to copy file \(error.debugDescription)")
                    //print("Ooops! Something went wrong copyItem: \(error)")
                    isGoahead = false;
                    isGoaheadMessage = "error:103";
                }
            }

            self.updateProgress(type: 1, message: "progress", min: 6, max: 10)

            if(isGoahead){

                if(isDbEncripted == "true"){
                    let success = SSZipArchive.createZipFile(atPath: filePathToZip!,
                                                             withContentsOfDirectory: newDirectory!,
                                                             keepParentDirectory: false,
                                                             compressionLevel: 5,
                                                             password: ZipPassword,
                                                             aes: true,
                                                             progressHandler: nil)
                    if(success){
                        isGoahead = true
                    }else{
                        isGoahead = false
                        isGoaheadMessage = "Error creating zip"
                    }
                }else{
                    let success = SSZipArchive.createZipFile(atPath: filePathToZip!, withContentsOfDirectory: newDirectory!)
                    if(success){
                        isGoahead = true
                    }else{
                        isGoahead = false
                        isGoaheadMessage = "Error creating zip"
                    }
                }

                var fileData: NSData? = nil
                var fileData1:String  = ""
                do {
                    var fileSizeValue: UInt64 = 0
                    do {

                        let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: filePathToZip!)

                        if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                            fileSizeValue = UInt64(fileNumberSize)

                            let byteCountFormatter = ByteCountFormatter()
                            byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                            //print(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))

                        }

                    } catch {
                        //print(error.localizedDescription)
                    }

                    try fileData = NSData(contentsOfFile: filePathToZip!, options: NSData.ReadingOptions.mappedIfSafe)

                    fileData1 = fileData!.base64EncodedString(options: NSData.Base64EncodingOptions([]))
                }
                catch let error as NSError {
                    isGoahead = false;
                    isGoaheadMessage = "error:104";
                }
                self.updateProgress(type: 1, message: "progress", min: 11, max: 25)

                if(isGoahead){
                    let web = urlUpload+uploadMethod
                    let parameters = [
                        "FileArray": "\(fileData1)",
                        "FileName": "\(zipName).zip",
                        "DeviceId": "\(imei)","PersonId": "\(fk_EmpGlCode)","Version": "\(version)","SubModuleName": "\(ClientName)","APIToken": "\(userName)",
                    ]

                    //print(parameters)
                    self.startTimmerDetails(min: 25, max: 39)

                    self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)

                        .responseString { response in

                            switch response.result {
                            case .success(let jsonData):
                                if fileManager.fileExists(atPath: filePathTo!) {
                                    do {
                                        try fileManager.removeItem(atPath: filePathTo!)
                                    } catch let error as NSError {
                                        NSLog("delete directory \(error.debugDescription)")
                                    }

                                    self.createDirSyncDb(documentsPath: self.documentsPath)
                                }


                                do{
                                    self.stopTimer()
                                    self.updateProgress(type: 1, message: "progress", min: 40, max: 40)

                                    let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData

                                    let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]

                                    let anyObj = JSON(json)
                                    print("responce")
                                    print(anyObj)

                                    var isValid:String = ""
                                    var Message:String = ""
                                    var Message1:String = ""

                                    if anyObj["Status"].exists(){
                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Response"].stringValue
                                        Message1 =  anyObj["Message"].stringValue

                                    }else{
                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Response"].stringValue
                                        Message1 =  anyObj["Message"].stringValue
                                    }

                                    if anyObj["SyncId"].exists(){
                                        self.SyncId = anyObj["SyncId"].intValue
                                    }

                                    if(isValid.lowercased() == "1"){
                                        self.updateProgress(type: 1, message: "progress", min: 41, max: 41)
                                        if (self.isConnectedToNetwork() == true ){
                                            self.startTimmerDetails(min: 41, max: 55)
                                            self.downloadFile(urlStr: Message,zipFileName: "\(zipName).zip",databaseName: databaseName,Message: Message1)
                                        }else{
                                            isGoaheadMessage = "NO_INTERNET"
                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                        }
                                    }else{
                                        isGoaheadMessage = "server error:!, please try again \(anyObj)";
                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                    }
                                }catch{
                                    isGoaheadMessage = "server error:@, please try again \(jsonData)";
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }



                            case .failure(let error):
                                let message = "# Oops something went wrong, please try again \(error)"
                                isGoaheadMessage = message;
                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                            }
                    }

                    return isGoaheadMessage

                }else{
                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                    return isGoaheadMessage
                }
            }else{
                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                return isGoaheadMessage
            }
        }else{
            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
            return isGoaheadMessage
        }
    }

    func downloadFile(urlStr:String, zipFileName:String,databaseName:String,Message:String){

        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "HH:mm:ss"



        /*let destination: DownloadRequest.Options = { _, _ in
            let documentsURL = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask)[0]
            let fileURL = documentsURL.appendingPathComponent("SyncDatabase/Download/\(zipFileName)")

            return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
        }*/

        let destination: DownloadRequest.Destination = { _, _ in
            let documentsURL = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask)[0]
            let fileURL = documentsURL.appendingPathComponent("SyncDatabase/Download/\(zipFileName)")

            return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
        }

        self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "DOWNLOAD_START")
        self.syncJSON.setValue("---Download DB Start---", forKey: "23")

        AF.download(urlStr, to: destination).response { response in
            //print(response)

            //if response.error == nil, let imagePath = response.destinationURL?.path {
          if response.error == nil, let imagePath = response.fileURL?.path {
                //let image = UIImage(contentsOfFile: imagePath)

                //print(imagePath)
                //end - diff
                //let dateFormatter = DateFormatter()
                //dateFormatter.dateFormat = "HH:mm:ss"
                //let diff = self.getDiffTime(time2: Date())
                //self.data_createJson.setValue("\(diff)", forKey: "9_DOWNLOAD_END")

                //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 46,MAX: 60))"]
                //NotificationCenter.default.post(name: self.notificationName, object: nil)
                self.stopTimer()
                self.updateProgress(type: 1, message: "progress", min: 65, max: 68)

                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "DOWNLOAD_END")
                self.syncJSON.setValue("---Download DB End---", forKey: "24")


                var fileSizeValue: UInt64 = 0

                do {
                    let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: imagePath)

                    if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                        fileSizeValue = UInt64(fileNumberSize)

                        //let byteCountFormatter = ByteCountFormatter()
                        //byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                        //print(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))

                        //self.data_createJson.setValue("\(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))", forKey: "9_DOWNLOAD_FILE_SIZE")
                    }
                } catch {
                    print(error.localizedDescription)
                    self.syncJSON.setValue("---9_DOWNLOAD_END_FAIL---\(error.localizedDescription)", forKey: "36")
                }

                self.unzipDirectory(unZipFile: zipFileName,databaseName: databaseName,Message: Message)

            }else{
                self.syncJSON.setValue("---6_DOWNLOAD_END_FAIL---", forKey: "37")
            }
        }
    }

    func unzipDirectory(unZipFile:String,databaseName:String,Message:String){
        // unzip & copy

        DispatchQueue.main.async {

            //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 61,MAX: 74))"]
            //NotificationCenter.default.post(name: self.notificationName, object: nil)
            self.updateProgress(type: 1, message: "progress", min: 69, max: 73)

            self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "IMPORT_FILE_START")
            self.syncJSON.setValue("---Import File Start---", forKey: "25")

            let fileManager = FileManager.default

            let documentsPath = NSURL(fileURLWithPath: NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true)[0])
            let filePathToZip = documentsPath.appendingPathComponent("SyncDatabase/Download/\(unZipFile)")?.path
            let filePathfromZip = documentsPath.appendingPathComponent("SyncDatabase")?.path
            //let oldDBName = documentsPath.appendingPathComponent("SyncDatabase/\(self.zipNameFinal.lowercased()).db")?.path
            let oldDBName = documentsPath.appendingPathComponent("SyncDatabase/\(self.zipNameFinal).db")?.path
            let newDBName = documentsPath.appendingPathComponent("SyncDatabase/\(databaseName)")?.path

            let documentDBName = documentsPath.appendingPathComponent("\(databaseName)")?.path

            //print("********************")
            //print(filePathToZip)
            //print(filePathfromZip)
            //print(oldDBName)
            //print(newDBName)
            //print(documentDBName)
            //print("********************")


            //print("1 --> \(filePathToZip)")
            // print("2 --> \(filePathfromZip)")
            var fileUnZip:Bool = false
            var s:Bool = false

            self.syncJSON.setValue("---Unzip File Start---", forKey: "26")

            let success = SSZipArchive.isFilePasswordProtected(atPath: filePathToZip!)
            if success {
                print("Yes, it's password protected.")
                //info.text = "Yes, it's password protected."

                s   = SSZipArchive.unzipFile(atPath: filePathToZip!,
                                             toDestination: filePathfromZip!,
                                             preserveAttributes: true,
                                             overwrite: true,
                                             nestedZipLevel: 1,
                                             password: self.ZipPassword,
                                             error: nil,
                                             delegate: nil,
                                             progressHandler: nil,
                                             completionHandler: nil)
            } else {
                print("No, it's not password protected.")
                //info.text = "No, it's not password protected."
                s =  SSZipArchive.unzipFile(atPath: filePathToZip!, toDestination: filePathfromZip!)
            }



            //let s:Bool =  SSZipArchive.unzipFile(atPath: filePathToZip!, toDestination: filePathfromZip!)
            if(s){
                fileUnZip = true
                print("unzip zip file")
                 self.syncJSON.setValue("---Unzip File END---", forKey: "27")
            }else{
                fileUnZip = false
                print("not unzip zip file")
                self.syncJSON.setValue("---Unzip File FAILED---", forKey: "28")
            }

            //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 75,MAX: 84))"]
            //NotificationCenter.default.post(name: self.notificationName, object: nil)
            self.updateProgress(type: 1, message: "progress", min: 74, max: 80)

            if(fileUnZip){
                // rename file
                //print("3 --> \(oldDBName)")
                //print("4 --> \(newDBName)")

                //print("oldDBName:\(oldDBName)")
                //print("newDBName:\(newDBName)")
                //print("documentDBName:\(documentDBName)")

                if fileManager.fileExists(atPath: oldDBName!) {

                    do {
                        try fileManager.moveItem(atPath: oldDBName!, toPath: newDBName!)
                    }
                    catch let error as NSError {
                        //print("Ooops! Something went wrong renamefile: \(error)")
                        //self.data_createJson.setValue("error", forKey: "RESTORE_DB_END_FAIL_10")
                        //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 1 \(error)","progress": "0"]
                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                        self.updateProgress(type: 2, message: "Ooops! Something went wrong 1", min: 0, max: 0)
                    }
                }

                if fileManager.fileExists(atPath: documentDBName!) {
                    do {
                        try fileManager.removeItem(atPath: documentDBName!)
                    } catch let error as NSError {
                        //print("error delete file \(error.debugDescription)")
                        //self.data_createJson.setValue("error", forKey: "RESTORE_DB_END_FAIL_10")
                        //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 2 \(error)","progress": "0"]
                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                        self.updateProgress(type: 2, message: "Ooops! Something went wrong 2", min: 0, max: 0)
                        self.syncJSON.setValue("---Move Item Failed---", forKey: "29")
                    }
                }

                self.updateProgress(type: 1, message: "progress", min: 81, max: 83)

                //print("5 --> \(newDBName)")
                //print("6 --> \(documentDBName)")

                //copy from SyncDatabase to document

                if fileManager.fileExists(atPath: newDBName!) {
                    do {
                        //restor starts
                        let dateFormatter = DateFormatter()
                        dateFormatter.dateFormat = "HH:mm:ss"


                        /*if fileManager.fileExists(atPath: newDBName!) {

                            //print(newDBName)
                        }

                        //print(documentDBName)

                        if fileManager.fileExists(atPath: documentDBName!) {

                            //print(documentDBName)
                        }*/


                        try fileManager.copyItem(atPath: newDBName!, toPath: documentDBName!)
                    } catch let error as NSError {
                        NSLog("Unable to copy file \(error.debugDescription)")
                        //self.data_createJson.setValue("error)", forKey: "10_RESTORE_DB_END_FAIL")
                        //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 3","progress": "0"]
                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                        self.updateProgress(type: 2, message: "Ooops! Something went wrong 3", min: 0, max: 0)
                        self.syncJSON.setValue("---Copy File Failed---", forKey: "30")
                    }
                }else{
                    //print("newDBName:\(newDBName)")

                    //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 4","progress": "0"]
                    //NotificationCenter.default.post(name: self.notificationName, object: nil)
                    self.updateProgress(type: 2, message: "Ooops! Something went wrong 4", min: 0, max: 0)
                }

                //sleep(200)

                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "IMPORT_FILE_END")
                self.syncJSON.setValue("---Import File End---", forKey: "31")


                let filePathTo = documentsPath.appendingPathComponent("SyncDatabase")?.path
                // delete sync directory
                if fileManager.fileExists(atPath: filePathTo!) {
                    //print("FILE AVAILABLE")
                    //var error: NSError?
                    do {
                        try fileManager.removeItem(atPath: filePathTo!)
                    } catch let error as NSError {
                        NSLog("delete directory \(error.debugDescription)")
                        //self.data_createJson.setValue("error", forKey: "10_RESTORE_DB_END_FAIL")
                        //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 5","progress": "0"]
                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                        self.updateProgress(type: 2, message: "Ooops! Something went wrong 5", min: 0, max: 0)
                    }

                    //self.createDirectory(documentsPath)
                }



                //sleep(10)

                //DispatchQueue.main.async {
                //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 85,MAX: 97))"]
                //NotificationCenter.default.post(name: self.notificationName, object: nil)
                self.updateProgress(type: 1, message: "progress", min: 85, max: 97)
                // }

                //s//leep(1)

                //self.callUpload(urlUpload: self.urlUpload, logUploadMethod: self.logUploadMethod, fk_EmpGlCode: self.fk_EmpGlCode, SyncId: self.SyncId, DeviceSyncStatus: "Y", DeviceSyncJson: "Y", ClientName: self.ClientName, imei: self.imei, version: self.version, userName: self.userName)

                // DispatchQueue.main.async {
                //self.returnItems = ["type": "3","Details": "Sync Successfully Done","progress": "100"]
                //NotificationCenter.default.post(name: self.notificationName, object: nil)
                // }
                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "SYNC_END")
                self.syncJSON.setValue("---Sync End---", forKey: "32")

                self.updateProgress(type: 3, message: Message, min: 100, max: 100)


                //dispatch_async(dispatch_get_main_queue()) {

                //self.currentDateDB = ECP_Constant.checkFlagLableMaser("SYNCDATE");

                //self.isAllowCheck = ECP_Constant.checkFlagLableMaserBool("CheckReviewOnVisit");



                /*let date = Date()
                 let calendar = Calendar.current

                 let year = calendar.component(.year, from: date)
                 let month = calendar.component(.month, from: date)
                 let day = calendar.component(.day, from: date)

                 let hour = calendar.component(.hour, from: date)
                 let minute = calendar.component(.minute, from: date)
                 let second = calendar.component(.second, from: date)

                 self.isallowflag = self.checkDate(isFirst: false)

                 let defaults = UserDefaults.standard
                 defaults.set(NSDate(), forKey: ECP_Constant.VAR_LAST_SYNC_TIME_DATE);*/

                //ECP_Constant.IS_VALID_LOGIN)

                /* var i:Int = 0
                 while (i<10000) {
                 i = i + 1
                 }*/

                //sleep(500)

                //end
                // let dateFormatter = DateFormatter()
                // dateFormatter.dateFormat = "HH:mm:ss"

                //let diff = self.getDiffTime(time2: Date())

                //self.data_createJson.setValue("\(diff)", forKey: "11_RESTORE_DB_END")

                //let diff2 = self.getEndTimeDiff(time2: timeStart)
                //self.data_createJson.setValue("\(diff2)", forKey: "12_END")

                //self.MessageLastSync(msg: "Sync Successfully Done")
                //let varLastSyncTime:String = "\(day)/\(month)/\(year) \(hour):\(DBAdapter.addZero(value: minute)):\(second)"
                //let defaults = NSUserDefaults.standardUserDefaults()
                //defaults.setValue(varLastSyncTime, forKey: ECP_Constant.VAR_LAST_SYNC_TIME)
                //self.setSyncTime()
                //self.getModuleList()
                //}
            }else{
                //dispatch_async(dispatch_get_main_queue()) {
                //self.showAlertMessageSync(messageM: "Ooops! Something went wrong")
                //}

                //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong","progress": "0"]
                //NotificationCenter.default.post(name: self.notificationName, object: nil)
                self.updateProgress(type: 2, message: "Ooops! Something went wrong", min: 0, max: 0)
            }
        }
    }

    func randomNumber(MIN: Int, MAX: Int)-> Int{
        return Int(arc4random_uniform(UInt32(MAX-MIN)) + UInt32(MIN));
    }

    func createDirSyncDb(documentsPath:NSURL){
        let logsPath = documentsPath.appendingPathComponent("SyncDatabase")
        do {
            try FileManager.default.createDirectory(atPath: logsPath!.path, withIntermediateDirectories: true, attributes: nil)
        } catch let error as NSError {
            NSLog("Unable to create directory \(error.debugDescription)")
        }
    }

    func createDir(path:NSURL){
        do {
            try FileManager.default.createDirectory(atPath: path.path!, withIntermediateDirectories: true, attributes: nil)
        } catch let error as NSError {
            NSLog("Unable to create directory \(error.debugDescription)")
        }
    }

    func deleteDir(path:NSURL) -> Bool{
        if FileManager.default.fileExists(atPath: path.path!){
            do {
                try FileManager.default.removeItem(atPath: path.path!)
            } catch let error as NSError {
                NSLog("delete directory \(path) \(error.debugDescription)")
                return false
            }
        }
        return true
    }

    func deleteDirNew(path:NSURL) {
        if FileManager.default.fileExists(atPath: path.path!){
            do {
                try FileManager.default.removeItem(atPath: path.path!)
            } catch let error as NSError {
                NSLog("delete directory \(path) \(error.debugDescription)")
                //return false
            }
        }
        // return true
    }

    func isConnectedToNetwork() -> Bool {

        var zeroAddress = sockaddr_in(sin_len: 0, sin_family: 0, sin_port: 0, sin_addr: in_addr(s_addr: 0), sin_zero: (0, 0, 0, 0, 0, 0, 0, 0))
        zeroAddress.sin_len = UInt8(MemoryLayout.size(ofValue: zeroAddress))
        zeroAddress.sin_family = sa_family_t(AF_INET)

        let defaultRouteReachability = withUnsafePointer(to: &zeroAddress) {
            $0.withMemoryRebound(to: sockaddr.self, capacity: 1) {zeroSockAddress in
                SCNetworkReachabilityCreateWithAddress(nil, zeroSockAddress)
            }
        }

        var flags: SCNetworkReachabilityFlags = SCNetworkReachabilityFlags(rawValue: 0)
        if SCNetworkReachabilityGetFlags(defaultRouteReachability!, &flags) == false {
            return false
        }

        /* Only Working for WIFI
         let isReachable = flags == .reachable
         let needsConnection = flags == .connectionRequired

         return isReachable && !needsConnection
         */

        // Working for Cellular and WIFI
        let isReachable = (flags.rawValue & UInt32(kSCNetworkFlagsReachable)) != 0
        let needsConnection = (flags.rawValue & UInt32(kSCNetworkFlagsConnectionRequired)) != 0
        let ret = (isReachable && !needsConnection)

        return ret

    }

    func getDeviceUniqueNo()->String{
            let udifstr = UIDevice.current.identifierForVendor!.uuidString
            let mili:Int64 = getCurrentMillis()
            let rand:Int64 = getRandomNumber()
            let iint:Int = "\(mili)".count
            let iii = udifstr + "\(mili)" +  "\(iint)" + "\(rand)";
            //print(iii)
            return iii
    }

    func getCurrentMillis()->Int64 {
        return Int64(Date().timeIntervalSince1970 * 1000)
    }

    func getRandomNumber()->Int64 {
        let number = floor(Double(arc4random_uniform(1000) * 6000)) + 1000
        return Int64(number)
    }

    var timer: Timer?
    var mMin:Int = 0
    var mMax:Int = 0

    func startTimer() {

        if timer == nil {
            timer = Timer.scheduledTimer(timeInterval: 10, target: self, selector: #selector(self.loop), userInfo: nil, repeats: true)
        }
    }

    func stopTimer() {
        if timer != nil {
            timer?.invalidate()
            timer = nil
        }
    }

    func startTimmerDetails(min:Int,max:Int){
        stopTimer()
        mMin = min
        mMax = max
        startTimer()
    }

    @objc func loop() {
        if(mMin < mMax){
            mMin = mMin + 1
        }
        returnItems = ["type": "1","Details": "Update Progress Auto","progress": "\(mMin)"]
        NotificationCenter.default.post(name: notificationName, object: nil)
    }
}

/*extension Range
 {
 var randomInt: Int
 {
 get
 {
 var offset = 0

 if (startIndex as Int) < 0   // allow negative ranges
 {
 offset = abs(startIndex as Int)
 }

 let mini = UInt32(startIndex as Int + offset)
 let maxi = UInt32(endIndex   as Int + offset)

 return Int(mini + arc4random_uniform(maxi - mini)) - offset
 }
 }
 }*/

extension String {
    /*func aesEncrypt(key: String, iv: String) throws -> String{
        //let data = self.dataUsingEncoding(NSUTF8StringEncoding)
        let data1 = self.data(using: .utf8)
        let enc = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).encrypt(data1!.bytes)
        let encData = NSData(bytes: enc, length: Int(enc.count))
        let base64String: String = encData.base64EncodedString(options: NSData.Base64EncodingOptions(rawValue: 0));
        let result = String(base64String)
        return result
    }

    func aesDecrypt(key: String, iv: String) throws -> String {
        // let data1 = NSData(base64Encoded: self.data(using: .utf8)!, options: NSData.Base64DecodingOptions(rawValue: 0))
        let data1 = Data(base64Encoded: self)!
        let dec = try AES(key: key, iv: iv, blockMode:.CBC).decrypt(Array(data1))
        let decData = NSData(bytes: dec, length: Int(dec.count))
        let result = NSString(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
        return String(result!)
    }*/

    func aesEncrypt2(key:String, iv:String, options:Int = kCCOptionPKCS7Padding) -> String? {
        if let keyData = key.data(using: String.Encoding.utf8),
            let data = self.data(using: String.Encoding.utf8),
            let cryptData    = NSMutableData(length: Int((data.count)) + kCCBlockSizeAES128) {
            let keyLength              = size_t(kCCKeySizeAES128)
            let operation: CCOperation = UInt32(kCCEncrypt)
            let algoritm:  CCAlgorithm = UInt32(kCCAlgorithmAES128)
            let options:   CCOptions   = UInt32(options)

            var numBytesEncrypted :size_t = 0

            let cryptStatus = CCCrypt(operation,
                                      algoritm,
                                      options,
                                      (keyData as NSData).bytes, keyLength,
                                      iv,
                                      (data as NSData).bytes, data.count,
                                      cryptData.mutableBytes, cryptData.length,
                                      &numBytesEncrypted)

            if cryptStatus == kCCSuccess {
                cryptData.length = Int(numBytesEncrypted)
                let base64cryptString = cryptData.base64EncodedString(options: .lineLength64Characters)
                return base64cryptString
            }
            else {
                return nil
            }
        }
        return nil
    }

    func aesDecrypt2(key:String, iv:String, options:Int = kCCOptionPKCS7Padding) -> String? {
        if let keyData = key.data(using: String.Encoding.utf8),
            let data = NSData(base64Encoded: self, options: .ignoreUnknownCharacters),
            let cryptData    = NSMutableData(length: Int((data.length)) + kCCBlockSizeAES128) {

            let keyLength              = size_t(kCCKeySizeAES128)
            let operation: CCOperation = UInt32(kCCDecrypt)
            let algoritm:  CCAlgorithm = UInt32(kCCAlgorithmAES128)
            let options:   CCOptions   = UInt32(options)

            var numBytesEncrypted :size_t = 0

            let cryptStatus = CCCrypt(operation,
                                      algoritm,
                                      options,
                                      (keyData as NSData).bytes, keyLength,
                                      iv,
                                      data.bytes, data.length,
                                      cryptData.mutableBytes, cryptData.length,
                                      &numBytesEncrypted)

            if cryptStatus == kCCSuccess {
                cryptData.length = Int(numBytesEncrypted)
                let unencryptedMessage = String(data: cryptData as Data, encoding:String.Encoding.utf8)
                return unencryptedMessage
            }
            else {
                return nil
            }
        }
        return nil
    }

}

extension String {
    /*func aesEncrypt(key: String, iv: String) throws -> String{
     //let data = self.dataUsingEncoding(NSUTF8StringEncoding)
     let data1 = self.data(using: .utf8)
     let enc = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).encrypt(data1!.bytes)
     let encData = NSData(bytes: enc, length: Int(enc.count))
     let base64String: String = encData.base64EncodedString(options: NSData.Base64EncodingOptions(rawValue: 0));
     let result = String(base64String)
     return result
     }

     func aesDecrypt(key: String, iv: String) throws -> String {
     //let data1 = NSData(base64Encoded: self, options: NSData.Base64DecodingOptions(rawValue: 0))
     let data1 = Data(base64Encoded: self)!
     let dec = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).decrypt(Array(data1))
     let decData = NSData(bytes: dec, length: Int(dec.count))
     let result = NSString(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
     //let result = String(bytes: Data(decData).bytes, encoding: .utf8)
     print(decData)
     //let result =  String(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
     return String(result!)
     }*/

    /* let key = "B4V2A1C@S#S$F"
     let iv = "0000000000000000"
     let s = "Vcs@1234"
     let enc = try! s.aesEncrypt1(key: key, iv: iv)
     print(enc)

     do{
     let dec = try enc.aesDecrypt1(key: key, iv: iv)
     print("dec:\(dec)")
     print("\(s == dec)")

     }catch let error {
     print("error:\(error)")
     }*/

    func aesEncrypt1(key: String, iv: String) throws -> String {


        let pwdBytes = [UInt8](key.utf8)
        var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
        var len = pwdBytes.count
        if(len > keyBytes.count){
            len = keyBytes.count
            //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
        }

        var i:Int = 0
        while(i < len){
            keyBytes[i] = pwdBytes[i]
            i = i + 1
        }

        let key1 = keyBytes
        let iv1 = keyBytes

        //let encrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).encrypt([UInt8](self.data(using: .utf8)!))

        let encrypted = try AES(key: [UInt8](key1), blockMode: CBC(iv: [UInt8](iv1)), padding: .pkcs7).encrypt([UInt8](self.data(using: .utf8)!))

        return Data(encrypted).base64EncodedString()
    }

    func aesDecrypt1(key: String, iv: String) throws -> String {

        let pwdBytes = [UInt8](key.utf8)
        var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
        var len = pwdBytes.count
        if(len > keyBytes.count){
            len = keyBytes.count
            //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
        }

        var i:Int = 0
        while(i < len){
            keyBytes[i] = pwdBytes[i]
            i = i + 1
        }

        let key1 = keyBytes
        let iv1 = keyBytes

        guard let data = Data(base64Encoded: self) else { return "" }
        let decrypted = try AES(key: [UInt8](key1), blockMode: CBC(iv: [UInt8](iv1)), padding: .pkcs5).decrypt([UInt8](data))
        //let decrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).decrypt([UInt8](data))
        return String(bytes: Data(decrypted).bytes, encoding: .utf8) ?? "Could not decrypt"
    }

}

extension String {

    func toDate() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }

    func toServerDateUTC() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "UTC") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }

    func toEntryDDate() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }

    func toEntryDDateUTC1() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "UTC") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }


    func toConvertTimeAMPM() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.locale = Locale(identifier: "en_US_POSIX")

        //        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date = dateFormatter.date(from: self)

        let dateFormatter1 = DateFormatter()
        dateFormatter1.dateFormat = "hh:mm:ss a" //Your date format
        dateFormatter1.locale = Locale(identifier: "en_US_POSIX")

        //        dateFormatter1.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date2 = dateFormatter1.string(from: date!)

        return date2
    }

    //    func toShowTimeAMPM() -> String {
    //        let dateFormatter1 = DateFormatter()
    //        dateFormatter1.dateFormat = "hh:mm:ss a" //Your date format
    //        dateFormatter1.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
    //        let date2 = dateFormatter1.string(from: dateFormatter1.date(from: self)!)
    //
    //        return date2
    //    }


    func replace(target: String, withString: String) -> String
    {
        return self.replacingOccurrences(of: target, with: withString, options: NSString.CompareOptions.literal, range: nil)
    }
}

extension Date {

    func monthsFromDate(from date: Date) -> Int {
        return Calendar.current.dateComponents([.month], from: date, to: self).month ?? 0
    }

    func toDayNameString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "EEEE"
        let str = dateFormatter.string(from: self)
        let index = str.index(str.startIndex, offsetBy: 3)
        return str.substring(to: index)
        //return String(str[index])
        //return mySubstring
    }

    func toDayString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "EEEE"
        return dateFormatter.string(from: self)
    }

    func toPlanStringGMT() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd"
        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone

        return dateFormatter.string(from: self)
    }

    func toPlanString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd"
        return dateFormatter.string(from: self)
    }

    func toPlanShowMonthString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "dd-MMM-yyyy"
        return dateFormatter.string(from: self)
    }

    func toShowTimeAMPM() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "hh:mm a"
        return dateFormatter.string(from: self)
    }

    func toTime24Hours() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "HH:mm"
        return dateFormatter.string(from: self)
    }

    func toPlanShowString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "dd-MM-yyyy"
        return dateFormatter.string(from: self)
    }

    func toEntryDate() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
        return dateFormatter.string(from: self)
    }

    func toMyFormatDate(format:String) -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = format
        return dateFormatter.string(from: self)
    }

    func toEntryTime() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "HH:mm:ss"
        dateFormatter.locale = Locale(identifier: "en_US_POSIX")

        return dateFormatter.string(from: self)
    }

    func toMonth() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.month, from: self)
        return month
    }

    func toDay() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.day, from: self)
        return month
    }

    func toHour() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.hour, from: self)
        return month
    }

    func toMinute() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.minute, from: self)
        return month
    }

    //let dateFormatter = DateFormatter()
    //dateFormatter.dateFormat = "MMM-YYYY"

    func toMonthYearString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "MMM-YYYY"
        return dateFormatter.string(from: self)
    }

    func toFullMonthYearString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "MMMM-YYYY"
        return dateFormatter.string(from: self)
    }

    func toFullYearString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "YYYY"
        return dateFormatter.string(from: self)
    }

    func toMonthString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "MMMM"
        return dateFormatter.string(from: self)
    }

    func toYear() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.year, from: self)
        return month
    }

    func addRemoveYear(month1:Int)->Date{
        return Calendar.current.date(byAdding: .year, value: month1, to: self)!
    }

    func addRemoveMonth(month1:Int)->Date{
        return Calendar.current.date(byAdding: .month, value: month1, to: self)!
    }

    func addRemoveDay(month1:Int)->Date{
        return Calendar.current.date(byAdding: .day, value: month1, to: self)!
    }


    /*func startOfMonth() -> Date {
     return Calendar.current.date(from: Calendar.current.dateComponents([.year, .month], from: Calendar.current.startOfDay(for: self)))!
     }

     func endOfMonth() -> Date {
     return Calendar.current.date(byAdding: DateComponents(month: 1, day: -1), to: self.startOfMonth())!
     }*/

    func startOfMonth() -> Date {

        let calendar = Calendar.current
        let currentDateComponents = calendar.dateComponents([.year, .month], from: self)
        let startOfMonth = calendar.date(from: currentDateComponents)

        return startOfMonth!
    }

    func dateByAddingMonths(_ monthsToAdd: Int) -> Date? {

        let calendar = Calendar.current
        var months = DateComponents()
        months.month = monthsToAdd

        return calendar.date(byAdding: months, to: self)
    }

    func endOfMonth() -> Date {

        let plusOneMonthDate = dateByAddingMonths(1)

        let calendar = Calendar.current
        let plusOneMonthDateComponents = calendar.dateComponents([.year, .month], from: plusOneMonthDate!)
        let endOfMonth = calendar.date(from: plusOneMonthDateComponents)?.addingTimeInterval(-1)

        return endOfMonth!

    }

    func dayOfTheWeek() -> String? {
        let weekdays = [
            "Sunday",
            "Monday",
            "Tuesday",
            "Wednesday",
            "Thursday",
            "Friday",
            "Saturday"
        ]

        let calendar = Calendar.current
        let components = calendar.dateComponents([.weekday], from: self)
        return weekdays[components.weekday! - 1]
    }

    func getJsonLogTime() -> String {
        let formatter = DateFormatter()
        formatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
        return formatter.string(from: self)
    }

}

extension String {
    func fileName() -> String {
        return URL(fileURLWithPath: self).deletingPathExtension().lastPathComponent
    }

    func fileExtension() -> String {
        return URL(fileURLWithPath: self).pathExtension
    }
}

public class Reachability {

    class func isConnectedToNetwork() -> Bool {

        var zeroAddress = sockaddr_in(sin_len: 0, sin_family: 0, sin_port: 0, sin_addr: in_addr(s_addr: 0), sin_zero: (0, 0, 0, 0, 0, 0, 0, 0))
        zeroAddress.sin_len = UInt8(MemoryLayout.size(ofValue: zeroAddress))
        zeroAddress.sin_family = sa_family_t(AF_INET)

        let defaultRouteReachability = withUnsafePointer(to: &zeroAddress) {
            $0.withMemoryRebound(to: sockaddr.self, capacity: 1) {zeroSockAddress in
                SCNetworkReachabilityCreateWithAddress(nil, zeroSockAddress)
            }
        }

        var flags: SCNetworkReachabilityFlags = SCNetworkReachabilityFlags(rawValue: 0)
        if SCNetworkReachabilityGetFlags(defaultRouteReachability!, &flags) == false {
            return false
        }

        /* Only Working for WIFI
         let isReachable = flags == .reachable
         let needsConnection = flags == .connectionRequired

         return isReachable && !needsConnection
         */

        // Working for Cellular and WIFI
        let isReachable = (flags.rawValue & UInt32(kSCNetworkFlagsReachable)) != 0
        let needsConnection = (flags.rawValue & UInt32(kSCNetworkFlagsConnectionRequired)) != 0
        let ret = (isReachable && !needsConnection)

        return ret

    }
}

extension Character {
    var isAscii: Bool {
        return unicodeScalars.allSatisfy { $0.isASCII }
    }
    var ascii: UInt32? {
        return isAscii ? unicodeScalars.first?.value : nil
    }
}

extension String {

    var length: Int {
        return count
    }

    subscript (i: Int) -> String {
        return self[i ..< i + 1]
    }

    func substring(fromIndex: Int) -> String {
        return self[min(fromIndex, length) ..< length]
    }

    func substring(toIndex: Int) -> String {
        return self[0 ..< max(0, toIndex)]
    }

    subscript (r: Range<Int>) -> String {
        let range = Range(uncheckedBounds: (lower: max(0, min(length, r.lowerBound)),
                                            upper: min(length, max(0, r.upperBound))))
        let start = index(startIndex, offsetBy: range.lowerBound)
        let end = index(start, offsetBy: range.upperBound - range.lowerBound)
        return String(self[start ..< end])
    }

    var bool: Bool? {
        switch self.lowercased() {
        case "true", "t", "yes", "y", "1":
            return true
        case "false", "f", "no", "n", "0":
            return false
        default:
            return nil
        }
    }
}

extension String
{
    func trim() -> String
    {
        return self.trimmingCharacters(in: NSCharacterSet.whitespaces)
    }
}

// Sagar Added for RE Farmer

protocol Cryptable {
    func encrypt(_ string: String) throws -> Data
    func decrypt(_ data: Data) throws -> String
}

struct AES2 {
    private let key: Data
    private let ivSize: Int         = kCCBlockSizeAES128
    private let options: CCOptions  = CCOptions(kCCOptionPKCS7Padding)

    init(keyString: String) throws {
        //        guard keyString.count == kCCKeySizeAES256 else {
        //            throw Error.invalidKeySize
        //        }
        self.key = Data(keyString.utf8)
    }
}

extension AES2 {
    enum Error: Swift.Error {
        case invalidKeySize
        case generateRandomIVFailed
        case encryptionFailed
        case decryptionFailed
        case dataToStringFailed
    }
}

private extension AES2 {
    func generateRandomIV(for data: inout Data) throws {
        try data.withUnsafeMutableBytes { dataBytes in
            guard let dataBytesBaseAddress = dataBytes.baseAddress else {
                throw Error.generateRandomIVFailed
            }

            let status: Int32 = SecRandomCopyBytes(
                kSecRandomDefault,
                kCCBlockSizeAES128,
                dataBytesBaseAddress
            )

            guard status == 0 else {
                throw Error.generateRandomIVFailed
            }
        }
    }
}

extension AES2: Cryptable {
    func encrypt(_ string: String) throws -> Data {
        let dataToEncrypt = Data(string.utf8)

        let bufferSize: Int = ivSize + dataToEncrypt.count + kCCBlockSizeAES128
        var buffer = Data(count: bufferSize)
        try generateRandomIV(for: &buffer)

        var numberBytesEncrypted: Int = 0

        do {
            try key.withUnsafeBytes { keyBytes in
                try dataToEncrypt.withUnsafeBytes { dataToEncryptBytes in
                    try buffer.withUnsafeMutableBytes { bufferBytes in

                        guard let keyBytesBaseAddress = keyBytes.baseAddress,
                            let dataToEncryptBytesBaseAddress = dataToEncryptBytes.baseAddress,
                            let bufferBytesBaseAddress = bufferBytes.baseAddress else {
                                throw Error.encryptionFailed
                        }

                        let cryptStatus: CCCryptorStatus = CCCrypt( // Stateless, one-shot encrypt operation
                            CCOperation(kCCEncrypt),                // op: CCOperation
                            CCAlgorithm(kCCAlgorithmAES),           // alg: CCAlgorithm
                            options,                                // options: CCOptions
                            keyBytesBaseAddress,                    // key: the "password"
                            key.count,                              // keyLength: the "password" size
                            bufferBytesBaseAddress,                 // iv: Initialization Vector
                            dataToEncryptBytesBaseAddress,          // dataIn: Data to encrypt bytes
                            dataToEncryptBytes.count,               // dataInLength: Data to encrypt size
                            bufferBytesBaseAddress + ivSize,        // dataOut: encrypted Data buffer
                            bufferSize,                             // dataOutAvailable: encrypted Data buffer size
                            &numberBytesEncrypted                   // dataOutMoved: the number of bytes written
                        )

                        guard cryptStatus == CCCryptorStatus(kCCSuccess) else {
                            throw Error.encryptionFailed
                        }
                    }
                }
            }

        } catch {
            throw Error.encryptionFailed
        }

        let encryptedData: Data = buffer[..<(numberBytesEncrypted + ivSize)]
        return encryptedData
    }

    func decrypt(_ data: Data) throws -> String {
        let bufferSize: Int = data.count - ivSize
        var buffer = Data(count: bufferSize)

        var numberBytesDecrypted: Int = 0

        do {
            try key.withUnsafeBytes { keyBytes in
                try data.withUnsafeBytes { dataToDecryptBytes in
                    try buffer.withUnsafeMutableBytes { bufferBytes in

                        guard let keyBytesBaseAddress = keyBytes.baseAddress,
                            let dataToDecryptBytesBaseAddress = dataToDecryptBytes.baseAddress,
                            let bufferBytesBaseAddress = bufferBytes.baseAddress else {
                                throw Error.encryptionFailed
                        }

                        let cryptStatus: CCCryptorStatus = CCCrypt( // Stateless, one-shot encrypt operation
                            CCOperation(kCCDecrypt),                // op: CCOperation
                            CCAlgorithm(kCCAlgorithmAES128),        // alg: CCAlgorithm
                            options,                                // options: CCOptions
                            keyBytesBaseAddress,                    // key: the "password"
                            key.count,                              // keyLength: the "password" size
                            dataToDecryptBytesBaseAddress,          // iv: Initialization Vector
                            dataToDecryptBytesBaseAddress + ivSize, // dataIn: Data to decrypt bytes
                            bufferSize,                             // dataInLength: Data to decrypt size
                            bufferBytesBaseAddress,                 // dataOut: decrypted Data buffer
                            bufferSize,                             // dataOutAvailable: decrypted Data buffer size
                            &numberBytesDecrypted                   // dataOutMoved: the number of bytes written
                        )

                        guard cryptStatus == CCCryptorStatus(kCCSuccess) else {
                            throw Error.decryptionFailed
                        }
                    }
                }
            }
        } catch {
            throw Error.encryptionFailed
        }

        let decryptedData: Data = buffer[..<numberBytesDecrypted]

        guard let decryptedString = String(data: decryptedData, encoding: .utf8) else {
            throw Error.dataToStringFailed
        }

        return decryptedString
    }

}
// Sagar Added for RE Farmer Finish
